///////////////////////////////////////////////////////////////////////////////////
// Ver.19.x系
///////////////////////////////////////////////////////////////////////////////////

Ver.19.3.0.0
●リストの描画の調整
・リストビューの全てのコンポーネントのレイアウト/サイズを数ピクセル程度して調整が多数
　リスト幅を左右1ピクセル小さく、アドレスバー4ピクセル大きく右に2ピクセル移動、右のボタンの間を2ピクセル詰めたなど計37項目
・フォーカス線を点線/システムカラー固定（通常は黒）から、実線かつ背景の反転色を使うようにして視認性を向上
　目立つが煩わしい感もあるので評判が悪ければ設定化も検討
・画面分割時にフォーカスがあるビューの背景をタブの枠線の色で塗って目立たせるようにした
・詳細モードで、フォーカスの下枠が、行の下枠と重なって見にくいのを是正
・サイズを表すバーの高さを半分にして重ね描きしているテキストを読みやすくなるように変更

●画面分割モードでなくても、挙動の切り替えができるように変更
・上下階層の同期移動
・分割したウィンドウの内容の比較
・フォーカスの同期移動

●その他
・拡張コピーコマンド(FileCpMv.exe)にて「動作モード」を「個別判定」にした場合、進捗ダイアログをタスクバー表示の対象になるようにして、タスクの死活判断が行えるように修正
・ソースの依存関係を少し下げたので、次の全ビルドで若干サイズが減るコマンドが発生する見込み
※ライブラリの肥大化ペースに負ける可能性大




Ver.19.2.2.0
●プレビューの強化と整理2
・画像として優先取得する拡張子の設定を削除して毎回処理を試みるように変更
・コンポーネント操作の優先順位を調整
・コンポーネントがない場合にWindows内蔵のPDF/メディアプレーヤ/RTFプレビューハンドラを優先使用するように変更

●操作の改善
・ドラッグ中にツールチップを消す処理を改善
・組み込みマウスカーソルの視認性を向上
※ドラッグ中のマウスカーソルが潰れる環境への配慮
　白に少し色を入れ文字太くしたので、かなりうるさいくらいに目立つ
　エクスプローラーやデスクトップのマウスカーソルも潰れるのでWindowsの問題の気がする

●その他
・FileCpMvの64ビット専用の解凍機能を追加したが、性能が高いだけで機能性と操作性が悪いので保留




Ver.19.2.0.0
●プレビューの強化と整理
※OSのプレビューはSJISやUNICODEのテキストが閲覧できない＋表示が遅すぎるのでテコ入れ
・シェル画像展開の「全ての画像情報の取得を試みる(遅い)」を削除
・内蔵テキストビューアの拡張子判定の設定を追加
・プレビューの優先順位を変更
　プラグイン→プレビューハンドラ→画像→テキスト（最終手段）
　→プラグイン→画像→テキスト→プレビューハンドラ→テキスト（最終手段）
・おそらくWindows11 25H2からと思われる解放漏れに対処

●貼り付けコマンドの強化
※種類はいくらでも増やせるけど要望があれば、にしておく
・クリップボードの内容がテキストで、ファイル化する際の文字コードの設定を追加
　SJIS/UNICODE/UTF8/UTF8(BOM)
・クリップボードの内容が画像で、ファイル化する際の画像フォーマットの設定を追加
　PNG/BMP/JPG

●不具合修正
・LoadSettingスクリプトが機能していなかった不具合の修正

●その他
・コード分析対応×8
・FileCpMv.exeの機能追加のための分岐をちょこちょこと作成
・ツールチップに画像やテキストを表示する、ダイアログベースの機能を有効にする隠し設定の追加
　以下の設定をすると、オプション→リスト→ツールチップ、という画面が増える
　ヘルプを参照するには、この画面でF1を押下すること
※人を選ぶ機能であり、表示制御のチューニングも途中でやめてるので操作性に難ありです。
　たまに使いたくなるので情報公開するものです。
[HKEY_CURRENT_USER\Software\AMA_Soft\ASR\Main001\AppInfo]
"TestTooltip"=dword:00000001




Ver.19.1.2.0
●マウスドラッグの改善
・ドラッグ中にツールチップの表示を抑制して操作性の改善
・ドラッグヘルパーで「簡易表示」モード(先頭アイコンのみ参照、透過あり、上じゃなくて右にずらす)の追加
※OS標準のドラッグヘルパーだとドロップ先が画像に重なって見えないため
・ドラッグヘルパーの設定を有無から３択に変更




Ver.19.1.1.0
●Windows 26H1対応の追加と関連exeの更新
※Windows12と誤認してOSバグの回避処理が無効になっていた
●シェル実行時に代替データストリームを含むファイルかを確認し、問い合わせ/無条件削除/無視の設定と挙動を実装
※設定の初期値は暫定、評判が悪いようなら変更する想定
●その他
・リストのオブジェクト破棄時の安定性の向上×3
・リスト生成の走査時のフェッチ数の調整の仕組みを追加(OS側が未実装なので、ほぼ効果なし)
・静的コード分析対応(27個)




Ver.19.0.8.0
●プレビュープラグイン
・需要減につきAdobeReader.dllの配布を終了(ソースは公開済み)
・InternetExplore.dll/MediaPlayer.dllが静的リンクになっていなかったのを修正
●タブバーの枠線の描画
　横一列に配置した場合の見た目の改善（同一パス、下位階層表現よりも優先的に描画するように変更）
●エクスプローラ風チェックボックス
　チェックボックスを左クリックした場合の選択判定が逆転する現象に対処
●クリップボードのテキストデータを読み込む際に、読み取り可能なクリップボードフォーマットを増やした
※「クリップボードのテキストから開く」等であり、「貼り付け」や「カスタムペースト」は対象に含まない




Ver.19.0.6.0
●「ファイルの文字コードを一覧に表示」コマンドを追加(ID:33299)
※リスト上に表示されているファイルの文字コードを一時的に一覧表示するもの
　メニュー定義、説明リソース、バーカスタマイズ等に追加
・走査結果をリストに表示する系のコマンドの説明文を修正
・検証の実験台としてAsr.exeのソースコードをUTF8に統一(3MBもサイズ減)
●ソース管理
・全ビルドリリース用のスクリプトの修漏れをたくさん修正
●ファイル名のコピーコマンド
※次期の設定インポート/エクスポート用の準備で、マクロ定義設定の後方互換が無くなりました
・マクロ定義文字列の保存の際に改行コードを文字に変換すように仕様変更
・未初期化の変数警告対応が多数
●セキュリティ強化（次版以降の準備）
・フォルダ設定のState Stringの文法チェックを厳しくした
●不具合修正
・一行表示がONの詳細の先頭カラムだけ1ピクセル大きいのを修正
・32ビット版のみ、遷移時の選択状態保持で桁あふれの可能性があるのを修正（悪用不可）




Ver.19.0.4.0
●不具合修正
・数値の文字列化のカンマを入れる処理の誤り修正
・説明文の助詞の抜けを修正×2




Ver.19.0.3.0
・Migemoのライブラリ読み込みエラーメッセージパターンを2→12種に増加
※dll破損も検知できるようになった
・コード分析対応が47件
・Windowsのバグ報告用の実証コードを削除
・数値の文字列化のカンマを入れる処理で1000未満を分岐して高速化、ループ脱出用Goto排除
・インクリメンタルサーチで次の候補を探す際のループ脱出用Goto排除
●不具合修正
・メニュー定義の誤記修正




Ver.19.0.2.0
・タブ/ウィンドウ管理バー上で、ホイールを無視する設定の追加
●不具合修正
・仮想フォルダから上位の実体を持つフォルダーへ遷移する場合、ITEMIDLISTが取得できなければ自身を更新対象とするように変更
・デスクトップで上位移動コマンドが発行されたら無視するように変更




Ver.19.0.1.0
●全てのexeやDLLを静的リンクにしてランタイム不要に変更
●配布書庫の32ビット版/64ビット版を分離
※Microsoft社の32ビットOSのサポート終了に合わせて、32ビット版の配布を終了する予定です
・配布書庫のレイアウトを抜本的に変更
・InstAsr.exe、Setting.exeの64ビット版を新規作成




Ver.18.9.5.0
●不具合修正
・オプション内の説明文字列を結合する際の誤字修正
・32ビット版で選択状態保持のunordered_mapの桁あふれ抑止のキャストを追加
※桁あふれは発生しませんが追跡困難なビルド警告が出るため
●ソリューション構成の不整合の修正
・FreeMemがデバッグ実行不可になっていたのを修正
・ShellCmdの32ビット版の自動ビルドが通らなくなっていたのを修正




Ver.18.9.4.0
●タブセット管理の強化
・タブセットの管理ディレクトリを開くコマンドの追加(ID:33885)
・全てのタブセットを圧縮してバックアップコマンドの追加(ID:33884)
・以下のメニュー定義とドッキングバーへの配置リソースに「タブセットの管理ディレクトリを開く」と「全てのタブセットを圧縮してバックアップ」を追加
_StatusTabSetMenu.txt
_MainFullCmd.txt
_MainCustCmd7A.txt
_MainNormalCmd7A.txt
_TabMenuSetting.txt
_TabMngBarTabset.txt

●その他
・画像リソースの整理と命名ルールが雑だったのを修正
・migemoを使う設定になっている場合、コマンド検索でローマ字検索する機能を追加
　機能があることに気づいてもらえないと思うので画面にヒントも追記

●不具合修正
・他のタブへ圧縮コマンドの定義ファイルを修正(ExternalDefCommand.txt)
・サーチ系処理でリストのフォーカスを動かす場合に、フォーカスが迷子になる組み合わせがある不具合の修正
・ライブラリ不整合で挙動がおかしかったSetting.exeをリビルドした
・上下階層の移動の安定性を向上(24H2の仕様変更？)




Ver.18.9.2.0
●32ビット版廃止に向けた準備
・Arc.exeの内容をArcPack.exeに統合した
・32ビット版のみだったBindFile._xeの64ビット版を追加

●不具合修正
・自動更新検出時にソートする設定で、更新によりフォーカス移動させられる場合にフォーカスが迷子になる不具合の修正
・ユーザー定義バーの「テキスト幅設定」とオプション画面での許容範囲が異なる不具合の修正
・ユーザー定義バーのテキスト幅にアイコン幅を含んでいた計算式を修正

●Windows 11 24H2不具合対応
・特定の手順によるデスクトップ上のアイテムへの操作により、COM内部で多重開放を引き起こして落ちる現象の緩和措置が多数
※参照カウンタの管理がおかしい、悪用可能なのでMS社が放置するとは思えないため暫定措置
・OSバグの影響で増殖しがちなOneDriveは非表示に変更

●その他
・Direct2Dライブラリをリンクに追加
・ビルド番号27547以上はWindows12とみなして、起動時にサポート対象外のメッセージを表示するように変更
　番号の根拠は薄いが、正常動作が期待できないレベルで挙動が変わっているため制限した
・ユーザー定義バーのソート比較関数を調整し、安定ソートになる確率を向上して高速化
・ユーザー定義バーの検索絞り込み速度を大幅に向上
　（元から速かったので、速度が1桁変わっても誰も気づかないアレです）
・COPY_DATA系のイベントIDのラベル化漏れを修正




Ver.18.8.8.0
●24H2不具合対応
・特定の仮想フォルダの親のITEMIDLISTがNULLで返ってきて再描画が止まる現象への対処
※何が親か分かんないのでデスクトップに遷移

●オプション→全体→マウスカーソルの設定画面を追加
　1.「ドラッグヘルパーを表示する」を移動
　2.OS標準のマウスカーソルと組み込みカーソルの選択

●その他
・オプションで使用禁止想定のIDをうっかり使用していたのを修正
・安定性検証用のスタックトレースを山盛り埋め込んだ
　α版モード専用、4桁仕掛けたが1/4も行ってない




Ver.18.8.7.0
●ドラッグ中の動作改善
・リンク作成カーソルを調整
・カーソルリソースを再利用して計算量の削減

●インストール関係
・インストール時のランタイムテストコマンドに、インストールの有無とランタイムのバージョン番号の表示を追加
・Setting.exeの誤記修正

●バージョン情報
・VCランタイムの情報を追加




Ver.18.8.6.0
●不具合修正
・ネットワークのログインダイアログやディスク挿入を促すメッセージが表示できなくなっていた不具合の修正
・GDIスケーリングモードで伸縮が発生している環境で、MDIモードかつ、キーボードかマウスホイールのタブ切り替えでウィンドウ管理バーの塗り残しへの対処(Windows11 24H2のみ)
・SHParseDisplayName()のリファレンスと異なる挙動を拾って落ちる現象に対処
※まれにエラーを返しているのに、ITEMIDLISTをセットしてくることがある
・ユーザーディレクトリが仮想フォルダとして扱われる不具合を修正
・publicのデスクトップにある項目の操作に失敗する操作手順がある不具合の修正

●その他
・D&Dの開始時にリストのツールチップを消すように変更
・選択コマンド系のリドロー指定の不整合を是正

●32ビット版の書庫コマンドの統合
・ArcUnPack.exeを廃止してArcPack.exeにまとめた

●非推奨API修正の適用
・Associate.exe
・Setting.exe
・Unreg.exe
・FileNewEx.exe

●MFCへ依存しないように変更
・FreeMem.exe
・ShellCmd.exe




Ver.18.8.3.0
●リストからのドラッグ開始の改善
・ドラッグヘルパーの自前処理をすべて破棄してAPIに丸投げに変更
・Windows11の組み込みマウスカーソルが小さすぎると不評だったので自前のものに置き換えた
※美的感覚が大惨事、32x32 256色でドラッグ中のマウスカーソルを提供してくれる方を募集

●タブバー/ウィンドウ管理バーからのドラッグの改善
・MAX_PATHを超えるパスをドラッグできるようにした

●不具合修正
・フォーカスが2個になる操作の組み合わせがある不具合を修正
・リストの選択解除の条件が不適切になるパターンがある不具合を修正
・フルパス取得で呼び出しているAPIがスレッドセーフになっておらず、酷い負荷をかけると不安定になる不具合を修正
・サムネイルモード時のドラッグヘルパー画像が意図しないものになっていた不具合の修正

●非推奨APIの廃止
・SHMapPIDLToSystemImageListIndex()の使用をやめた(試行ルートの一つ、単純に削除)
・SHGetSpecialFolderPath()を代替関数に置換
・SHGetSpecialFolderLocation()を代替関数に置換
・SHCreateDirectory()を自前処理に置換(本体だけ)
・ILCreateFromPath()の大部分を代替関数に置換
※実体を持たない仮想フォルダの上下階層への移動の際に、現行とは異なるパスに移動する可能性あり
　例えばDownloadの親はデスクトップ(Windows11)だったり、PC(Windows10)なのを自前で補正しているため

●その他
・最悪のケースのシェルアイコンの取得を現在のリファレンスに合わせた
・キャッシュ周りで落ちていた件の検証トラップをたくさん追加
・フィルタ判定で冗長な関数呼び出しのオーバーヘッドを削減
・フォルダ設定で冗長な関数呼び出しのオーバーヘッドを削減し、コードの属性を整理

●無応答になるAPIのタイムアウト処理の試作
・GetDiskFreeSpaceEx()を1秒でタイムアウトする関数にした
※具体的にはステータスエリアの「ネットワークでもディスク容量を取得する」だが、ネットワーク先が突然死の場合にタイムアウトしないので気休め




Ver.18.7.3.0
●環境依存によるキャッシュ関連の不具合修正
・ImaggeListの描画関連のNULLチェックと代替処理を追加
・メモリが少なめでキャッシュアウトが発生しやすい環境へ配慮を追加

●その他不具合修正
・仮想パスの走査で、上から行けるところまで行く探索をする場合にメモリリークするルートがある不具合の修正
・2か所でILFree()とCoTaskMemFree()を混同していた不具合を修正
・リストの初期化の際にアイコン画像のアタッチを2回やっていたのを1個削除
・初期化の際の再描画フラグをOFFにして描画スレッドと衝突しないように修正

●その他
・非推奨になったSHGetMalloc()をすべて削除
　またIMallocを使用していたメモリ開放をCoTaskMemFree()に置き換えた
・非推奨関数SHILCreateFromPath()、SHSimpleIDListFromPath()がリトライ処理に残っていたのを削除
・アイコン画像描画に例外トラップを追加
・アイコン描画とオーバーレイアイコン描画を分離
・ILCreateFromPath()を呼んでいる最中に、別プロセスにより当該ファイル等が消された場合に落ちる問題への対処
※ILCreateFromPath()の全廃に向けた暫定対処




Ver.18.6.8.0
●配布書庫の変更
・ディレクトリ4個削減
・初期設置/更新時の判定処理数を削減

●不具合修正
　リストへイメージリストをアタッチする際の判定の強化
・サムネイル画像の破棄の条件式を修正
・イメージリスト破棄の前にリストから切り離すように変更
　処理中に別スレッドでの描画に追い越された場合に不安定になる可能性を潰した
・メモリが枯渇などで空のイメージリストの生成に失敗する場合の対処を追加

●その他
・前回変更した見た目に合わせて「一覧」のマウスの当たり判定位置を調整
・数年前から発生していた一覧/詳細一覧で、フォーカス移動する際にリストの起点が狂うOSのバグの対策を削除
※上下階層の移動時のフォーカス移動が見えないくらい速くなりますが、環境依存の可能性が高いので暫定
・サムネイルでのテキスト表示の画質を大きく改善(ただし画像１枚当たりの消費メモリ増)
・リスト項目数を数える処理の計算量を削減

●FileCpMvの変更（圧縮/解凍機能を盛り込むための枠組み）
・共通ライブラリの組み込みとソースツリーの構成を整理
・冗長なコマンドライン解析処理をリファクタリング
・画面リソースと制御クラスを追加




Ver.18.6.6.0
●コンパクトビューコマンドの追加(ID:32950)
※詳細系/リスト系のリスト行間を広げる
　デフォルトはWindows11に倣ってOFF
・シェルアイコン画像をリストにセットするのをやめた
・アイコン画像の自前に置き換えた
・表示モード設定系のメニュー追加
　(_MainCustCmd3V.txt、_MainFullCmd.txt、_MainNormalCmd3V.txt、_ViewMode.txt)
・当該コマンドをツールバー等へ配置を可にした

●リスト描画の改善と仕様変更
　a.一覧
　・テキスト描画座標を当たり判定に合わせるように変更
　※画像が大きくなると見た目が悪くなるが、分かりやすさ優先
　・テキスト幅の設定が0ではなく、高さがあれば折り返すように変更（ただしテキストが上寄せ）
　・タグの位置の調整
　b.詳細
　・格子座標の微調整
　c.並べて表示
　・テキスト幅が0かつ2/3行目が非表示の場合、不要なはずの折り返しが発生しやすいのを調整
　・テキスト幅が0の場合は、グラフ幅が不定なのでサイズグラフを表示しないように変更

●タグの描画
・テキスト背景を透過するように変更




Ver.18.6.4.0
●格子色指定の拡張
・ツールバーに配置機能を追加
・動的生成するソートメニューへ追加（リスト下部ボタン、ツールバーボタン）

●不具合修正
・オプションのキー割り当ての一覧に「最近閉じたフォルダーへフォーカスを移動する」(ID:35703)が存在しない不具合の修正
・バージョン情報にて「最新版の情報を取得」の押下後にフォーカスが迷子になる不具合の修正
　適切なものが無いので「更新情報」にフォーカスをセット
・メインメニュー系のコマンドはAltでの連続再表示を抑止するため、再表示まで300ms待つように調整

●その他
・OSを信じない系のnullチェックを強化(今後、少しずつ適用)
・コード分析の誤検出の200件くらい抑制
・Visual studioの更新による新しいコードスタイルを適用
・Migemo辞書の読み取りの冗長性の解消

●64ビット版の書庫操作(プロトタイプ)
・組み込み処理からカプセル化したクラスに移設
a.解凍(ID:35199)
・パスワード入力を専用ダイアログで作り直した
b.圧縮(ID:35200)
・出力先パスのみ指定でとりあえず作ってみた
※書庫名などの指定が不可なので実用性は低いです




Ver.18.6.2.0
●メインメニューの非表示時の強化
・タイトルバーの右クリックメニューはメインメニューに変更

●高DPI対応の強化
・スケーリングモードの切り替えで失敗してもエラーメッセージを出さないように変更
・スケーリング指定のAPIが使えない環境を検出した場合に適用値を自動調整する機能を追加
 ※GDIスケーリング→システム→制御なしと順に試して切り替える
・バージョン情報とステータスバーのDPI情報に、設定値と適用した値を表示するように変更

●格子色の活用方法を広げた
・格子色を無効(ID:33324)を追加
・行ごとに格子表示(ID:33325)を追加（既存仕様）
・並び順により格子でグループ(ID:33326)を追加
・メニュー定義更新(_MainCustCmd3V.txt/_MainFullCmd.txt/_MainNormalCmd3V.txt)




Ver.18.6.0.0
●バージョン情報
・画面の構成を調整
・「サポート必須情報」の表示を追加して必要性を強くアピールするようにした

●高DPI対応の強化
・オプションに互換性ページを用意して、DPI設定を追加
　なし/システム/GDIスケーリングを選択できるようにした
・上記の設定を各種外部コマンドにも反映するようにした（例外はヘルプ参照）
・高DPI環境でツールバー画像の新規作成/編集を試みた場合に、メッセージを出して中断するように横取りした
　また画像破損しなくなったので、ユーザーツールバー画像の自動修復機能を削除
・「システム」で高DPI環境にてドッキングバーのレイアウト不正によりアプリ起動に失敗する場合の自己修復する仕組みを追加
・「システム」で補正値に矛盾が生じた場合に自己修復する仕組みを追加

●プロトタイプ
・ソート種別ごとの格子塗り機能の追加
　名前順系だと先頭１文字、拡張子系だと拡張子の先頭１文字、日付やサイズ系だと日付やサイズの単位ごと等




Ver.18.5.2.0
●不具合修正
・マウスジェスチャの軌跡を描画する際、MSLLHOOKSTRUCTのマウス座標がディスプレイ依存で信用できないのでマウスカーソル座標を求めるAPIを変更
・スクリプトのSelectDialogで引数が足らない場合にエラーメッセージを出さない不具合の修正




Ver.18.5.1.0
●高DPI環境対応
・ほとんどのexeをGDIスケーリング対応に変更
※位置調整、描画の補完範囲が大きく既存と大きく異なります
　概ねDPI比が異なるモニタ間の移動が可能で、既知の課題であったサムネイル画像の最大サイズやMFC由来の致命的な欠陥は解消するも特定操作で描画の崩れ等が発生します。
・全てのexeでWindows 10/11の判別およびビルド番号の取得が可能な仕組みに変更
・タブ、ウインドウ管理バーのドライブレター画像の生成をGDIスケーリング用に変更、また生成速度の向上
・ウィンドウ管理バーのみ高DPI環境にて、ラベル描画が更新されない場合があるので再描画通知を調整
・カーソル移動でゴミが残るので、ユーザー定義バーのフォーカス描画のサイズを調整

※GDIスケーリングの対象外
・Version.exe
・Seeker.exe

●コンテンツモードの描画改善
・仮想フォルダーの場合、右側の表示を右寄せではなく画面1/3の位置からの描画に変更(縦が崩れて見苦しいため)
・ごみ箱の表示項目の位置構成を変更（元の場所を２段目、OS依存の意義の怪しい表示を削除）

●その他
・PCのカラム取得にて、シェル拡張ツールによる不用意な項目増減への安全装置を追加
・ネットワーク設定のPINGのタイムアウトの初期値を500ms→50msに変更
・サムネイル画像生成で、フォルダ判定にSFGAO_FOLDERも使う用に変更
　(ごみ箱内のディレクトリ等、ディレクトリ属性を持たないフォルダー対策)
・プロセス管理系の基本処理を実装
・コード分析対応が多数
・Setting.exeで「各種バーのレイアウト情報を削除する」を押下時にAsr.exeが起動されていたら終了を促すメッセージを追加




Ver.18.4.3.0
●スクリプトコマンド追加(プロトタイプのまま昇格)
・指定フォルダー以下のファイルを選択するメニューの表示(MenuOfFile)
・指定フォルダー以下のフォルダーを選択するメニューの表示(MenuOfDirectory)

●コマンド追加(プロトタイプをリメイク)
・ファイルのサムネイルイメージを保存(ID:35204)
・詳細カラムも含めてクリップボードにコピー(ID:35660)

●画面分割時の選択系のコマンドを追加
※数が多いのでツールバーボタンのみ追加
・分割画面を比較して現在のリストの方が古いアイテムを選択(ID:35670)
・分割画面を比較して反対のリストの方が古いアイテムを選択(ID:35671)
・分割画面を比較して現在のリストの方が新しいアイテムを選択(ID:35672)
・分割画面を比較して反対のリストの方が新しいアイテムを選択(ID:35673)
・分割画面を比較して現在のリストの方が大きいファイルを選択(ID:35674)
・分割画面を比較して反対のリストの方が大きいファイルを選択(ID:35675)
・分割画面を比較して現在のリストの方が小さいファイルを選択(ID:35676)
・分割画面を比較して反対のリストの方が小さいファイルを選択(ID:35677)
・分割画面を比較して反対のリストに存在しないアイテムを選択(ID:35678)
・分割画面を比較して現在のリストに存在しないアイテムを選択(ID:35679)
・分割画面を比較して反対のリストに存在するアイテムを選択(ID:35680)
・分割画面を比較して現在のリストに存在するアイテムを選択(ID:35681)

●コンテンツモードの描画改善
・右寄せレイアウトは見にくいので見直す準備と仕掛けを作成
・描画可能な行数の計算式を修正して重ならないようにした
・不要なローカル変数を削除

●コマンド名の名称変更の修正漏れ修正
・_ToolbarTag.txtを修正

●不具合修正
・選択解除のダミー選択状態をセットする場合にフォーカスが存在しないと落ちる不具合の修正
※新規実装で見つかった既存バグだが、問題が発生するかは未確認
・スクリーンセーバー設定の組み合わせでユーザー情報管理ディレクトリに画像をコピーしない場合があるのを修正
・フォルダーのサムネイル画像の背景色が不適切な不具合の修正
・ソート用のメニュー構築に失敗した場合にインデックス不正にならない仕組みに変更、また未取得のルートがあったのを修正
・ごみ箱の下位階層ディレクトリに潜れないように変更
　開いていると更新通知が止まらない危ないディレクトリであるため(OSバグ？)
・仮想ディレクトリからシェル実行する際に一覧をロックしていなかった不具合の修正(仕組み上、実害なし)




Ver.18.3.7.0
●外部の監視ソリューションとの親和性の向上関連
・メモ帳のパス指定を修正
・ExternalDefCommand.txtのメンテナンス
　廃止コマンドの削除×2、パス表記の互換性向上など

●フォルダーバー/インサイドツリー
・アイコン画像の拡大表示の設定を追加
※作者の老眼対策なので初期値をONにしていますが不評なら変更します

●タブ/ウィンドウ管理バーのラベル名に、フォルダー名/絶対パス指定のタグを切り替える機能・設定の追加
・タブ/ウィンドウ管理の設定に「ラベルにはタグを表示」を追加
・タブ/ウィンドウのコンテキストメニューやコマンドメニューに「タグを編集」を追加
・タブ共通のオプションに設定項目を追加

●その他
・メニュー定義の「タグを追加」は編集や削除も可能なので「タグの追加・編集」に改名
・コード分析対応×16個
・ユーザー定義バーの設定の「カラム幅調整」を「テキスト幅設定」に変更、ダイアログメッセージも日本語に変更

●不具合修正
・アドレスバーの背景色を#000000にすると、初回の色塗りがスキップされる不具合の修正
・ユーザー定義バーのテキスト幅設定でメモリリークしていた不具合の修正
・フォーカスを太字などで目立つようにし、一覧かつ、アイコン小の組み合わせで表示が崩れる不具合の修正
・ユーザーディレクトリの特別扱いをやめる対応で、Windows10以下だと不適切になるルートがあったので再修正




Ver.18.3.1.0
●Windows 11 24H2の仕様変更対応
・INameSpaceTreeControlEvents::OnAfterContextMenu()の仕様変更に伴い予期せぬNULL値を受信して落ちる問題の対処
・調査で使用したINameSpaceTreeControlの内部で発生した例外をトラップする仕組みは残した
※メッセージ内容はコンポーネント内部で異常が発生したことを知らせるに留めるように変更

●カスタマイズ可能な画像ファイルの参照先をインストール先からユーザー情報の管理ディレクトリへ変更
※移行措置としてユーザー情報管理ディレクトリに存在しなければインストール先からコピーします
　Ver.19にて初期設定/更新時に配布ファイルを上書きするように変更する予定です
・スキン画像(img)
・ステータスバーアニメーション(StatusImg)
・スクリーンセーバー(StatusAnime)

●サムネイル画像の描画の速度と画質の向上
・中間フォーマットとしてアイコン変換をやめてビットマップまま、リストに積む/差し替えるように変更
※ファイルによって背景が透過しないケースが増えることが予想されますが、教えてくれると対応できる場合があります
・大判属性を持つサムネイル画像の縮小処理を作り直して若干画質が向上した（PowerToysでシェル拡張したSVGのサムネイル画像などが顕著）
・lnkファイルのサムネイルイメージは読み飛ばしてアイコンとして処理するように変更
※リンク先によってかなりの性能低下があったため
・icoファイルのサムネイルイメージは読み飛ばしてアイコンとして処理するように変更
※icoは背景透過処理のため画像扱い不可

●高DPI環境の改善
・GDIスケーリングを有効にして起動した場合の改善
　a.サムネイルの表示欠けを修正（前述のアイコン変換をやめた理由）
　b.ウィンドウ管理バーへの左クリックで描画が崩れないように修正

●タブ共通の設定追加
・グループの最後のタブになったら自動的にグループを解散する、を追加

●ツリーの設定切替動作の改善
・「隠しアイテムの表示」を切り替えた際に、表示されている全てのツリーを対象とするか問い合わせるように変更
・オプション/各種ドッキングバーからの処理ルートを共通化した
※再描画は遅いので、従来は1個しか反映させていなかった

●メニュー定義
・表示モード切替メニュー定義(_ViewMode.txt)の文言の不統一の修正と、他の改修を受けてコメントの内容が不適切になっていたのを修正

●その他
・コンパイラオプションによるDPI検出モード指定を無効に変更
・改修で未使用になっていたメッセージ定義を削除×2
・ファイルリストの列挙処理をモダンライブラリに変更して高速化、各種の機能に適用(7機能)
・タブの列挙処理ををモダンライブラリに変更して高速化、各種の機能に適用(32機能)
・全てのファイルリストのパスの列挙処理を高速化(タブに送る系スクリプトで使用)
・環境変数入りパス生成の際に入れ子の環境変数への対応を廃止
・インストールパスに読み書き権限がない場合、ステータスバーや、サポート必須情報に権限がない旨の表示を追加
・キャプションバーの跡地を掃除した
・ユーザー(C:\Usersの方)ディレクトリの特別扱いをやめた
※上位階層の補完やカラム取得のリトライ処理等
・オプションのレイアウト調整

●テスト実装
・「チップヘルプの表示を抑制する」をテスト実装
以下のキーを追加すると、リスト、ツリー、ボタン、各種ドッキングバー、ステータスバーなどのチップヘルプが全て表示されなくなります。
機能説明がゴッソリなくなるので正式仕様にするか否か決めかねてます。
しばらく使ってもらって、Ver.19時点で正式/廃止を決めます（意見が上がってこなければ廃止）
[HKEY_CURRENT_USER\SOFTWARE\AMA_Soft\ASR\Main001\AppInfo]
"HideToolTips"=dword:00000001(デフォルトは0)




Ver.18.1.4.0
●不具合修正
・選択状態を保持したままの更新で、画面分割した反対側の選択状態を保持しない不具合の修正
・選択状態の保持する際に、内部管理しているチェック済み数が不正になる場合がある不具合の修正
・表示モード設定ダイアログの反映の際にリスト項目の排他制御漏れを修正
・カーソル移動ではない全解除依頼はマウス位置の選択状態を確認した上で解除するように変更
※「詳細」かつ「一行選択」の場合は先頭カラム(ファイル名)のみ解除しないようにした

●仕様変更
・「コンテンツ」の場合に「詳細」の一行選択の設定が反映されるのは不適切な仕様のため廃止

●性能改善
・「履歴移動で選択状態を覚える」がONの場合の情報管理速度が60%向上
※上記の不具合修正中に見つかったネタで選択状態保持の仕組みを再構築したもの
　検証用として影響範囲が狭い履歴移動のみ適用した

●その他
・コード分析対応を22件
・代替データストリーム情報のサムネイル表示時が分かりにくいとのことなので「ADS情報」と見出しを付けてヘルプも加筆




Ver.18.1.1.0
●カスタマイズファイルの出力/参照先をインストール先からユーザー情報の管理ディレクトリへ変更
※配布ファイルの削減と、カスタマイズ内容の持ち運びやすさの向上

a.ファイル一括作成(FileNewEx)
・テンプレートや、ファイル名構成部品のカスタマイズ内容の保存場所を「FileNewEx.exeのパス\<ロケール>\FileNewEx」から「ユーザー情報の管理ディレクトリ\Command<ロケール>\FileNewEx」以下に変更
・メッセージ文言を修正

bフォルダー一括作成(MkDir)
・サンプル事例の入力のカスタマイズ内容の保存場所を「MkDir.exeのパス\<ロケール>\MkDir」から「ユーザー情報の管理ディレクトリ\Command\<ロケール>\MkDir」以下に変更
・配布用のサンプル事例テキストを組み込みにして初期生成するように変更（参照先が存在しない場合に生成）
・メッセージ文言を修正
・初期定義ファイル内の意味のない空白を除去
・苗字世帯数順.txtは大きすぎるので配布をやめた
　既存配布していたファイルを新しいディレクトリにコピーすれば併用可

c.NewCommand.templateの参照パスをAsr.exeと同じパスからユーザー情報の管理ディレクトリに変更
・ユーザー情報の管理ディレクトリに存在しない場合は複製する処理を追加

d.Setting.exeの調整
・定義ファイルを75個削減、ディレクトリを17個削減に対応

●試験実装
・DLLが要らない書庫展開コマンドの追加(ID:35199)
※Windows搭載のtar.exeを使用するが、7zipがインストールされていれば7z.exeの方を優先使用する
　極端なシンプルUIであり、進捗ダイアログも死活の判別/中断のみ

●不具合修正
・各種選択系コマンド発行後に、選択解除のイベントが発生しない操作の組み合わせがある不具合の修正
・上記の一環で「選択して次へフォーカス」など（スペースキー押下で発動する系統のコマンド）を作り直した
・Windowsのコンポーネントバグでアイコン/タイルで右クリックした場合、クリック対象の選択状態を無視して常に全解除イベントが発生する件への暫定対応
・タブが1件も存在しない場合にポップアップメニューの初期化で落ちる不具合の修正




Ver.18.0.7.0
●誤検出対策対策/ランタイム不要化に向けた取り組み
・リソースDLLの仕組みを廃止
　dllを14個削減。ディレクトリを18個削減

●64ビット版で32ビットランタイムを不要にした
・Arc、ArcPack、ArcUnPack、MArcを静的リンクに変更(exeのサイズが増加)
・Setting.exeの説明とUIガイドを修正
・各種ドキュメントやガイドメッセージを大量に修正

●MSNの変更に伴うBrwsの修正
・GoHome()APIの表示ページがEdgeのダウンロードページになったため当サイトに変更
・検索ページが変更になったためGoSearch()APIの呼び出しに変更

●有用性が低く、他に有用なソフトがあるコマンドの廃止
・ファイルをロックしたプロセスの検索(ID:42042、LockProcess.exe)
・システムのサムネイルキャッシュの作成(ID:42039、CreateTumbImg.exe)

●アプリ更新時に強制上書きするファイルに変更（予告していたことを忘れていた）
_MainNormalCmd.txt
_MainNormalCmd1F.txt
_MainNormalCmd2E.txt
_MainNormalCmd3V.txt
_MainNormalCmd4T.txt
_MainNormalCmd5W.txt
_MainNormalCmd6H.txt
_MainNormalCmd7A.txt
・ユーザー情報の管理ディレクトリに「Command」ディレクトリを作成
※今まで雑に扱っていたMkDir.exeとFileNewEx.exeのカスタマイズ情報の格納先として使用予定

●MSIX形式インストーラー化への取り組み(準備段階)
・バージョン情報にAsr.exeのフルパス表示を追加
※インストール先は%ProgramFiles%\WindowsApps\（インストーラー名）になるので確認用
・外部参照ファイルの削減
　オプションのマクロ定義テキストを6個、音声認識定義のxmlを1個、ディレクトリ2個削減
・起動時にAsr.exeのバージョン番号を参照するように変更

●不具合修正
・インストール状態の確認で、同じメッセージが複数回も表示されるルートがあったので整理した
・ユーザー情報の管理ディレクトリが存在しない旨のメッセージが表示されない不具合の修正
・テーマファイルの読み込みディレクトリ指定が間違っており、実害はないが処理順番を入れ替えたらバグになる可能性があるので修正
・OLEオートメーションサーバーの登録時に最近閉じたフォルダーバーの情報が喪失する不具合の修正
・ユーザー情報の管理ディレクトリを取得する関数にて冗長なメモリ転送を削除、またモードとエラー種類毎にディレクトリ作成の動きが異なっていたので修正




Ver.18.0.3.0
●不具合修正
・選択系コマンドの内、16個がステータスエリアと連動しない不具合の修正
・上記の一部のnullチェックが古い記述で冗長だったので修正

●配布書庫の整理
・「DLLプリロード等の脆弱性がある外部ソフトをインストールしている環境でも動作する版」の廃止
※通常版も外部アプリケーションの脆弱性を許容するように変更
・Ver.18系の改修にて性能差が大きく減ったため「AVX2使用版」を廃止
・セキュリティ関係のコンパイルオプションを見直した
　制御フローガード、EH継続メタデータ生成(x64)など




Ver.18.0.0.0
●選択状態などの内部データ化
・マウス操作やキー操作から選択/フォーカス/ドロップハイライト状態を取得する仕組みを追加
・Shift押下時のキー操作から選択状態を取得する仕組みを追加
・リスト項目の状態をセット/取得するAPIのラッパーを追加
・カーソル移動による全解除イベント生成用の補完処理を追加
・複数の属性の全選択/全解除の走査ループを1回で行い、抽出条件をラムダ式で指定する関数の追加

●省メモリ化(データ構造の見直し)
a.リスト上の個々のアイテム
・親クラスのポインタを削除してアイテム1個あたり8バイト削減
・親クラス管理を上位クラスに委譲し、コールバック関数へはコンストラクタ引数で渡す仕組みを実装
・ファイルの拡張子のテキストをwchar_t*→shortに変更して1個あたり3バイト削減
・上記の参照ヶ所の補完処理を大量に実装
※拡張子優先系のソートの性能は2～4%くらい劣化したが、少し前の改修で110～160%の向上をしているので許容範囲と判断
・桁削減に伴いメモリアライメントの並び順を調整(合計16バイト削減)
b.リスト
・1個当たり、BOOL→boolで14バイト削減
・不要変数の削除で4バイト削減
c.復元用選択状態リスト
・ステータスをUINTからshortで2バイト削減

●CMapの利用の削減
・画面分割比較の際の同名ファイルの走査のハッシュをunordered_mapに変更、約40～300%の速度向上
・移動履歴に選択状態を含める場合の処理速度が10～500%向上、また情報を圧縮して省メモリ化も行った
・CLSIDとプレビューハンドラのハッシュをunordered_mapに変更、ただし数が少ないため性能影響は小さい

●内部処理の変更に伴った性能向上
・ソートの比較関数のメモリブロックを近い位置に変更してブロックまたぎを起こりにくくした
・チェック数のカウントロジックの計算量を削減
・内部データの破棄時に1,000件以上あるなら並列で破棄するように変更し、約0～400%の性能向上
・画面分割で左右比較で、検出解除を明示的に行い同期性を高め、約800～1,200%の性能向上
　また十分な速度が出るようになったので投機実行をやめて追従性と正確性も向上
・チェックボックスの「エクスプローラー風」(ID:33341)のメニュー表記から「(遅い)」を除去
・現在の選択状態の取得方法の抜本見直しと、情報管理の仕組みの再構築で約1,000～2,000,000%の向上
・情報の衝突率が最悪のケースの場合、選択状態の復元速度が約2,000～500,000%の向上
・アイコン（旧）/アイコンのみ（旧）のドラッグスクロールや大量選択の性能劣化がなくなった（性能向上倍率がintの桁数を超えたので計測不能）
・選択状態を保持したまま更新の処理速度が10～500%の性能向上に伴い、中で「選択状態を保持したまま更新」を呼び出す機能全てが高速化
・各種選択系のコマンドの速度は全体的に約10～3,000%向上

●コード分析対応
・描画周りのポインタを参照へ変更がたくさん
・nullチェック系のコード分析の指摘対応がたくさん
・gotoを4つ削減
　a.詳細設定の検索のリトライ修正
　b.フォルダサイズ計算の中断×2修正
　c.メインフレーム破棄のリトライ修正

●カーソル移動系コマンドの追加(Shift/Ctrlとは連動しない)
・次へカーソル移動（終端の次は先頭）(ID:35760)
・前へカーソル移動（先頭の前は終端）(ID:35761)
・上へカーソル移動(ID:35762)
・下へカーソル移動(ID:35763)
・左へカーソル移動(ID:35764)
・右へカーソル移動(ID:35765)
・先頭へカーソル移動(Home)(ID:35766)
・終端へカーソル移動(End)(ID:35767)
※PAGEUP(ID;35768)、PAGEDOWN(ID;35769)も実装しているがスクロール方向で終端に行く/行かない等の考慮が良く分からないので保留

●ベンチマーク情報のログバー出力追加
・走査の前処理の情報を追加
・走査の後処理の情報を追加
・ミリ秒未満はほぼ誤差なので削除
・クリップボードへ保存コマンドの追加
・情報出力のInformationはサフィックスを付けないように変更
・調査用の隠しスクリプト追加（StackTrace）
※性能低下要因につき、情報が陳腐になったり撤去される可能性があります。
　ログバーが表示されている場合に、リストの内部処理のスタックトレースと、各項目の選択/フォーカスステータスを出力します。
　ログバーの出力オプションは「その他」のみにし、401件以上出力するようにしないと欠けが発生する可能性があります。
　またOther以外の項目を非表示にしておかないと、ログが流れていきます。
1.リストのスタックトレースを最大200件出力
2.フォーカス番号と現在のフルパスを出力（表示項目数が200件超の場合はエラーメッセージ）
3.表示項目の状態を最大200件
　選択状態(S)/カーソル移動用選択(s)チェック状態(C)/フォーカス状態(F)/カーソル移動用フォーカス(f)/表示名を出力
【書式】
StackTrace

●設定の削除
・起動時に外部コマンドをキャッシュして呼び出しを速くする
　今どきのSSDでは、ほぼ意味がないため
・リストのフォーカスの初期状態を選択にするを廃止
　設定の組み合わせで問題のある挙動になるため
・イベントコマンドのディスクの取り外し／取り出しを検出した場合を廃止
・イベントコマンドのディスクの追加／挿入を検出した場合を廃止
・ステータスエリアの選択状態の計算をする上限設定を無視するように変更
　性能向上に伴い不要になったため

●コマンドの廃止
・シフトロック範囲選択の開始(ID:35629)の廃止

●その他
・サムネイル画像をファイルに保存コマンド時のピクセル数の並び順の整理と、種類を増加
・埋め込みリネームの発動対象をエクスプローラーに近い条件に変更
※フォーカスアイテム→フォーカスかつ選択アイテム、フォーカスかつ選択アイテムが存在しない場合選択しているもの先頭が対象
　エクスプローラーはフォーカスかつ選択アイテムが存在しない場合、選択している2番目が対象で意図が不明
・自動更新の際に、Zipなどリネームでディレクトリ属性が付与されるものへの配慮を追加
・小文字変換際の不必要なメモリ転送を削減した
・vectorから一致するものが存在するか否や、値の大小の評価関数などの引数をテンプレートに変更
・アドレスバーから廃止プロトコル名でアクセスしようとした場合に除去するように変更

●不具合修正
・パス分割ユーティリティでFTPパスの分解に失敗していた不具合の修正
※構文解析のエラーにならないが、Windows10以降はCOMインターフェイスがFTPパスを受け付けないので実害なし
・プロトコル名判定でftpsが抜けていたので追加
・アクセス不能なパス書式のプロトコルルートから上位階層へ移動しようとした場合に落ちる不具合の修正×2




Ver.17.5.8.0
●ホームページ上からサポート掲示板のリンクを削除する準備
・バージョン情報画面にあるサポート掲示板表示ボタンを非活性にならないように変更
・本体から受信した実行権限/版/本体認識のDPI情報をクリップボードにコピーするテキストに含めるように変更

●ライブラリの不具合に対する補完機能の追加
・高DPI環境でツールバー画像を新規作成/編集すると画像を破損する現象への対処
　現象の説明メッセージと、配布画像に修復する機能を追加




Ver.17.5.7.0
●分割時のインサイドツリーのフォーカス制御を変更
・インサイドツリーへのフォーカス遷移は、画面分割の有無に関係なくTABキーで移動するように変更
※画面分割の際にTABキーでペインを切り替えるのは、わざわざインサイドツリーの表示操作をしているユーザー操作を尊重する意図です。
・反対側のペインにフォーカスを移動する(ID:35708)コマンドを追加、各種メニュー定義を更新

●Windowsの不具合対応
・最近のWindows10/11 23H2でシェルのオーバーレイアイコンの背景色が透過しなくなったので切り取り時の描画に透過属性を付与した

●不具合対応
・リストがアクティブになるまで走査しない、がOFFの時に未走査のタブ表現が更新されない不具合の修正
・アドレスバーのボタン位置の微調整
・カスタムペーストの「ターゲットが既に存在する場合は自動リネームする」の挙動はエクスプローラーと微妙に異なり混乱しそうなので、対象パスを判断して自動付与に変更した




Ver.17.5.5.0
●見た目などの変更
a.フォルダーバー/インサイドツリー
・ツリーの開ボタンの色味を変更して開/閉の視認性を上げた
b.タブバー
・描画ステータス変数が不要になっていたので削除
・未ナビゲートのタブのテキストは背景とテキスト色の中間色に変更
・ドライブアイコンを使用している場合、ドライブレターは重ね描画ではなくテキスト部で表示するように変更、また描画性能の改善
・レイアウトの調整
c.ウィンドウ管理バー
・描画ステータス変数が不要になっていたので削除
・未ナビゲートのタブのテキストは背景とテキスト色の中間色に変更
・ドライブアイコンを使用している場合、ドライブレターは重ね描画ではなくテキスト部で表示するように変更、また描画性能の改善
　さらにアイコンインデックスをキャッシュするように変更
d.リスト（並べて表示）
・枠表示を線で表現するように変更、レイアウト微調整
・PCを表示した場合、「種類」を２行目、３行目に「空き容量/合計サイズ」に重ねてサイズグラフの表示を追加
e.リスト（一覧/詳細一覧）
・表示直後のフォーカス移動はアイテム全体が見える位置に変更
f.その他
・フォーカス枠の色指定が雑だったのでテキスト背景色の反対色で揃えた
・テキストのサムネイル表示時のレイアウトを微調整

●日時フォーマットの追加(MkDir.exe、Rename.exe)
　a.日付の追加
　・%Y_%m_%d：スペース表記の置き換え用途
　・%Y年%ｍ月%Ｄ日(1桁全角)：数字が一桁の場合は全角にする
　　※固定幅フォントの環境で縦揃えになるようにするためのもの、年は4桁なので対象外
　b.時刻の追加
　・%H_%M_%S：スペース表記の置き換え用途
　・%Ｈ時%Ｍ分%Ｓ秒(1桁全角)：数字が一桁の場合は全角にする
　　※固定幅フォントの環境で縦揃えになるようにするためのもの

●リストのステータスエリア
・ロジックを整理して置換速度を大きく向上
　（現時点で体感速度に大差はありませんが、性能の向上のための種まきです）
・新規マクロを12個追加
　\t
　%DisplayName%
　%RealName%
　%FullpathFileName%
　%Attribute%
　%ShellFlg%
　%UpdateTime%
　%CreateTime%
　%AccessTime%
　%SelItems%
　%CheckCount%
　%FocusNo%
・エクスプローラ風チェック、アイテムチェックの２つのモードにて、マウス操作でチェックボックスの全解除(選択状態は無し)を行った条件でステータスエリアの更新処理を追加
・マクロ入力補助の定義ファイルを更新

●インストール/更新
・InstAsr.exeの起動時の確認メッセージにコマンドライン/tの説明を追加
・配布のzip書庫を展開しないでInstAsr.exeを実行した場合の失敗メッセージを少し分かりやすくした
・exeの実行時にエラーになる場合はウィルススキャンソフトメーカーに連絡するようにメッセージに追記した
・Windowsの標準機能を使って解凍した場合など、配布ファイルのタイムスタンプを損壊した場合の中断メッセージの言い回しを修正

●誤検出対策
　7z.exeで作成した7zipの自己解凍書庫をウィルスと誤判定を繰り返す欠陥(再現性あり)があるウィルススキャンソフト向けの対策
　具体的にはESET社およびキヤノンITソリューションズ株式会社の製品です。
・ヘルプに誤検出するウィルススキャンソフトがインストールされている環境では動作保証しないことを明記
・書庫生成の7z.exeをVer.24.05に更新
・zip版の配布書庫を作れるようにした
・7zファイルを自前で展開する版を作れるようにした

●現在のフォルダーの代替データストリームを削除(確認無し)コマンドを追加(ID:35217)
※イベントコマンドの「貼り付けの終了」や「リストの表示」などで問答無用で自動的に処理するような用途向け

●カスタムペースト機能の追加
※貼り付けの際の問い合わせがうっとおしい、進捗ダイアログでフォーカスが外れるのが煩わしいといった用途
・オプション→リスト→貼り付け、に以下の設定を追加
　a.カスタムペースト機能を有効にする
　b.OSと連携するアンドゥ機能を使用する
　c.問い合わせがあれば、全てYesと答える
　d.新しいディレクトリの作成を確認しない
　e.セキュリティ識別子を複製しない
　f.接続されているファイルをグループ扱いしない
　g.エラーメッセージを表示しない
　h.ターゲットが既に存在する場合は自動リネームする
　i.進捗ダイアログを表示しない
　j.ごみ箱に格納されず、完全削除される場合に警告表示する

●ベンチマーク検証用のスクリプトコマンドを追加
・LogMessage
　ログバーにメッセージを出力するメッセージを送信する。
　ログ種別は「スクリプトスレッド」動作種別は「情報」で出力する。
【書式】
LogMessage=[送信文字列]
・BenchStart/BenchStop
　ベンチマークテスト用、BenchStartで計測タイマーを初期化し、呼ばれるたびにリセットする。
　BenchStart～BenchStopが呼ばれるまでかかった時間（ミリ秒単位）を計測して変数に代入する。
【書式】
BenchStart
変数 = BenchStop

●リストのチェック個数/フォーカスインデックス番号を内部で管理する仕組みの追加
※選択数のカウントループが半減し、並列処理化が可能になるので、将来的に大きな性能改善が見込める
　ただし影響範囲が広いので徐々に適用範囲を広げる
・「チェックボックスなし」モードの判定の一元化および、何度も判定していた冗長な仕組みを整理
・チェックボックスのモード切替時の初期化を微妙に高速化
・自動更新でリネームを検知した際の処理の性能改善
・簡易型の選択の有無の判定処理の高速化
　計算数が2(n-1)→2
・選択状態のチェック数が0か否かを使用するように変更
　膨大な数の改修の一部で先行実装
　今回の影響箇所は「リストで選択しているアイテムを登録」「ディレクトリ内検索」

●データ構成の整理
・デスクトップか否かのフラグを廃止して、フォルダータイプに一元化した
・ネットワークか否かのフラグを廃止して、フォルダータイプに一元化した
・フォルダー種別の判別ロジックの再確認
　ユーザーディレクトリの特殊な扱いを一部減らした
　デスクトップ、ネットワークの特殊な扱いを多く減らした

●安定性の向上
・OS等のシステムエラーの検出と回避の仕組みを大量に追加
・外的要因が多いメモリ開放の際の例外処理をトラップして破棄するようにした
　デストラクタの速度低下による性能低下あり
・コア情報と表示情報の結合度を下げて表示情報の寿命を短くした
　安定性の向上の布石

●並列処理の見直し(前述の改修により可能になった性能改善)
・各種の並列処理においてOpenMPの利用をやめて、PPLと並列STLに置き換えた
・状態更新処理用のインデックスをunordered_mapからconcurrent_unordered_mapに変更して並列化した
・調整すべきパラメータが無くなったのでベンチマークでチューニングコマンド(ID:35906)を削除
※1コア環境では2～3割は性能劣化しており、2コアで従来並みです。
　intel系8コア環境(i7-9700)で2.2～3.6倍速、AMD系16コア環境(Ryzen 7 7730U)で2.2～4.5倍速の改善です。
　通常運用条件では、いずれも100万ファイルの格納ディレクトリの表示が約2.5秒→1.9秒程度
・インデックスが生成される条件で、上位階層への移動/ファイル名を指定して開くなどのフォーカス位置の検索速度の改善
※100万のサブディレクトリがあるディレクトリ間の移動の最悪ケースで7～9秒かかっていたものが測定不能な速度に短縮
・遅延処理を考慮していたフルパス文字列の生成を廃止して、並列処理に含めて走査速度を向上

●その他
・コード分析の警告の解消が200件くらい
　nullチェックとnoexcept指定の追加など
・一覧生成スレッドの冗長なオーバーヘッドを削減
・Vislual Studioの更新(Ver.17.10)、新機能を使って下記の改善に貢献
　a.メモリアライメントを調整してリスト上のアイテム1個当たり8バイト削減
　b.以前使用を検討していたIShellItem2のポインタを除去、アイテム1個当たり8バイト削減
・データ系のクラスのコンストラクタの例外処理を大量に削除
　コンストラクタの速度向上による性能向上
・低機能/高速文字列クラスの再代入処理でメモリの断片化をしにくくした
・メモリリーク検出のトラップを大量に追加
・表示用データの複製で、拡張子テキストの複製をループから数値演算にして高速化
・ログバーに出力するベンチマーク値を調整
・多数のCOMのポインタをスマートポインタに変更
・起動時/タブセット切り替え時の移動履歴保存の仕組みを再構築するも、性能が悪すぎて再封印

●不具合修正
・全機能一覧で生成したHTMLでタグが閉じていないところがあった不具合の修正
・ボーダー無しの場合にステータスエリアに残像が残る不具合の修正
・オプションの画面内からのバージョンチェック時にコマンド名が間違っている不具合の修正




Ver.17.1.8.0
●メインメニューのカスタマイズ環境を追加
・メインメニューをスタンダードに切り替え(ID:33410)
・メインメニューを全機能に切り替え(ID:33411)
・メインメニューをカスタムに切り替え(ID:33412)
・上記コマンドをメニュー定義に追加
	・カスタムメインメニューの定義ファイルを8個追加
　_MainCustCmd.txt、_MainCustCmd1F.txt_MainCustCmd2E.txt、_MainCustCmd3V.txt、_MainCustCmd4T.txt、_MainCustCmd5W.txt、_MainCustCmd6H.txt、_MainCustCmd7A.txt

●インストール/更新
・InstAsr.exe
　a.整合性のチェックが完了するまで中間ファイルを生成しないように変更
　b./tが付与された場合、エラーでも作業ディレクトリを消さないように変更
　c.エラーメッセージの情報量を大幅に増やした
　e.書庫展開でCreateProcess実行のコマンドライン指定をやめた(書庫解凍の上書き確認のYを指定していた)
・Setting.exe
　a.更新時に全機能メニューは強制上書きに変更
　　（通常のメインメニューである「スタンダード」は経過措置としてVer.17.5.0.0以降で実施予定）
　b.更新処理の冗長な記述の修正とログの文言修正

●スクリプト拡張
・SelectDialogで、省略可能なデフォルトフォーカスのインデックス指定を追加

●その他
・ScriptTracer関連の分岐を削除
・リストの遅延情報取得スレッドがCPUコア数の少ない環境で不安定になるようなのでスレッド数減らした
・選択ファイルを展開を試験実装（ID:35199）
※シェルの解凍機能で、OSによってサポートしている書庫が異なる
　OSの機能も確定ではなく、速度も遅いので廃棄の可能性あり




Ver.17.1.6.0
●バージョン情報(VersionInfo.exe)と、最新バージョンの確認(VersionCheck.exe)を統合
　a.メニュー項目はバージョン情報に統合
　b.「サポート連絡用の必須情報をクリップボードにコピーしてサポート掲示板を開く」ボタンを追加
※スパム書き込み避けの掲示板の引っ越しを想定してリダイレクトURLとした
　c.最新版情報の配信サーバーを2系統に増やした
　d.情報の取得ができたら「リリース版をダウンロードして、ダウンロードディレクトリと配布ページを開く」に切り替わる機能を追加
　　（通信断などで旧サーバーから受信したら「リリース版ページを開く」のまま変化しない）
　e.β版も同様

●コマンドの追加
・タブセットを選択して別プロセスで起動(定義ファイル:_NewTabsetProc.txt)
　コマンドIDを追加した定義ファイル
　_MainFullCmd.txt
　_MainNormalCmd7A.txt
　_StatusTabSetMenu.txt
　_TabMngBarTabset.txt
　_TabMenuSetting.txt
・上位階層メニュー
　コマンドIDを追加した定義ファイル
　_MainFullCmd.txt

●メインメニュー
・メインメニューのショートカットの表記にAltとの組み合わせの記載を追加

●各種メニューにアイコン画像を追加
・アドレスバーをダブルクリックしたとき（パス表記部分）のメニューに追加
・ユーザー定義バーをポップアップメニューで表示したメニューに追加
・メインメニューを非表示の場合、タブグループ切替系の項目の色塗り画像の追加
・メニュー定義のDIRECTORYコマンドに階層がある旨のディレクトリアイコンを追加
・上位階層メニューにシェルアイコン画像を追加

●メニュー定義追加
・MESSAGEコマンドを追加

●スクリプト追加
・SelectDialogコマンドを追加

●オプションで移動履歴を保持する設定を追加
・ここから開く/ナビゲートロックから継承する場合に移動履歴を保持する（リスト→動作）
・分割の切り替え時に移動履歴を保持する（リスト→画面分割）

●誤検出対策
・内容を判別して拡張子変更コマンドの廃止
※再配布している外部DLLがブラウザの誤検出でブロックされるため。
　またサイト上に置いておくだけでも警告されるので機能廃止に至りました。
・InstAsr.exe
　a.コンソールアプリからWindowsアプリに変更
　b.起動直後に確認メッセージを追加
　c.パスフレーズによる署名機能を追加
　d.テストモード追加
　e.チェックサムによる破損や改ざん検知の追加
　f.配布書庫の7zipパスワードは付与しないように変更(/tで取り出したあと、どうしようもないため)
・Setting.exeで日付チェックする処理を追加
※配布書庫の日付が壊れている場合にカスタマイズ内容が破損する可能性があった
　使用許諾で許されていない、無断で改ざんした再配布サイトで発生していたトラブルの原因はこれ

●その他
・オプションの文言修正
・メッセージ定義ファイルの文言修正
・なるべく積極的にMFCカスタムダイアログの保存処理を行うように変更




Ver.17.0.7.0
●ウィルス誤検出対策
・配布書庫の構成を変更してInstAsr.exeを追加
・Setting.exeにインストール済みであっても「初回インストール」を有効にするボタンを追加

●コマンドラインオプションに起動時のタブセット番号を指定を追加
・Asr.exeに/tabsetスイッチを追加
・AsrLoad.exeの/tabsetスイッチの動作を変更
　本体が起動していない場合に起動してタブセット切替コマンドを発行していたが、本体の起動コマンドラインに渡すように変更
※タブセット1で作業していて、タブセット2を開いてるAs/Rがもう一つ欲しいな・・・という時に使う想定
　タブセットを指定して別プロセスで起動コマンドの下準備

●非アクティブ時に薄くして、非アクティブを強調する設定を追加（全体-動作）
※マイカを意識しながら、より極端にしたものなので実験的な取り組み
　アクティブウィンドウが分かりにくいWindows10/11向け
　上記のコマンドラインの拡張のようにAs/Rを複数起動し、切り替えて使用するシーンを想定

●フレームの枠線の設定を追加（全体-外観-色・フォント）
・各種フラット系のテーマの定義ファイルはOFFとした

●MFCカスタマイズダイアログ系の改善
・キー割り当ての変更時、カスタマイズ時に、メインメニューの定義ファイルの再読み込みの仕組みを追加
・大きいアイコン変更の反映の要再起動の制限をなくした
・大きいアイコンの場合にタブバーアイコンにも反映させるように変更

●その他
・リスト、ユーザー定義バーのインクリメンタルサーチのマッチング処理の冗長性を改善
・インサイドツリーをクリック時、環境変数が含まれるパスへ遷移できなかった課題に対応
・アドレスバーをダブルクリックしたときに表示される下位階層メニューから、環境変数が含まれるパスへ遷移できなかった課題に対応

●不具合修正
・レジストリエディタなどでレジストリの値を不適切な値に書き換えた問題
　ツリーの先頭ノードが空になる場合がある不具合の修正
　起動に失敗する場合がある不具合の修正
・メモリ枯渇時にバッファオーバーランが発生する可能性がある不具合を修正
・スクリーンリーダーが誤読しやすい送り仮名を修正
・高DPI環境にて表示が見切れるオプションのレイアウト調整を多数
・グラデーションなしの場合に発生するリストの表示崩れを修正
・ツリーで行選択無しの場合のタグ描画を修正
・オプションのスクリプトコマンド画面の表示切り替え時の挙動を修正
・OSコマンドの呼び出しの一部でディレクトリトラバーサルの脆弱性を修正




Ver.17.0.1.0
●不具合修正
・インストールの際にUserImages20.bmpをユーザー情報の管理ディレクトリに複製し損ねていた不具合の修正
・クリーンインストールをした場合、廃止したファイルを読み込もうとして起動に失敗する不具合の修正




Ver.17.0.0.0
●機能重複および利用頻度の低い機能の削除
・キャプションバーの廃止
・履歴メニューボタン（アドレスバー横）を廃止
　同時に更新ボタン順番の変更、レイアウトを一部変更
・スクリプトトレーサー連携機能の廃止

●メニューバーにヘルプ検索を追加
・Googleのサイト検索を行うコンボボックスを追加
　Enterキー押下で入力したテキストで、オンラインヘルプのサイト内検索を行う
　検索履歴は10件まで保持するが、アプリ終了時に破棄

●高DPI環境にて、ライブラリが非対応のための仕様変更
※大きいツールバー画像は、絵心ないので元画像の外枠のサイズを変更しただけです。
　絵師さんが名乗り出てくれれば仕様の公開も検討します。
・「標準」ツールバーの画像サイズを20×20に変更し、機能アイコンを大幅に入れ替えた
・「標準」のツールバー以外は全て削除
・カスタマイズ用のUserImages20.bmpの追加
・大きいツールバー用の32x32の画像リソースを追加
・アドレスバー周り/リスト下部/ステータスバーのボタンサイズは、最小値20pixかつリストのフォント依存となるように変更
・ツールバー上から表示する機能メニューはカスタマイズ要素として「このメニュー定義を編集」を追加

●メインメニュー
・定義ファイル_MainNormalCmd.txtを使用するように変更し、ライブラリ提供の仕組みを全廃
※MFCカスタマイズダイアログでのメイメニューの変更は、タブ切り替えまたはAs/Rの再起動で失われます
　a.キー割り当てされたショートカットの表示が増えた
　b.ライブラリ依存の補正処理が全てなくなったため起動速度向上
　c.ファイル読み込み/メニュー定義解析のため起動速度低下
　d.Ver.17以降のみアップデート/ダウングレードの安定性の向上
　e.使用頻度・有用度を基準に項目の削除/統合
　f.「自動判定して名前の変更」「ヘルプ検索ボックス」「ヘルプ検索」「コマンド検索」などの追加

●全機能メニュー
※削除したコマンドのIDも残しているので当面は使用可能ですが、いつまで使えるかは保証いたしません
　a.使用頻度・有用度を基準に項目の削除/統合
　b.ポップアップメニュー表示系の機能をたくさん追加
　c.「自動判定して名前の変更」「ヘルプ検索ボックス」「ヘルプ検索」「コマンド検索」などの追加
　d.誤操作のもとになる懸念より、一括登録/削除系のコマンドを削除

●初期ショートカットキーの割り当ての見直し
・6、B、Xを未割当に変更
・Rを「自動判定して名前の変更」に変更

●MFCカスタマイズダイアログ
・全機能系の機能一覧を精査して、各機能がカテゴリ分類されるように変更
・カスタムコマンドなどの使われないIDを削除
・全機能メニューの精査に伴い項目が増減した

●ツリー系オプション
・フォルダーバーの動作設定のメニュー定義を、インサイドメニューと共通で使えるように修正
・「起動時/タブセット切り替え時にツリーを同期しない(OFFは非推奨)」を追加
※隠し機能時からの変更点：起動時コマンドライン指定は固定で同期あり、タブセット切り替えにも適用
・「独自描画を行う(廃止予定設定)」を追加
・「行選択」と「線あり」の相互干渉をなくした

●ツリーをカスタムドローで描画する機能の追加
・若干描画がもたつくようになった
・フォーカス色やグラデーションが適用されるようになった
・ツリーに制限のあったOSのダークモードの影響が減少
・ツリー表現の向上
　a.オーバーレイアイコンの取得で属性情報を使う設定がONになっていると、共有やショートカットのオーバーレイアイコンを表示
　b.絶対パスタグの付与されたパスにマーカーを表示
　c.開閉ボタンを自前画像に変更
　　大きさ/色に差をつけて視認性を向上、「線あり」との親和性向上
　　背景色の輝度に合わせて開閉ボタンの色調を切り替えるなど
・クラシックモードは使用せずクラシックモード風の描画を実装




Ver.16.9.4.0
●マルチメディアビューア(Seeker.exe)
・メディアプレーヤーで時間を進めるコマンドが来た場合、停止状態だと再生するように変更

●その他
・リストの表示カラムを全てクリップボードへコピーコマンドを暫定で追加(ID:35660)
※「並べて表示」のように変動型カラムや、「詳細一覧」で表示情報があるがカラムがない場合もあるので検討中
・プレビューバーの背景色をテーマのドッキングウィンドウ背景色（アクティブ）に変更

●不具合修正
・オプションでOS番号を間違える可能性がある不具合の修正




Ver.16.9.3.0
●不具合修正
・プロセス分離をする際にパスが文字化けをすることがある不具合の修正
・誤字修正




Ver.16.9.2.0
●1フォルダあたり10万ファイル超の環境での操作性の改善
・リストの選択状態の表示を無効にする上限設定を追加(初期値10万)
※PCの性能に依りますが、作者環境で40万件あたりから性能劣化が顕著になるため調整できるようにしたものです

●文字コード変換処理の改善(省メモリ化、OFRからのフィードバック)
　a.サムネイル画像による一覧表示
　b.プレビュー
　c.ファイルの中身をクリップボードへ保存コマンド
　d.オプション
　e.テキスト文字コード変換コマンド
　f.テキストビューア

●不具合修正
・タブバーの機能ボタンのツールチップのタイトルをセットしてない不具合の修正
・ツールチップタイトルの文字列長の上限チェックしないルートがある不具合の修正
・ツリーの「開閉ボタンはフェイドアウト」の設定を削除
　修了確認メッセージの表示時にツリーコンポーネント内部の処理で以後描画されなくなるため




Ver.16.8.9.0
●ツリーの改善
・初期化の冗長性を解消
・未使用変数の整理とバイト単位での省メモリ化を多数

●その他
・コード分析対応、主に性能向上が見込める箇所のみ200件くらい
・リスト部のレイアウト処理をブロック化して整理
・CreateProcess()を実行する際に検証用の字句解析があったのを削除
・メインメニューを非表示にしたとき、「表示」メニューのプレースホルダーにユーザーツールバーを追加
　「カスタマイズ」もプレースホルダーに含めるように定義ファイルも修正
・ツールバーなどのツールチップを「OSのダークモードを使用する」の影響を受けるように変更
・タブバー/ウィンドウ管理バーのツールチップに絶対パスタグのテキストを追加

●不具合修正
・フォーカスがないツリーに右ボタンでアクティブになった際、フォーカスが見えるようにスクロールしないように修正
・中ボタン押下ではアクティブにならないが類似現象が発生するので同じ対処を行った
・オプションのタブセット画面で設定を保存するとメインメニューを洗い替えしてしまう不具合の修正
・ステータスバーのコンテキストメニューのプレースホルダーから不要なセパレータを削除
・ツールチップのシェル拡張ツールと連携した際の脆弱性の修正




Ver.16.8.3.0
●各種ドッキングバーのツールバーの大型化
・タブバーを除いてドッキングバーのツールバー画像を16pix→20pixに変更
・タブバーも含めてイメージライブラリの更新に伴い画像の変更
　「このメニュー定義を編集」削除など
・利用頻度に関する観点からボタン整理に伴い各メニュー定義の見直し
・ボタン画像の大型化に合わせて、機能数が多く縦置き前提のドッキングバーの横幅を削減
 a.ユーザー定義バー
　1.ツールバーから削除(リストの選択アイテムを登録/現在タブを一括登録)
　2.ツールバーに「新規作成メニュー」(_UserBarNew.txt)を追加
　3.各種メニューの新規作成系の機能を整理
　4.復元スクリプトの前身であった「この階層への一括操作」系の機能はメニューから削除
　※機能を理解せず使ってしまうケースがあることのこと、誤用した場合の復旧が面倒なため機能削除
　5.カラム幅設定の多くを削除（動作設定メニューにあれば良いという判断）
　6.「このメニュー定義を編集」を削除

 b.ウィンドウ管理バー
　1.ツールバーから削除（横に並べて表示/縦に並べて表示/子ウィンドウの最大化）
　2.ツールバーに「並び替えメニュー」を追加(_TabMngBarArrangeWindow.txt)
　3.各種メニューの並べる系のコマンドを整理
　4.メニューのウィンドウ管理系のコマンドを上位に移動
　5.メニューから利用頻度の低い選択タブにショートカットの貼り付けを削除
　6.全てのウィンドウを横に並べる(ID:57652)を追加※メインメニューのものと同一
　7.全てのウィンドウを縦に並べる(ID:57651)を追加
　8.全てのウィンドウを重ねて表示(ID:57650)を追加
　9.選択ウィンドウを横に並べるのID変更(ID:57652→47641)
　10.選択ウィンドウを縦に並べるのID変更(ID:57651→47640)
　11.選択ウィンドウを重ねて表示のID変更(ID:57650→47642)

●描画調整
・デバッグバーのレイアウトの微調整
・リストの「詳細」のヘッダソート矢印のフォントサイズを調整

●その他
・非推奨になったSHCONTF_FLATLISTを使用しないように変更
・読み上げの邪魔になっていたのでユーザー定義バーのアイテムにドロップした際のメッセージの記号文字を変更、またログバーへの出力に変更
・上下に画面分割した場合のインサイドツリーのレイアウトを修正(ステータスエリアを貫通して高さを確保)
・インサイドツリーには存在しない「タイトルバー」「ツールバー」「連動設定→タブ切り替え」を非表示に変更
※メニュー内のセパレーターはVer.17時に定義ファイルから消します

●OSかOfficeの不具合の暫定対処
・実体を確認しない速度優先のアクセス手法でフルパス文字列指定でナビゲーション依頼を発行すると、フォルダーとしてバインド可能でありながら列挙時に予期せぬエラーになる特殊なファイルの場合に終端を除去してリトライする処理を追加
a.ログバーに、エラー種別で「Detected a bug in windows and retried.」を出力
※xlsxやdocx等のMicrosoft Officeの文書のみで発生します。
　何かしら別の問題が発生したり、不具合が修正されたら本対策は除去します。




Ver.16.7.7.0
●インサイドツリー
・表示切り替えボタンの位置を変更（画面分割の方向でレイアウトに差異があり)
・表示切り替えボタンの画像を切り替えように変更
・コマンドメニューボタンを追加して（リソースをケチる動的生成型）、以下の機能を追加
　定義ファイルはフォルダーバーと共用で_FolderBarAction.txtを使用
　a.最新の状態にする
　b,コピー
　c.切り取り
　d.貼り付け
　e.元に戻す
　f.名前の変更
　g.削除
　h.プロパティ
・動作設定ボタンを追加して（リソースをケチる動的生成型）、以下の機能を追加
　定義ファイルはフォルダーバーと共用で_FolderBarSetting.txtを使用
　a.リストの移動と連動
　b.ネットワークフォルダーを連動
　c.隠しアイテムを表示
　d.仮想フォルダーを連動
　e.オプション
※インサイドツリーには存在しない「タイトルバー」「ツールバー」「連動設定→タブ切り替え」は機能しません
　フォルダーバーの廃止の段階で、定義ファイルも更新する予定です。

●リスト描画
・実体ありフォルダーの「コンテンツ」の高速化(効果大)
　a.ファイルのサイズを内部計算にした
　b.更新日を内部計算にした
・「詳細」のヘッダを自前描画に変更
　よりフラットに、テーマ依存でソート順が目立つように変更
・「一覧」のフォーカス/テキスト描画の位置を調整
・各モードで取得するカラム項目の取得の際のオーバーヘッドを削減

●リスト周りにあるボタン
・ボタンのツールチップに動的に変化するショートカット表記を追加
・ツールチップメッセージをリソース化し、雑な実装になっていた部分を再構築
・ディレクトリ内検索のボタン4個、フィルタのボタン1個をリソースをケチる動的生成に変更
※ボタンを非表示にした場合にコンポーネントを破棄してメモリを解放する
　ただしOS側のキャッシュは残るので効果は微妙

●移動履歴のポップアップメニュー
・エクスプローラに寄せて、フルパス実体表記ではなく仮想名称の現在のパス表記に変更
※復元スクリプトの移動履歴の保持で使う想定なので、仮想名称内の「<」と「>」は全角文字に変換

●その他
・配布をやめたインストーラー同梱版をドキュメントから削除
・Windows Serverのサポート切れを受けて動作確認OSを減らした
・タブレット支援バー/ログバー/デバッグバーの非表示時の初期化省略による起動の高速化と非同期処理の整理
・MAX_PATH定数を使っているところを削減×2
・ウィンドウ管理バー/タブバーのドラッグでMAX_PATHを超える項目もエラーにならないようにした
・デフォルトのテーマ色の調整（格子色、ボタン色がディスプレイによって白と見分けがつかないため）
・コントロール描画のWingdings3/Webdingsをやめて、MeiryoUIに変更

●不具合修正
・ウィンドウ管理バーの空欄からのドラッグで、先頭行が対象になる不具合の修正
・復元スクリプトの「現在のタブのみ」で、オプションの終了時/タブセット切替時の保存有無の設定で仮想フォルダ/ネットワーク判定の影響を受ける不具合の修正
・ステータスバーの機能ボタンの、隠し属性を持つアイテムの表示切替の画像サイズにDPI係数を掛けていなかったのを修正
・ネットワークの死活チェック処理がスレッドセーフになっていなかったのを修正
　（ハードウェアのバスが1個なので並列処理を禁じるべきもの、ネットワークの監視を行っている環境で不安定になりやすい）




Ver.16.6.8.0
●ステータスバーの機能追加
・バー上に配置できる各種のボタン機能と、オプションの設定画面を追加
　アイコン画像と、ツールチップテキストで現在のアプリの状態を表現します。
　a.通常ファイルにドロップでフォルダ作成モードの切り替え
　b.ドラッグアンドドロップの標準動作(_StatusDropModeMenu.txt)
　c.チェックボックス(_StatusCheckBoxMenu.txt)
　d.サイズバーの表示（設定ダイアログ表示）
　e.日付の色分け（設定ダイアログ表示）
　f.隠し属性のアイテム表示の切り替え
・インジケーター部分の右クリックメニューを追加（_StatusContextMenu.txt）
　※並び替えはオプション画面で行う想定
　a.各種の機能ボタンの表示切替
　b.オプション表示

●「並べて表示」の高速化（効果大）
・ファイルのサイズの表示をONにしている場合、シェル情報を取得するのではなく内部計算にして高速化
・時間がかかる項目の取得設定の組み合わせを見直して高速化

●「詳細一覧」の高速化（効果大）
・上位階層への移動などのフォーカスを当てる処理の画面崩れの原因が特定できたので大幅に高速化

●オプションのツリーの初期値/設定の改修
・ツリーのトップレベルノードの初期値を変更
　a.Windows11用以外
　　デスクトップのみ
　b.Windows11用
　　ダウンロード、デスクトップ（階層なし）、PC、ユーザー、ネットワーク、ごみ箱、最近使ったファイルの列挙
・設定画面の変更
　a.追加位置を選択アイテムの前から後ろに変更
　b.項目レイアウトの調整
　c.一覧をダブルクリックすると編集する機能を追加
　d.表示名にカテゴリも付けて、少し分かりやすくした
　e.UUID/パスの指定画面で未選択状態でOKを押すと分かりにくいエラー文言になるのを修正
　f.「「すべてのフォルダーを表示」のまとめ設定」ボタンの追加
　g.「Windows11用のまとめ設定」ボタンの追加

●ツリーの挙動の追加
・ツリー上にあるlnk属性（拡張子は見ていない）をもつアイテムはシェル実行に変更

●リスト上のツールチップ
・ファイル名はタイトル部にセットしていたが、95文字以上の場合に本文に埋め込むように変更

●インサイドツリーのスプリッタ
・スプリッタの再構築をしないと色設定が反映されないのを修正

●オプションに属する子ダイアログで表示するヘルプの参照先が統一されていないので見直した
　a.メニューエディタ
　b.メニューコマンド編集
　c.マクロ入力
　d.フォルダ設定のオプション子ダイアログ
　e.コマンド定義編集
　f.拡張子連動コマンド
　g.スクリプト編集
　h.機能一覧

●仕様変更
・初期値および、各種テーマファイルの「フォーカス装飾」の太字をOFFに変更
※太字や大きいフォントの場合の当たり判定の差異の課題のため、制限ありの機能に降格

●その他
・画像リソース名がデフォルトままで滅茶苦茶だったのを整理
・テーマ描画のポップアップメニューで、ダイアログが親の場合はOSのダークモード適用を無視するように変更
・カスタムテーマのツールバーの▼などの描画フォントをWebdings/Wingdings3で固定して、環境依存の文字化けしないように変更

●不具合修正
・自動更新ボタンのツールチップ文言を修正
・ウィンドウに合わせてカラム幅の自動的に調整する設定が詳細以外にも干渉する現象に対処
・1フォルダあたり1億アイテムを超えていると画面が滅茶苦茶になる不具合の修正
※上限1億の徹底、また非常識に時間がかかるので再現テストは非推奨




Ver.16.5.9.0
●フラット系テーマの画面分割時のスプリッタ
・テーマ配色を適用

●インサイドツリーのスプリッタ
・テーマ配色を適用
・ドラッグイメージを大きく変更（点線にした、テーマ配色を適用）
・描画スタイルを3Dからフラットへ変更
・1ピクセル幅を大きくし、DPI係数を掛けるように変更
・コントロール座標の計算を間違っているところがあったので修正

●インサイドツリー
・フォーカスが当たった時にフォーカスアイテムがなるべく見えるように変更
・ノード指定された場合、遅延動作でフォーカスアイテムがなるべく見えるように変更
※フォルダーバーはリスト同士の取り合いが発生して操作性が悪くなるので未対応です

●ステータスバー
・設定フォントを適用するように変更
・ステータスバー上のアイコン画像をフォントに合わせて拡大/縮小するように変更
・ボタンの反応をダブルクリック→シングルクリックに変更

●タブバー
・タブセットの一覧のプレースホルダー(ID:39996)を使用できるようにした
・上記を使うように_TabMenuSetting.txtの更新

●ユーザー定義バー
・本体コマンドのスクリプトを自動生成するコマンドを追加
・コマンドメニューの定義ファイル(_UserBarAction.txt)に「本体コマンドの作成」を追加(ID:47035)

●デバッグバー
・自動非表示モードの場合のアイコン表示を追加

●ログバー
・自動非表示モードの場合のアイコン表示を追加
・ログ種別にベンチマーク項目を追加（下記の性能チューニングの効果測定用）
・オプションに設定追加

●テーマ微調整
・_FILMTN(FlatDark).thを微調整

●性能チューニング
・一覧用のフルパス生成時のメモリ転送回数を減らした
・ソートアルゴリズムのパラメータを自動調整するコマンドの追加(ID:35906)
※誠に遺憾ながら性能向上は誤差の範囲なので使用は推奨しませんが、全機能メニューには載せた

●初期設定ツール(Setting.exe)
・文言修正たくさん
・更新ファイルの一覧、ビューア画面、結果表示でウィンドウサイズに合わせて各種コントロールを動かすように変更

●画像付きボタンの改善
・1個当たり2～6バイト省メモリ化
・初期化処理のメモリ転送回数の削減
・動的生成するための派生クラスを用意
・配布書庫からフィルタをクリアの画像を削除(FilterClear.bmp)
・配布書庫にコマンドメニュー(Command.bmp)、ツリーを閉じる(TreeClose.bmp)のボタン画像を追加

●メインメニューバーの表示切替の追加(ID:33399)
※現行のメインメニューは、廃止予定なので当コマンドを足していません。
※メインメニューを非表示にした場合、ALT/F10で「よく使うメインメニュー」(_MainNormalCmd.txt)のメインメニューが表示されます。
　こちらのメニューは、Ver.17を想定しているため、現行のメインメニューと構成が異なりますので、ご注意ください。
　またALT+F/ALT+E/ALT+V/ALT+T/ALT+W/ALT+H/ALT+Aで子メニュー(_MainNormalCmd1～7?.txt)が直接表示されます。
・システムメニューに追加(左上の赤いフォルダーアイコン)
・全機能メニューに追加(_MainFullCmd.txt)
・よく使うメインメニューの「表示」に追加(_MainNormalCmd3V.txt)
・メインメニューをポップアップメニューで表示を追加(ID:33400)

●ツールバーなどに配置する想定のコマンド追加（暫定機能）
・画面分割時コマンドメニューの追加(ID:36804、_ToolbarDivMode.txt)
・ツールコマンドメニューの追加(ID:36805、_ToolbarTools.txt)
・ファイル操作コマンドメニューの追加(ID:36806、_ToolbarFileOperations.txt)
・新規作成コマンドメニューの追加(ID:36807、_ToolbarShellNew.txt)

●その他
・Ver.16の初期のコンパイルオプションでの分岐を削除(ツールチップ関連)
・リソースメッセージの文言修正多数
・デバッグバーとログバーのアイコン画像としてBaricon.bmpの更新
・フィルタとディレクトリ内検索のイベントハンドラをフレームからビュー内に移動
・ビューの初期化時のレイアウト調整は不要だったので削除
・Visual Studio 2022 17.8で追加されたコード分析対応(lnt-make-member-function-const)たくさん
※マクロ定義など、MS社の管轄している未対応箇所を除く

●不具合修正
・スクリーンセーバーを設定している場合に落ちる設定の組み合わせがある不具合の修正
・進む/戻る/履歴ボタンの活性化状態の切り替えが機能していなかった不具合の修正

●Windows11 23H2の不具合対応
・未走査のデスクトップでCOM比較でのソートを行う設定になっている場合に落ちる場合がある問題への対処
※STLかコンパイラのバグと、Windows11 23H2の性能劣化の仕様変更かバグの合わせ技
　Windows7のライブラリを2回走査すると安定する不具合と同じ現象




Ver.16.4.5.0
・クリップボードにテキストをコピーする処理の修正方法が間違っていたので修正




Ver.16.4.4.0
●Cppcheckによる静的解析対応
・主に初期化系の性能に関するものを40件くらい対応

●フォルダーバー/インサイドツリーのコンポーネントの更新
・INameSpaceTreeControl(Vista)からINameSpaceTreeControl2(7以降)に変更
※そのうち設定反映でコンポーネントの再構築が不要になるとか、機能が追加されるとかのメリットが出てくる想定
・Zipや7ZipのOSのアイコンが、ツリー上で見分けづらいので「その他」の指定色に変更(23H2対応の一環)

●その他
・メニュー定義ファイルのショートカット修正

●システムショートカット/キー割り当て/マウス操作を組み合わせることで多重表示され、操作しにくくなるためロールバック
・_ToolbarIconMode.txt/_ToolbarListMode.txt/_ViewMode.txtはMFC系のメニューに置き換えたのを戻した
・メインメニューを非表示にした場合のみ表示されるショートカットメニューが10種も同様

●不具合修正
・クリップボードにテキストをコピーする処理でメモリリークするルートがあった不具合の修正
※グローバルメモリのロック失敗のイレギュラーケース
・ネットワークパスの判定処理でメモリリークするルートがあった不具合の修正
※UNC表記のローカルファイル表記
・起動直後などステータスバーの描画が崩れる場合がある不具合の修正




Ver.16.4.1.0
●全スキンテーマ
・MFC系のポップアップメニューでOSのダークモードを適用

●追加スキンテーマ
・Flat(Blue/Black/Silver/Aqua)を追加
 a.フラット（ベタ塗り）イメージ描画の実装
 b.ステータスバー/メインメニューなどはフレーム背景色を適用
　※ステータスバーのタブセット名の表記は変化しない
 c.ツールバーはテーマのボタン色を適用
 d.各種ドッキングバーのキャプションをテーマのボタン色を適用
・これらを用いた同梱テーマファイルを3つ追加
 a._DarkMode(Flat).th
 b._FD(FlatDark).th
 c._FILMTN(FlatDark).th

●オプション
・機能一覧は全機能メニュー（_MainFullCmd.txt）を使用するように変更
・テーマ設定画面の文言修正とレイアウトの修正
・テーマの保存時に適用済みの値を使用していたのを、画面上の値を使用するように変更
・DDX/DDVでエラーになったOK/適用の処理を修正(50画面くらい)
・ページ切り替えの際にもDDX/DDVのチェックをするように修正
・誤字修正、綴り間違い修正

●ステータスバー
・キーボードモードとタブセットにツールチップを追加
・タブセット表示の最低文字数を5にした
・キーボードモード欄をダブルクリックすると_StatuskeySetMenu.txtのメニューを表示する機能を追加
・タブセット欄をダブルクリックすると_StatusTabSetMenu.txtのメニューを表示する機能を追加
※ウィンドウ管理バーを表示してないとき用
・ステータスバーのテキスト/アイコン/チップテキスト描画、サイズ計算を作り直して拡張性と動作の効率化を向上

●ウィンドウ管理バーのタブセット切替メニュー(_TabMngBarTabset.txt)
・タブセットの一覧のプレースホルダー(ID:39996)を使用できるようにした
・配布用のメニュー定義ファイルは上記のプレースホルダーを使うように変更
※既存の書き方も可で、上記のステータスバーから表示されるメニューと使い分けしても良いでしょう

●その他
・黒系のテーマでツールバー画像の視認性が下がらないように画像を補正
・ショートカットキーの重複を整理
・前回リリースしたメニュー定義ファイルの評判が悪かったので既存踏襲になるよう見直し
　同様に_MainNormalCmd7A.txtを追加
・FullStateOpen/FullStateOpenExで、当該でスクリプト１個目のみ「新しく開く」の動作に変更
・_ToolbarIconMode.txt/_ToolbarListMode.txt/_ViewMode.txtはMFC系のメニューに置き換えた

●不具合修正
・複数のスレッドから並列で設定を読み出す場合に予期せぬ挙動になることがある不具合の修正
・最近閉じたウィンドウバーのツールバーの表示を切り替えた際に描画が崩れることがある不具合の修正
・起動時のタブセットのActiveTabNoが範囲外の場合に落ちる不具合の修正
・保存時のActiveTabNoが不適切な値になるルートが存在する不具合の修正
・ツールチップテキストの本文は1024文字未満である必要があるのに、1024文字より長い部分を切り捨てていた不具合の修正
※ついでに「...」の省略文字表記を追加
・タブを保存しないモードの場合に、ウィンドウ管理バーのタブセットメニュー項目が非活性にならない不具合の修正




Ver.16.3.1.0
●初期設定ツール
・タイトル文言を修正
・説明テキストの文言修正
・上書き確認画面で、ユーザーが編集したファイル/新しい版が存在する/インストール先に存在しないファイルのみ一覧に表示するように変更
・ログの改行を修正

●システムメニュー（タイトルバーの左のアイコンで表示されるメニュー）
・「新しく開く」を追加

●メニュー定義構文の拡張
・POSITIONにLEFTを追加
　親ウィンドウの左上の座標を指定します。
【書式】
POSITION<TAB>LEFT

・TITLEを追加
　見出し目的で使う用途です。
　メニューから選択するとID:0（キャンセルと等価）するため動作しません
　MENUITEMコマンドを使用すると以下の記述と同じです。
　MENUITEM<TAB>タイトル表記のコマンド<TAB>0
【書式】
TITLE<TAB>タイトル表記のコマンド

・INCLUDEを追加
　同じパスにあるメニュー定義ファイルを読み込み展開します。
　なおINCLUDEして読み込んだファイル内のINCLUDE、DIRECTORYは無視します。
【書式】
INCLUDE<TAB>ファイル名

●メインメニュー系のメニュー定義ファイルを追加
・全機能メニューの定義ファイルを追加(_MainFullCmd.txt、後述の隠し機能や次版の機能で使用)
・よく使う機能のメインメニューの定義ファイルを追加
　_MainNormalCmd.txt内から以下の6ファイルを読み込む階層構造を持つメニュー定義ファイルです。
　a.ファイル(_MainNormalCmd1F.txt)
　b.編集(_MainNormalCmd2E.txt)
　c.表示(_MainNormalCmd3V.txt)
　d.ツール(_MainNormalCmd4T.txt)
　e.ウィンドウ(_MainNormalCmd5W.txt)
　f.ヘルプ(_MainNormalCmd6H.txt)

●隠し機能
・ヘルプ作成/リファレンス用に、全機能一覧.txt/全機能一覧.htmlをasr.exeと同じ位置に出力するコマンド（ID:36223）
※旧AllCommand.txtとの比較
　不足していた動的生成コマンドの追加
　ツールバー等への割り当て用の重複の削減

●その他
・ドッキングバーのフォーカス制御の計算処理を削減
・タブレット支援バーのフォーカス制御が一部未実装だったので追加
※デスクトップモードはフォーカスを受け取るコントロールが無いので未対処

●不具合修正
・ツリーの右クリックメニューの表示の際にメモリリークが発生する場合がある不具合を修正
・リスト上部のコントロールの再描画で、フィルタダイアログの表示後の対処漏れを修正
・MDIモードでウィンドウを閉じる場合、メインフレームに対する再描画が下位階層のウィンドウに反映されないドライバ依存の問題への対処を追加
・最近閉じたウィンドウバーとユーザー定義のフォーカス制御「フォーカスを失ったら非表示にする」が、テーマの「アクティブタブ背景色を使用」がFalseの場合に機能しない不具合の修正
・最近閉じたウィンドウバーの初回表示時のみ、即座に非表示にしてしまうことがある不具合の修正
・メニュー定義ファイルの誤記修正




Ver.16.2.0.0
●画面描画の改善
・リストの上部のコントロール群の表示制御を整理して、ちらつき低減と、まとめて開く系の処理効率を向上
・最近閉じたウィンドウバーのアイコン描画位置を調整
・デフォルトボタン画像が配色依存で視認性が悪くなるのを改善

●各種ビットマップボタンの表現の改善
・ホバー状態の描画を改善（テーマ色の適用）
・選択ステータス描画を改善（テーマ色の適用）
・非活性状態を実装

●新型のツールチップの作成と適用
・各種ツールチップのOSのダークモード適用
・再表示等を含めたディレイ時間の調整
・太字で描画されるタイトル表現を追加
　長いファイル/フォルダ名称の確認用
　タイトル部は98文字まで(コンポーネントの上限が終端NULL込みで100文字)
　はみ出すなら95文字以降に省略記号(...)を付与

a.ウィンドウ管理バー
　インフォチップの表示の抑制を追加
　現在タブをタイトル、関連情報を文面にセット
b.最近閉じたウィンドウバー
　インフォチップの表示の抑制して置き換え、分割状態等の情報など表記を追加
c.タブバー
　現在タブをタイトル、関連情報を文面にセット
d.タブレット支援バー
　対象アイテムをタイトル、補足説明を文面にセット
e.ユーザー定義バー
　対象アイテムをタイトル、補足説明を文面にセット
f.アドレスバー付近のボタン類の全て
　従来通り表示をすべて文面にセット（表示内容は改善の余地あり）
g.ファイルリスト
　表示トリガーを他のバーと同じ方式に変更
　タグ情報の補足表記を追記
　ここだけ極端に表示が遅い場合がありうるので(APIの応答待ちで最悪数分)、リスト単位でスレッド化して管理するようにした
※バックグラウンドスレッドが応答待ちの状態になったらエクスプローラーと同じように、OSから返事が来るまでツールチップが表示されなくなります。

●全機能メニュー定義ファイル関連（主にVer.17を見据えた改修で次回以降の布石）
・メニュー定義ファイルの機能拡張が3個
　機能するが不適切なロジックが残っているので調整中
・機能要件の検証のための試作機能の追加が10個(メインメニュー)
・メインメニューの撤去に伴った、個々のメニュー呼出しショートカットの追加が6個(ALT+F等)
・F10の横取り/メインメニューの呼び出しの仕組みの追加
・ALT装飾キーの無効化のための仕組みを追加

●その他
・プリコンパイル済みヘッダのコンパイラオプションを変更
　(全exeのプロジェクトを変更したが、ウィルススキャンソフトの誤判定が嫌なので未ビルド)
・組み込み系のユーザー定義メニューの親ウィンドウを子フレームからメインフレームに変更
・メニューエディタ画面のLoadTestボタンでのメニュー位置の初期値はマウス位置に修正
・タブバーを横置きした際のサイズを調整




Ver.16.0.3.0
●不具合修正
・表示モードの組合せによって、高速でスクロールさせると落ちることがある不具合の修正

●その他
・上記の不具合修正のついでに、アイコン等の取得スレッドの計算量削減、オブジェクトの初期化ロジックの改善、同期性能改善、メモリ転送量の削減など改善点が多数であるがほぼ誤差
・ウィンドウ管理バー/タブバーの太字の表現を複数回の重ね描きからボールドフォントに変更
・2画面モードの、分割ウィンドウのサイズ/日付を比較モードの場合のアイコンイメージを目立つ配色に変更
・テーマファイルの_DarkMode.thの説明を訂正
・隠し機能でヘルプ作成用の全機能一覧の作成コマンドを作成（まだ1/5）




Ver.16.0.1.0
●インストール/更新ツールの改修
・テーマ配布処理の追加
・初期設定のエクスプローラー風のテーマ対応
・画面内の説明文言を追加

●長いファイル名の視認性の向上
・共通
　テキスト幅計算をフォーカス装飾フォントをベースで考えるように変更
・コンテンツモードのレイアウト変更
　ファイル名が折り返しできるスペースがあれば折り返し表示するように変更
・並べて表示のレイアウトを大幅に変更
　設定依存せずに、スペースがあれば常に折り返し表示するように変更
　ドラッグ選択の当たり判定、ファイル名以外が分かるように格子色による塗分けするように変更
　「種類」や「サイズ」は下端に詰めるように移動
　表示の優先順位は「種類」よりも「サイズ」の方を優先に変更
・一覧
　フォーカス装飾描画対応の微調整

●色・フォント設定
・配色設定できる項目数が、従来比3倍くらいに増えた
・配色設定に名前を付けて保存する機能の追加
・テーマファイルのアップロードサービスの追加
・フォーカスのテキストフォントの太字、下線、斜体、大きいといった装飾設定を新規追加

●色・フォント設定へ移動した設定項目
・フォルダーバー(OSテーマ依存のため)
　1.クラシックスタイル
・タブ共通（設定ヶ所が分散しないようにするため）
  1.現在のタブと同じパスのタブが存在していたら強調表示(薄緑色
  　→配色指定に変更
　2.ファイル操作エラー時にロック疑惑のあるタブの強調表示(赤色)
　　→配色指定に変更
　3.現在のタブよりも下位の階層のタブの強調表示(紺色)
　　→配色指定に変更
　4.（現在のタブ）太字にする
　5.（現在のタブ）輝度を大きく変えて強調する
　6.（現在のタブ）枠線を付けて強調する
　　配色指定を追加

●キー割り当ての初期値の変更
・Yにインサイドツリーの表示切り替えを追加

●インサイドツリーの動作変更
・インサイドツリーの表示時にカレントディレクトリを展開するように変更
※存在しないネットワーク/リムーバブルメディア/USB接続デバイスなどを開こうとすると当分返ってこないので
　起動時/下記のまとめて切り替え系コマンドも除外
　またネットワークや仮想フォルダは連動設定によりスキップあり

●コマンドの追加
・現在のリストのインサイドツリーを表示(ツリーは初期展開)
・現在のリストのインサイドツリーを非表示
・全てのタブのインサイドツリーを表示
・全てのタブのインサイドツリーを表示(分割を除く)
・全てのタブのインサイドツリーを非表示
・次のウィンドウ(フレームAPI）
・前のウィンドウ(フレームAPI）
・インサイドツリーを同期

●Windows11の機能廃止に伴う関連機能の削除
・外部プロセスも含めたウィンドウの整列系の機能を全てリソースDLL、コマンド定義から削除
※exeコマンド自体は残しているので必要ならご利用してください

●画像の変更
・チェックロックモードのチェックボックス画像が見にくいとのことなので派手めに変更

●下記3メニューを共通メニュー処理を行うように変更（互換性維持のためNONOTIFY OFF、POSITION MOUSE固定）
　_ToolbarIconMode.txt(ツールバーのアイコンモードボタン)
　_ToolbarListMode.txt(ツールバーの表示モードボタン)
　_ViewMode.txt(リストの右下の表示モードボタン)
※共通メニュー処理にすることで、各メニュー項目を混在させることが可能になった

●メニュー定義関係の機能追加
・名称が変動する系のプレースホルダーにキー割り当てされたキーの表記を付与する仕組みを追加
・全機能表示メニュー用のプレースホルダーをたくさん追加
・NONOTIFI OFFの場合にキー割り当てされたキーの表記を追加

●その他
・コンパイラが大きく変わっているので全ビルドしなおした
・輝度計算式を人が分かりやすい数字を使うように変更
・デバッグバーの変数表示で、組み込み関数の場合も変数展開後の値を表示するように変更
・アイコンや詳細情報取得スレッドの管理の見直し､CPU負荷の削減と高速化、冗長な処理の整理、イベントの最適化などを行った
※Ver.15系比で、画面サイズに依存するが10～30%くらいの負荷削減




Ver.15.9.5.0
●不具合修正
・フィルタ/ディレクトリ内検索のボタン押下順/キー操作順によって画面上にゴミが残る不具合の修正
・「タブグループを閉じる」と「タブセットメニュー」のIDが重複していた不具合の修正
・ログバー/デバッグバーの、ツールバー/タイトルバーの情報管理/復元処理が未実装だったので実装




Ver.15.9.4.0
●不具合修正
・画面分割時にデバッグバーで実行したスクリプトは、?nowdir?系置換マクロに反対側のパスがセットされていた不具合の修正
・OneDriveがデスクトップに2個あるような環境の場合、更新が頻繁に発生する場合がある不具合への軽減策を追加
※エクスプローラーで見ても取得情報が異常ですし、同じフォルダーに同じパスのものが2個存在するWindows側のバグと思われます




Ver.15.9.3.0
●アイコン/詳細情報の取得スレッド制御の不具合修正（詳細/並べて表示/コンテンツ）
・詳細情報の取得ステータスの管理に問題があり、取りこぼすルートが存在したのを修正
・詳細情報の取得の完了済みフラグのセット漏れを修正
・ローカルサムネイルキャッシュが存在した場合、詳細情報の取得リクエストを送らない不具合を修正

●その他
・配布書庫を作成する7Zipのバージョンを更新



Ver.15.9.2.0
●安定性の向上
・設定ファイルの保存処理で上書きではなく、テンポラリ出力＋リネーム＋削除する方式に変更

●メニュー定義の機能追加
・ユーザー定義メニューの親を子フレームからメインフレームに変更
・メニュー定義ファイルにNONOTIFYコマンドを追加
　初期値はON
　NONOTIFY ONでメインメニューの状態を反映しない、OFFにすると活性状態/ラジオ/チェックボックスを反映
・メニューエディタのNONOTIFY対応
・メニュー定義ファイルにNONOTIFY OFF/POSITION MOUSEを追加
　（この変更が必須になるのはVer.16移行とします）
　_ToolbarIconMode.txt(ツールバーのアイコンモードボタン)
　_ToolbarListMode.txt(ツールバーの表示モードボタン)
　_ViewMode.txt(リストの右下の表示モードボタン)
・表示モード切替メニュー(リスト下部)コマンドの追加(ID:36803)

●操作性の改善
・シェルアクション系のコマンドの実行時に未選択の場合に警告表示を追加
※プロパティ表示、切り取り、コピーなど

●その他
・最近閉じたウィンドウバーをダブルバッファリングするように変更




Ver.15.8.9.0
●不具合修正
・現在の分母を最大値とする百分率の場合に描画漏れが出る不具合の修正
・スペルミス修正と文字化け修正が２個

●その他
・テーマファイルを読み込む機能を追加




Ver.15.8.8.0
●タブセット関連
・オプションでタブセット11～81の名称設定を追加
※タブセット11～81はカスタマイズ用につきメインメニューには反映されません
　起動速度低下を抑止するために、空文字がセットされていると以降の読み取りをしません
・タブバーとウィンドウ管理バーのタイトルバーに現在のタブセット名表記を追加
※ステータスバーの表示は性能上の理由から削除を検討しています
・ウィンドウ管理バーのタブセットメニューを修正（コメント行を追加）
・AsrLoad.exeに/tabsetオプションとタブセットの切り替えを追加
※続けて数値を記載することで、指定番号のタブセットに切り替える(1～81)
例)タブセット1に切り替える場合
Asrload.exe /tabset 1

●タグ関連
・タグ入力ダイアログに設定ボタンを追加
・オプションで絶対タグと相対タグの初期テキストの設定を追加

●その他
・タブレット支援バーの未使用処理を削除
・音声認識情報の管理構造体をクラスに変更
・テーマ指定の設定を通常設定と同じクラス内に移動
・その他設定をクラス化
・メインメニューでの設定をクラス化
・設定をカテゴリ分けしている孫クラスを整理
・不具合じゃないレベルの不整合をたくさん修正
・サイズバーの設定と状態の持ち方が、不思議な構成になっていたのを修正
・タブの色、強調色なども色設定に寄せた
・現在の色設定をファイル出力する機能を追加（読み込み機能は未実装）

●不具合修正
・MDIモードでタブを閉じた時に再描画がかからない不具合の修正
・拡張子色分けの設定値の文字数上限をセットしていなかったので260文字に修正
・フィルタ系のメニュー定義ファイルの説明コメントを訂正
・相対タグの表示設定が保存されない不具合の修正




Ver.15.8.4.0
●コード分析対応
・警告を100個くらい減らした（主にcast系）

●生成AIによる指摘(メニュー定義ファイル解析)
・メモリ開放の可否の判定の冗長性の解消
・ON/OFF指定するコマンドで、「ON」「OFF」以外の記述の場合に値が何もセットされない仕様を変更
　(文法間違いではないので、「ON」ならtrue、それ以外をfalseに変更)
　DIR_FOLDER
　DIR_FILE
　HIDDEN_ITEM
　DIR_UP

●OS不具合対応
・Windows10かつ、OSのダークモードを使用時かつ、ウィンドウ最大化状態で起動しようとするとタイトルバーの描画がされない件の対応
※MS社より、当該APIはWindows11以降でのみ正式対応という事になった

●不具合修正
・一覧/詳細一覧かつ、小さいアイコン以外の場合にEnsureVisble()で目的のアイテムが表示されないコンポーネントの不具合対応
※再描画フラグをOFFにした状態でEnsureVisble()をするので、スクロールしていくのが見えるようになり操作性は劣化




Ver.15.8.0.0
●高DPI環境でのレイアウト調整
・リストのカラム幅調整
　初期設定コマンド
　ファイル情報コマンド
　テキストコード変更コマンド
　ロックしたプロセスの検索コマンド
　バージョン情報コマンド
　オプション（修正箇所多数、テキストレイアウトも含む）
　タグ情報ダイアログ（本体）
・閉じるボタン描画
　ウィンドウ管理バー
　タブバー

●コード分析対応
・警告を150個くらい減らした（主にconst、constexprの宣言）

●ユーザー定義バー
・新規作成系の説明テキストを改善
・コマンドメニューの定義ファイルの構成と文言を修正
・リストのパスを登録コマンドを追加
・設定メニューの文言変更
　このバーのコマンド実行後の動作→フォーカス制御
　リストへフォーカス移動→コマンド実行後にリストへフォーカス移動
　このバーを非表示にする→フォーカスが失われたら非表示にする
・「このバーを非表示にする」の動作を文言通りの「フォーカスが失われたら非表示にする」に変更
・シングルクリックで開くのショートカットキーをS→Cに変更

●最近閉じたウィンドウバー
・設定メニューの文言変更
　このバーのコマンド実行後の動作→フォーカス制御
　リストへフォーカス移動→コマンド実行後にリストへフォーカス移動
　このバーを非表示にする→フォーカスが失われたら非表示にする
・「このバーを非表示にする」の動作を文言通りの「フォーカスが失われたら非表示にする」に変更

●ウィンドウ管理バー
・貼り付けなどの説明テキストを改善
・コマンドメニュー定義ファイルからタブセット系の機能を削除
・ツールバーにタブセットメニューボタンを追加して上記で削除したものを表示する機能を追加
※メニュー定義ファイルは新規追加

●不具合修正
・メモリが逼迫＋CPU高負荷時＋ディスクI/Oも高負荷の場合に、ごくまれに落ちる可能性がある不具合の修正
・GDI枯渇してOSの描画も不安定な時、描画が崩れる可能性がある不具合の修正が2件
・オプション→リスト→表示→初期値で、アプリ終了時に未開放のメモリリークしていた不具合の修正(実害無し)

●その他
・クリティカルセクションのカプセルクラスのオーバーヘッドを削減
・オプションの色・フォント画面の生成ロジックをブロック化して色設定の数を5倍に増やす仕組みを追加




Ver.15.7.0.0
●フィルタ設定画面
・フィルタ定義ファイルのフォーマットを変更
※TSVで2項→最大3項に変更なので上位互換あります。
・拡張子の「...」ボタンは常時使用可に、選択内容によってチェックボックスおよびテキストの活性化制御をするように変更
・開始日時/終了日時に「...」ボタンを追加
a.メニュー表示用途で、和名による指定をするための置換マクロを6個追加
b.日時用メニュー定義ファイルを新規追加
・ファイルサイズ指定に「...」ボタンを追加
a.メニュー表示用途で、和名による指定をするための置換マクロを2個追加
b.サイズ用メニュー定義ファイルを新規追加

●オプション
・メニュー定義ページに機能しないボタンが残っていたので機能削除
・フォルダー設定ページのツリーに表示する項目
a.システムで使えないものを非表示に変更
b.和名が取得できるものは、識別名(和名)という表記に変更

●確認メッセージの非表示設定追加
・「未選択状態で「選択アイテムを追加」を実行したときの確認」の非表示設定を追加（ユーザー定義バーのみ対象）

●サイズの単位表記の仕様変更
・単位が切り替わる閾値を超過が発生した場合にしていたが、剰余が0になるタイミングに変更
※エクスプローラー準拠の仕様で1024→1024/1025→1KBであったものを正しい表記にした1024→1KB

●その他
・タブレット支援バーの未使用巻数を整理
・サイズ変更時の再描画を一元化してちらつきを低減した
・クラスメンバーは初期化リストを極力使用してコンストラクタで初期化を行わないように変更(約70ヶ所)

●不具合修正
・既存のウィンドウサイズ変更時のちらつき抑制処理の真偽判定が逆になっていた不具合の修正
・CoInitialize/CoUninitializeをカプセル化し、COMの初期化と解放を自動的に行う仕組みを使うように変更
※スレッドプールで管理されたスレッドの場合、インスタンスの再利用の際にCOMの解放を行わない現象が発生するため環境依存の問題が発生しうる




Ver.15.6.4.0
●画面更新時のちらつき低減
・風車、時間、ステータスの自前で描いてるテキストの更新処理の見直し
・ボタン、リストの自動更新時の描画手順を見直し

●初期設定ツール(Setting.exe)
・AVX2を使えない環境では、AVX2版を選択できないように変更

●テキスト文字コード変換
・レイアウト/文言変更
・一覧から削除機能を追加
・UI制御を改善して誤操作を抑止するように変更
・未選択状態でのコード修正の場合にエラーメッセージを出すように変更
・変更前後でコードページが同じである場合に未処理にするように変更
・変更前コードページが不明なものが存在する場合、エラーにして処理継続するか確認するように変更

●オプション
・リスト→表示→表示共通に項目の追加
1.「隠し属性のアイテムの表示」
2.「.で始まるアイテムを表示（OFFにすると遅い）」
3.「ローカルサムネイルキャッシュを表示（OFFにすると遅い）」
・全体→タグ
1.相対パスのタグび表示設定と、説明テキストの追加

●その他
・テーマ切替時のドッキングヘルパーの構築速度が少し改善

●不具合対応
・_wfullpath()にGUIDを含むパスを渡すと先頭3文字を::{→::\{と変換してしまうので仮想フォルダは処理しないように修正
・テーマ無しの場合にグループアイコンの描画で落ちる不具合対応のため、グループアイコン画像の管理の仕組みから修正
　また再描画をスキップするパターンもあったのも同時に修正




Ver.15.6.0.0
●代替ストリーム(Alternate Data Stream)関連の正式化
・代替ストリームの件数表示コマンドのリソース類を追加
・「アクセスブロック属性の解除」を廃止して「代替ストリームの一括削除」に名称を変更
※exeなどは変更なし、全ての代替ストリームを対象と認識できる機能名に変更

●絶対タグ/相対タグ（As/Rユーザー同士の共有タグ）
・タグ登録ダイアログのUI制御/適用ロジックなどを作り直した
・タグ情報→タグ登録ダイアログのUI制御/適用ロジックなどを作り直した
・タグ登録の際に「絶対パス」/「相対パス」のラジオボタンと説明文言を追加
・「相対パス」を「タグ削除」コマンドで消した際、最期のタグを消したら「.LocalTag」を削除するように変更

●リストのツールチップ制御の改善
・処理手順を最適化して効率を向上
・デフォルトツールチップの制御を横取りして、なるべく抑制するように変更
・設定の組合せと、特殊な操作の組み合わせることで遅延が大きくなる現象を改善

●描画の調整
・リスト上の選択状態の復元の際に、ビュー単位での再描画処理に戻した
※ちらつき増、開く際の速度低下ありだがOS差異を吸収
・タブ単位でクローズ時の描画を抑制して若干の速度向上
・アプリ終了時の再描画を抑止して若干の速度向上
・ボタン、ドッキングバー等の部品のWM_PAINTの発生源を精査して15個くらい削減

●フレーム/ビューの管理の仕組みを抜本的に見直した
※全体的な高速化/処理の簡易化と、デバイスドライバ依存の差異が入り込む余地の削減
・タブセット切り替えを通常のスクリプト処理ではなく、専用の簡易スクリプト処理に変更
※タブの挿入位置の設定を無視するように仕様改善
・リストがアクティブになるまで走査しない動作の見直し
・画面分割の動作の全般的な見直し
・フレーム/ビューのアクティブ化制御の全般的な見直し
・フレームのウィンドウ状態/サイズを構造体からクラス化(アクティブ化制御で使用)
・起動時のフレームの1個目開かないようにする方法が見つかったので起動時処理とタブセット切替を見直した

●高DPI対応
・ユーザー定義バーで一覧表示しない場合のアイコン画像の拡大表示の正式対応
・タブレット支援バーのアイコン画像の拡大表示の正式対応
・最近閉じたウィンドウバーの拡大表示対応

●その他
・Setting.exeでソースコードの文字コード判別を間違うコンパイラの不具合に対応
・本体のコンパイラオプションをISO C++20に変更
・メニューに表示しているタブグループの色見本の画像をテーマ切り替えに連動するように機能追加
・グループの最大値が2重管理になっていたので是正
・最近フレームワークが自動挿入するメニューの処理で警告が表示されるようになっていたので未処理になるように変更
・次/前のタブ(Zオーダー順)の循環型が簡単にできたので試験的に機能追加（ID:35813,35812）




Ver.15.4.8.0
●アドレスバー
・ipconfigなどで取得できるIPv6アドレスを、アドレスバーへの入力でIPv6形式のナビゲート可能文字列に変換する機能を追加
ローカルホストへループバックする例)
「\\::1(%スコープID)/(共有名)\」→「\\--1.ipv6-literal.net\(共有名)\」

●ログバー
・設定メニューの中に「名前を付けて保存」を追加

●OSのダークモード（Windows11のみ）
・OSのダークモードを使用する設定になっている場合、アプリの描画にフックを掛けてリストのスクロールバーの描画を置き換える処理を追加
※本体内の全てのListCtrlや、オーナードローできないComboxExにも適用される

●アクセスブロック属性の解除コマンド
※Ver.15.5.0.0で機能名を「代替データストリームの一括削除」に変更する予定です。
・機能ボタンの表記/タイトルバーなどの文言を修正
・「アクセスブロック属性のみを対象にする」オプションを追加
　チェックを外すと、全ての代替データストリームが対象
・文字列宣言が古い形式になっているコードを修正

●代替データストリーム処理全般
・代替データストリームの読み/列挙はかなり古いコードだったので、Vista以降のAPIで書き直した
※本体、Info.exe、RemoveZoneID.exeに影響
・ファイル情報コマンドで、代替データストリームのタイプ名の種類は名前見ればわかるので表示を削除した

●上級者用タブセット
※上級者向けの機能という扱いで、スクリプトのPostMessageやメニュー定義での用途に限定
・タブセット11～80(ID:33810～33880)まで使用可能にした
・タブセット番号が0～9の範囲外の場合に落ちる不具合の修正
・タブセット11以降のステータスバーへの表示を追加

●イベント駆動スクリプト「プレビュー表示発生」の改善
・プレビュー開始トリガーに厳密に沿うように変更
・プレビューバーへの表示と排他にして、外部のプレビューアプリを使用するスクリプトが組めるようにした
・スクリプト実行後、自身にフォーカスを戻すように努力するようにした

●その他
・テーマ色が外部コマンドに広げられるように色設定を統合しようとしたが(全体の1/5程度)
・ビルド警告を修正(4個)
・並べて表示の描画座標を微調整
・プレビューバーとの連携処理で、冗長な初期化/判定処理を整理した

●不具合修正
・スキンテーマによってアドレスバーの背景が真っ黒になる不具合の修正
※GetSystemColor(COLOR_WINDOW)をセットすべきところ、COLOR_WINDOWをセットした大ポカ




Ver.15.4.0.0
●代替ストリーム(Alternate Data Stream)関連の強化
・サムネイル表示の最優先に、代替ストリームが存在した場合は名称を列挙する機能を追加(背景が薄黄色のテキスト)
　オプション→リスト→アイコン→サムネイルに設定を追加
・代替ストリームの件数表示コマンドの各種リソースの追加して各種バーやメニューに配置できるようにした

●見た目の変更
・本体ダイアログを自前描画に変更し、スキンテーマに沿った配色に変更
・ダイアログ内のコントロールは概ねカスタムドローに変更
・各スキンテーマごとに色調の調整、特にOffice2007(黒)は全色変更
　（タブ、各種背景、モード切替系など、50色くらい×11パターンを調整）
・テキストのみ型のボタンの描画を今風（凹まない）に変更
・アドレスバー/ディレクトリ内検索/フィルタの背景色はOSのダークモードの設定ではなく、スキンテーマに依存するように変更
・ログバー、デバッグバーでWindows11はレイアウトが崩れるのでダークモードの適用をやめた
・タブバー/ウィンドウ管理バーのフォーカス/アクティブタブを目立たせるように変更
1.選択/非選択の色調の調整
2.枠線を太くした
3.矩形の範囲の調整
5.強調のためのアクティブタブの輝度の下げ幅を調整、特にOffice2007(黒)は輝度を上げるように変更
4.グループに含まれるタブと、含まれないタブのテキスト色を変えた
5.アクティブタブの文字色をテーマごとに固定にした

●ExRunスクリプト変更
・ExRun登場時のRunWait、ShowWindow、TimeOutを覚えない仕様バグを修正
・BootDirが指定されている場合、ExRun登場時ではなく実行時に置換マクロを展開していた不具合の修正
・ExRunの組み込みコマンドで、OSのシェル実行を行うShellExecuteを追加

●不具合修正
・マウスジェスチャで閉じる系のコマンドが実行された場合、オブジェクト破棄の順番が狂って落ちる不具合の修正




Ver.15.3.1.0
●情報コマンドの改修（Info.exeの「フィル情報」ダイアログ）
1.レイアウトを疑似タブによる画面切り替え型、自前で画面サイズを可変に変更
2.テキストとアイコンのコピーボタンを統合
3.ファイル情報（Info）で代替ストリームの個数を表示する機能を追加
　置換マクロに代替ストリームの個数を示す$AlternateDataStreamを追加
4.アイコン情報（Icon）の表示件数を増加
　アイコンサイズのコンボボックスを小/中/大の3段階から、16/32/48/64/96/128/192/256ピクセルの8段階に変更
5.代替ストリーム(ADS)で、名称一覧と内容のバイナリ(HEX)/アスキー(ASCII)/混合(Mix)表示する機能を追加
　指定した代替ストリームの削除機能を追加

●パス文字列からITEMIDLISTへの変換で、全ての公開APIで変換できないパス(USB接続されたAndroidの「内部共有ストレージ」など)の動作改善
・22H1以前で大丈夫であった相対取得もNGなので、EnumObject経由で取得して結合するように補完する処理を追加
・テキスト変換時に、この手のパスを飛ばした文字列にならないように修正（上位階層へ移動、アドレスバー文字列、自動生成スクリプトなどに影響）
※「(フルパス)\存在するが公開APIで取得できないパス\hoge」と「(フルパス)\hoge」が同一と見なされる現象でエクスプローラーでも同様に発生

●スクリプト変更
※Existを使うべきという仕組みであったが分かりにくい
・IsDirecty、IsFileで対象が見つからない場合はNot Foundのメッセージを出すように変更

●ユーザー定義バーの改善
・「選択アイテムの登録」で未選択の場合のスクリプト名称を決定する際に、なるべく人が理解できない名称を避けるように変更
　また上記のイレギュラーなパスも取得可能となった

●As/Rユーザーだけ見えるタグ(仮称、暫定)
・リンク切れタグの削除機能でローカルタグを対象にするように機能追加

●リスト上のアイテムを走査して、代替ストリームの件数を表示するコマンドの追加(ID:33322 仮称で暫定)
※走査対象はフォルダサイズ計算と同じで、選択しているものか、未選択の場合は現在のフォルダーの全てが対象
　リストの項目名の横に代替ストリームの件数を表示する
　暫定実装につき、スクリプトによるPostMessageコマンド以外で使えません

●不具合修正
・OSによってスリープから復帰した時に未走査のタブで「引数が不正です」というエラーが表示される不具合の修正
・オプション反映時に「引数が不正です」というエラーが表示される可能性がある不具合の修正
・パス表記の揺れを補完する処理を追加
※結果として「\」「/」「|」などのパスとして使えない文字の含まれるフォルダーのタブやタイトルバーの表記が変わる
・一括新規作成で、パス名に使用できない文字は全角に変換するように修正
・選択状態の判定でチェックボックスを見ない条件がある仕様の不統一を修正
1.ディレクトリ内検索の「選択/解除」
2.ユーザー定義バーの「選択アイテムの登録」
・デバッガで未選択状態でブレイクポイントをセットしようとすると落ちる不具合の修正
・スクリプト制御の不具合修正（?SelFile?等でフルパスではなく相対パスで渡している）
1.ユーザー定義バーから、選択状態の下位階層を開くコマンドの引数
2.ユーザー定義バーから、選択状態をスクリプトに渡すコマンドの引数




Ver.15.2.6.0
●アドレスバーの改修
・EraseBackGroundの塗りを追加して枠塗り領域を増やした
※オーナードロー不可なので色付けは背景のみ
・OSのダークモード時の色塗り対応

●起動/終了/タブセット切替の高速化
・リストの初回走査前のコントロールの初期化を更に減らした（1タブあたり2割くらいの速度向上）
・強制的に全て閉じる際に不要となる冗長な処理を飛ばすように変更

●リストのツールチップ
・戻る/進む/上位階層の長押しの説明を追加
・履歴と上位階層の説明が入れ替わっていた不具合の修正

●アクセスブロック属性の解除
・代替ストリームのサイズを0にするのではなく削除するように変更

●その他
・グループ内の個数を数える処理の呼び出しが残っていたので削除（個数管理に移行済み）
・未使用の変数の整理
・タイトルバーの表示設定で無駄にグローバル変数を使っていたのを修正
・表示モード設定ダイアログの並び順のリストの幅を動的に計算して見栄えを改善




Ver.15.2.3.0
●独自の進捗ダイアログからOS標準のものに変更
　処理に時間がかかる場合に遅延で表示され、概算の残時間が表示がある。
※CpMv.exeは後から考えるモードがあるので不可、フォルダサイズ計算は遅延表示が遅すぎて使い物にならないため不可
1.FileDelete.exe
2.FileAttribute.exe

●ファイル一覧生成/アクセス不能状態からの復帰の手順の変更
・パス文字列からITEMIDLISTを求める際の処理を精査し、簡単な取得で良い場合は動作の早い変換処理を使うように変更
・上から順に移動可能なパスを求めるロジックを使わないように変更
・デスクトップ階層にぶら下がるパスへジャンプする際、存在しない場合は通常フォルダと同じエラーになるように変更
　（エラー時にアドレスバーに表示が残る）
・走査に失敗してエラー状態かつ、アドレスバーに何らかの文字列が残っている場合、アドレスバーのテキストをもとに上位階層へ移動する機能を追加

●ダークモード
・Windows11はリストコントロールに対してAPIでダークモードにしないように変更
　※暫定対処、操作性が変わるため非推奨にしていたが、不具合と思われるので未対応にした
・詳細表示のヘッダを自前で塗るように変更

●その他
・15.2.0.0で修正した未走査のタブ名の取得処理の速度を改善（非推奨APIと同じ表示名になった）
・同様にお気に入りタブの名称テキストの生成速度を改善

●不具合修正
・リストの全更新の際に「引数が正しくありません」のエラーメッセージが表示されることがある不具合の修正
・オプションのメニュー定義画面の「コマンド一覧ファイルを参照する」の当該ファイルは配布終了になっているのでオンランヘルプに修正
・テーマ無しの場合、グループ無しのタブの色が黒くなる不具合の修正




Ver.15.2.0.0
●画面周りの改修
・2画面モードで非アクティブなリストのアドレスバーの表示テキストを暗くして、アクティブ側の視認性を向上
・フィルタと、ディレクトリ内検索のテキストボックスの見分けにくかったので色付けした
・リスト画面上のコントロールのレイアウトと見た目に関わる属性を微調整
・各コントロールのウィンドウハンドルの取得処理を整理と、無駄を省いた高速化が多数
・表示モードボタンの説明ツールチップを追加（サムネイルサイズ/原版サイズも表示）
・並び順ボタンにツールチップを追加
・スタティックコントロールに似せた描画のレイアウト微調整
・GDIオブジェクトの使いまわし率を向上させ、一時的に使用するリソースをケチる方向に変更(一部のみ)
・リスト描画のレイアウトの微調整(全モードで数Pixの微調整が多数)

●「OSのダークモードを適用」設定がONになっている場合の動作
・アプリ単位での適用を有効にした(ライブラリ管理外のメニューなどが影響)
・フィルタとディレクトリ内検索のテキストボックスの改修のついでにダークモードも作成

●高DPI環境の改善
・フィルタ、ディレクトリ内検索のサイズ補正処理を追加

●Windows 11の非互換対応/不具合対応
・mspaint.exeのパスが版ごとに異なる問題への対処
　1.エディタで開くのスクリプト（Editor.txt）の初期値を変更
　2.テンプレートの雛型のコメントを修正
・最近のWindows11 22H2の性能低下対策として再描画処理を一部最適化
・Windows11で発生するちらつきを低減
・Windows11 22H2で顕著になるちらつきを低減
・デスクトップのダウンロード/ドキュメント/ピクチャ/ミュージック/ビデオを列挙した中から除去するように変更
※これらの下位のフォルダで更新が発生すると、デスクトップ上の項目が2件になったり挙動がおかしい
　エクスプローラーでも延々と増殖するのでOS仕様か否か不明
　また更新通知がループするので抑制するように変更

●その他
・推奨されない無名構造体の使用数を減らした
・タブを新しく開く処理速度を少し改善
・走査していないタブも仮想名称を取得できる手法に変更した
　(旧処理は速いが、非推奨になったAPIなので移行を検討中)

●不具合修正
・ツールバー上のボタンのアイコン切替メニュー/表示モード切替メニューで、スクリプト系のコマンドが動いてなかった不具合の修正
・アドレスバーの色変の更済みが検出できないパターンがあり、再描画の効率が悪くなっていた問題の修正
・表示モード設定画面の初回表示時に、詳細系の並び順が表示されない不具合の修正
・タブセットの切り替え時に正しく並ばないことがあるらしいので、スクリプトの実行は新規スレッドではなくUIスレッドで処理するようにしてみた（再現方法不明につき暫定措置）
・画面分割時の同期移動がONでネットワークパスの場合にパス名加工に失敗していた不具合の修正




Ver.15.1.2.0
●自動更新の処理の改善
※元々エクスプローラーと比較して桁違いの性能差があったため、よほど過酷な環境でないと体感速度に差は出ません。
　消費電力やCPU使用時間が減った程度に考えてください。
・自動更新のON/OFF切り替えボタンは、再描画した時にリセットされないように仕様変更
・シェル通知モードはWindowsの不具合(MS社のサンプルでも再現)で通知が止まらない前提の実装に変更した
・削除を検出した際の処理速度が1～6倍速に向上（選択状態依存）
・追加/更新/リネームを検出した際の処理速度が1000～2800倍速くらい向上

●WindowsのDefenderおよびSmartScreenの誤検出対策
・インストーラー同梱版の7zip自己解凍モジュールを最新に更新




Ver.15.1.0.0
●高DPIモードの改善
・タブバーを除いて全てのドッキングバーがどこかにくっついている場合、縦横問わず幅を自前で保存/再現する仕組みを実装

●ステータスバー
・DPI値の表示を追加
・タブセット名を表示しているが、分かりにくいので背景色を塗ってみた

●新しく検出されるようになったC++20のエラー対応（MFCが完全対応していないので暫定）
・ローカル変数の未初期化対応
・for earch記述を全て廃止してRange記述に変更
・クラス特定の宣言を全て廃止
・リテラル文字列はconst付きとして扱い、全てキャストするように修正
・条件代入文の両辺でリテラル文字列と動的文字列の型をキャストして揃えた
・gotoによって初期化されない変数の修正




Ver.15.0.8.0
●チップテキスト取得処理の改善
・動作しない廃止APIの呼び出しが残っていたので削除
・メモリ管理インターフェイスを共通からローカルに変更
・権限関連で、情報取得に失敗した場合に落ちる可能性がある不具合の修正
・致命的な不具合があるアプリから情報を取得する際、外部要因でメッセージの取得に失敗した旨を表示するようにした
※なるべく「ツールチップテキストから、不適切なメモリ管理をしている外部アプリを検出しました。」をチップテキストで表示します。

●サムネイル画像の改善
・リストの縮小版/リストの背景/ドッキングバーの背景/ローカルサムネイルキャッシュの作成コマンドで、小さい画像を拡大する際の画質を改善(Windows8以降の機能)
・リストの縮小版で元画像がある場合の画質と速度の改善

●スレッドの停止処理
・新方式をフォルダサイズ計算スレッドの中断処理のみに適用、中断時のレスポンスが向上

●高DPIモードでの改善
・ユーザー定義バー/タブレット支援バーの表示を改善
※アイコンモードは操作できない事もない程度の暫定(アイコンが横長)
・タブバーの初期サイズを計算/描画するようにしたらDPI換算されたので採用した

●その他
・ドライブ移動コマンドで使用する、各ドライブごとのカレントディレクトリ情報の読み書きを最近の作法に書き直した

●不具合修正
・「現在のタブのみ」の復元スクリプトを生成する際、使えない文字が検出できない組合せがある不具合の修正
・ユーザー定義バーの「選択アイテムを登録」コマンドの登録名で「|」、改行、タブ文字が含まれている仮想フォルダが登録できない不具合の修正
　また使用できない文字は除去ではなく、半角→全角に変換するように変更した
・スクリプトのBackgroundImageでOne指定際に余計なウィンドウを対象にしていた不具合を修正
※冗長な記述になっていたので作り直した




Ver.15.0.5.0
●その他
・画面分割時の上下パスへの同期移動のパス文字列生成を、パス文字列クラスに置き換え「/」区切りのパスも同期移動できるようになった
・As/R同士のプロセス間通信の仕組みを実装
※以前のアンケートにあったのでエンジンを作ってみたものの具体的な内容が不明なため利用も未定

●不具合修正
・輝度を上げるコマンドでBYTEの桁あふれ検出の際のキャストの解釈が変わっていたのを修正




Ver.15.0.4.0
●Ping処理の改善と接続安定性の向上
・初期化を遅延処理することで未使用時の起動速度を向上
・ライブラリの動的読み込みをやめ静的リンクに変更
・古いWindows updateで対応済みのOS不具合の補完処理を削除
・Pingの成否と戻ってきたエラーメッセージをログバーに出力するようにした
・複数のネットワークアダプタを持っている機器の接続安定性を向上
・ネットワークの組み方依存でipv6の疎通確認が失敗する可能性がある問題への対処

●スクリプト
・CreateNowRestoreScriptスクリプトコマンドを追加
　指定されたファイル名で、現在のタブ構成の復元スクリプトを作成する。
【書式】
　CreateNowRestoreScript=[出力モード(1:現在のタブ/2:全てのタブ/3:一旦閉じる＋全てのタブ/4:タブセット)],出力ファイルのフルパス
・エラーメッセージを統合/整理した

●ここからコマンドプロンプト系
・ネットワークや仮想フォルダも起動対象に変更した(PowerShellはネットワークパスが使えるため)

●その他
・文字列生成クラスを機能拡張
　(なんちゃってStringBuilderで、終端のアイテムを消したり、間に\記号を入れた文字列を生成したり)

●不具合修正
・ユーザー定義バーのツールバーの検索ボタンのツールチップが出ない不具合の修正
・まれに終了時のタブ状態を保存し損ねる可能性がある不具合の修正(既存バグでスレッドのビジー状態が影響するため規則性無し)
・Windowsの終了時に現在のタブセット/最近閉じたウィンドウを保存しない場合がある不具合の修正
・閉じた時のタブの位置の設定が機能しなくなっていた不具合の修正




Ver.15.0.0.0
●開発環境をVisual Studio 2022に変更
・SDKを現時点の最新に更新
※ランタイムの更新が必要になります。ご注意ください。

●メインメニュー
・お気に入りタブコマンドの1～10を追加（表示は設定パス）
・子ウィンドウの最大化を追加
・ソフトウェアキーボードを起動するコマンド(ID:35520)を追加
・タブセット1～10の切り替えコマンドを追加(ID:33800～33809)（表示は設定名）
・タブセット設定(ID:33889)を追加
・プレースホルダー項目の整理をして生成速度が向上したが、機能追加の分だけ相殺

●タブセットの切替機能（旧名称：アクティビティ）
・「アクティビティ」が分かりにくいという事で「タブセット」に改名、また管理レジストリや管理ファイル名も変更
・アプリの起動時に既存の復元タブの仕組みは廃止、タブセット情報を読み込む簡易的なスクリプト解析に変更
・アプリの終了時に現在のタブセットを保存するように変更
・タブセットの保存時にActiveTabNoの出力を追加
・デフォルトのキー割り当てで、Ctrl+数字にタブセット切り替えを追加
・ウィンドウ管理バーのコマンドメニューにタブセット関連の項目を追加と、UI制御を追加
・タブバーの設定メニューにタブセット関連の項目を追加、また項目を見直して項目を大量追加し、UI制御も大量に追加
・ステータスバーに現在のタブセット名称の表示を追加
・現在のタブセットを規定のディレクトリに保存するコマンド(ID:33888)を追加（キー割り当て専用）
・現在のディレクトリに現在のタブセットのバックアップ保存するコマンド(ID:33887)を追加（キー割り当て専用）

●スクリプト
・ActiveTabNoスクリプトコマンドを追加
　タブバー上にあるタブの何番目を選択状態にするかを指定する。
【書式】
　ActiveTabNo=[タブバーの並び順で何番目かを指定]
・CreateRestoreScriptの廃止
※LastTab2.datの書式のバックアップを作成するコマンド、この書式の廃止に伴った措置

●タグ
・絶対パス指定タグで、大文字小文字を区別設定を反映を追加
・絶対パス指定タグで、非表示設定の反映を追加
・タグ削除コマンドでローカルタグを対象にするように機能追加

●オプション
・キー割り当て画面にて、未登録IDをセットした場合に機能一覧画面で確認できるように改善
・タブセットの設定画面を追加
・タグの設定画面を追加
・性能低下が大きすぎるため、終了時のタブ保存/復元スクリプトへの移動履歴の保存を廃止

●その他
・Shiftを押下して起動した場合、前回のタブ構成を無視するだけではなく処理確認メッセージを表示して選択ができるように変更
・UI操作をまとめて行い、並列可能な処理と分離することで「ロックされているウィンドウもすべて閉じる」の見た目が速くなった
・設定関連の構造体を全てクラスに変更
・ビルドの際の警告レベルを最高に変更し、警告への修正対応（警告数が約1000→問題なしの約300個）
・パス文字列の分解アルゴリズムの改善
・コマンドの連続起動処理をモダン化/省メモリ化/高速化
・お気に入りタブのメニュー表示処理を共通処理にまとめた
・お気に入りタブで保持しているフォルダ情報を全て破棄するコマンドの追加（ID:35838）
・アプリの終了処理を見直して、必ずしも必要ではない処理や、冗長な仕組みを改善
・ロックされているウィンドウもすべて閉じるコマンドの場合、最近閉じたフォルダーの履歴に含まないように変更
・混同する問い合わせが減らないので、ステータスバーに32ビット版/64ビット版の情報表示を追加
・アイコン画像のジャギの塗りや色相を調整
・ヘルプと突き合わせていたら、キー割り当て不可なコマンドが見つかったのでいっぱい修正




Ver.14.7.8.0
●ユーザー定義バー（お気に入りやランチャ等）に現在の階層以下を検索する機能を追加
※検索ボックスではEnter/TAB/ESCでバーの一覧にフォーカスが遷移する
・Ctrl+Sで検索ボックスの表示/非表示の切替、フォーカス移動する機能を追加
・ツールバーに検索ボックスの表示を切り替えるボタンを追加
・検索結果の場合はディレクトリが存在しなくなるので、ツールチップのTypeの表示をやめスクリプトのフルパスを表示するようにした
・複数階層の同時表示に齟齬が生まれないように、リネーム/削除/上位階層へ移動は禁止するように変更
・更新の際に検索モードを終了するようにした
・検索モードの際にタイトルバーの表記を変更するようにした
・ユーザ定義バーからの実行時に現在のパス情報を使用していたのを修正（走査/列挙時のパスを使うのが正）

●CMFCPopupMenuの全廃して統一
※メニュー内のアイコン画像が消えるが、アプリ単位のダークモードにした場合に適用されるようになる
　フレームワークが制御している「メインメニュー」「システムメニュー」「バー表示メニュー」は対象外
・タブバーの右クリックメニュー
・ツールバー上のアイコンモードメニュー
・ツールバー上の表示モードメニュー

●不具合修正
・ウィンドウ管理バーのコンテキストメニューの定義ファイルに不要なセパレータが入っていたので削除

●その他
・アクティビティの定義ファイルはユーザー情報の管理ディレクトリの下にActivityを作成して格納するように変更
※どこまで使うか不透明だが個人的に10じゃ足らない気がしてきため




Ver.14.7.1.0
●詳細カラムの改善
・ごみ箱、PCの詳細カラム情報の取得速度を向上
・起動時に読み込んでいた詳細カラム情報を遅延読み込みするように変更
・微妙な省メモリ化と微妙な高速化
・管理クラスをテンプレートにして再利用可能にした（たぶん二度と使わないけど）
・通常フォルダーのカラム数上限の撤廃
・ごみ箱、PCの詳細表示のカラム幅/項目の並び/ソート順等を覚える機能の追加
※ただしWindows11は、OSの仕様(不具合?)で勝手に設定幅が補正されるので注意してください

●Windows11のOS不具合の対応
・Homeなどのリストに並んでいる「デスクトップ」を実行して遷移しようとすると異常なITEMIDLIST構成を返してくるため、テキスト変換して遷移するように変更
・Windows11の「デスクトップ」にある「デスクトップ」は無意味で邪魔なので非表示にした

●復元スクリプトの強化と改善
・MDIモードの復元スクリプトを作成する際に「子ウィンドウを元に戻す」(PostMessage=35913)を埋め込むように変更
・復元スクリプトの生成の際に、手作業で編集しやすいようにコメントも生成するように変更
・復元スクリプトの生成を共通処理化

●その他最適化
・特殊な詳細カラム構成を持つXPのマイネットワークの検出を削除
・並び順のセット方法に古い考え方が混じって複雑になっていたので整理
・並び順のメニュー項目のセット方法も同様
・タグ情報の増減処理のメモリ転送回数を減らした
・文字列をレジストリから読む際のバッファの確保をあらかじめしておきメモリの確保/解放処理を大量に減らした

●不具合修正
・タグの削除機能が機能しなくなっていた不具合の修正
・リンク切れタグの判定で大/小文字を区別していなかった不具合の修正

●今後の準備
※当面はテスト運用で、Ver.15以降で正式版とする予定の機能です。
・アクティビティ切替（現在のタブをセットにして自動保存＋まとめ切替する機能）の追加(ID:33800～33809)
・As/Rユーザーだけ見えるタグの読み込み、表示、ツールチップ表示などの諸々の処理を追加
　ファイル名：リストで開いたフォルダーに「.LocalTag」があれば読み込む
　書式：TSV、改行はCRLF、UNICODE、BOMの有無は問わない
　[リスト上の表示名]<TAB>[コメント]<TAB>[色(RGBの10進数表記)]<TAB>[対象ファイルの属性]
・Windows10 1909以降でアプリケーション単位でのダークモード（ほとんどのメニューなどが黒くなる）を適用する隠し機能の追加
[HKEY_CURRENT_USER\SOFTWARE\AMA_Soft\ASR\Main001\Color]
"OsDarkApp"=dword:00000001(デフォルトは0)
・タグの配下ディレクトリのタブの色分けの仕組みを作ってみたが期待する性能の1/100しか出なくて封印
・アクティブタブ切り替えるスクリプトコマンドを追加したが、非同期で遅延処理をしまくる復元スクリプトに入れても動作しないので保留




Ver.14.4.8.0
●Microsoft社が、正式対応する気が無さそうなWindow10の不具合対応
・ネットワークの共有名のフォルダーに貼り付け/ドロップを行った場合、以下のメッセージを出して代替処理を選択できるようにした
「Windows10の不具合（エクスプローラーのツリーで発生します）で、共有名のパスにはシェル機能を用いた貼り付けが許可されていません。
一般的なファイル操作でファイルのコピーを試みますか？」
※貼り付け/シェル機能を用いたドロップに失敗した場合のみ、このメッセージを出すか否かの判定をしますのでInsiderPreview等の適用済みなどMicorsoft社が不具合対応したWindow10では表示されなくなります
※既知の不具合に執筆済みですが、Micorsoft社からはBuild 19603で対処したと回答がありました。
　その回答から2年半経過し、一般向けのWindow10のビルド番号が19603に到達する見込みが無いと判断したという経緯です。

●その他
・本体でWindows10/11の判定処理を追加
・起動時のOSチェックにおいてWindows11の判定を厳しくした
・Windows11だけで起こるCOMインターフェイスの欠如現象（Windows updateの不具合と思われる）の回避処理を追加
・対象フォルダにドロップ可能か否かの判定処理のインターフェイスのポインタ制御をスマートポインタに置き換えた
・タグの情報と制御処理を分離、またコードを今風に書き換えて若干の高速化と省メモリ化
・ファイルリスト上のタグの描画を高速化
・OSの不具合対応関連で共通関数の変更をしたので全ビルド

●不具合対応
・フォルダー作成のダイアログ画面のサイズを変えた際に、漢数字のチェックボックスだけ動かない不具合の修正

●プロトタイプ検証（性能評価中なので隠し機能扱い）
・既存のフルパスタイプのタグで大/小文字を区別しない設定を追加
　[HKEY_CURRENT_USER\SOFTWARE\AMA_Soft\ASR\Main001\Tag]
　"CaseSensitivity"=dword:00000001（0にすると大/小文字の区別をしない）
※大分マシになったけど、区別しない設定にすると若干の性能低下があります




Ver.14.4.5.0
●フォルダ作成コマンド
・連番の数字の作成で、漢数字のオプションを追加
※「第五回」のような連番の作成用

●不具合修正
・ユーザー定義バー上で削除のダイアログが表示された時、背景が白くなる現象への対処
 （APIへ渡す親ハンドルをリスト→メインフレームに変更しただけ）




Ver.14.4.4.0
●各種フォルダジャンプの発生時の仕様変更
・ロックされているタブに対して、ツリーやお気に入りなどから「移動」が発生した場合にアクティブタブのグループの影響を受けるように変更

●ウィンドウ管理バーの強化
・タブ上の右クリックメニューの「ここから開く」「ここからバックグラウンドで開く」で対象ウィンドウ情報を渡すように変更
・上記の定義ファイルのコメントアウトを解除

●オプション
・オプションの表示モード管理が古くなっていたので本体に合わせた
・アイコン（隠し）/アイコンのみ（隠し）の表示モードの補正値が不適切であったのを修正
・初期値、format系、switch文のフォロースルーコメント等、コード分析対応が63個

●その他
・新規ウィンドウのタブ挿入位置管理のための親ウィンドウ情報と制御を追加
・タブのインデックスを取得するのにCWnd*を渡すと正しいのに、HWNDを渡すと間違った値を返していた潜在不具合を修正（今回初めて使った）




Ver.14.4.0.0
●ウィンドウ管理バーの強化
・ウィンドウ管理バーからリスト部へドロップして別プロセスに分離する機能を追加
・ウィンドウ管理バーでD&Dで並び替える機能を追加
※ウィンドウ管理バーが並び替えを受け付けるのは、自動整列がOFFの時のみ
・内部D&Dのフォーマット名と構造を変更（古い版のAs/Rや、まめFileとの互換性が無くなった）
・シングルクリック時の動作で無駄な判定処理があったので削除

●タブバーの強化
・タブバーもウィンドウ管理バーの並び替えと同じ情報で並び替えができるように修正（相互にドロップ可）
・操作が速い場合のドラッグ開始座標を補正

●その他
・ドラッグヘルパーの実装が雑で、メモリが逼迫している時に不安定になる可能性があったのであちこち修正
・共通関数部のGDIが枯渇時の安定性の向上×4
・タブバーとウィンドウ管理バーのドラッグヘルパーを再度実装したけど、なぜか見えないので再封印
・ビルドバージョンをVista以降で動くよう指定していたが、API要求の定義が多くなってきたのでWindows7に変更
・呼び出し頻度の高い関数の型変換を見直して変換ロスを低減
・ナビゲートロック切り替えの際に呼びだしていた、構造改編で機能しなくなっていた関数を削除
・全ソースファイルに対してテキスト成型を掛けた

●コード分析対応
・「推奨」レベル
　2個対応（推奨レベルは完了）
　完全レベル消化の影響によって発生した13件対応
・「完全」レベル
　const付与推奨を1280個くらい対応
　ローカル変数の初期化を310個くらい対応
　constexpr付与推奨を220くらい対応
　その他140個くらい対応

●不具合修正
・画面分割し、選択状態を保持したまま更新コマンドを実行した瞬間、反対側のリストで自動更新のリネームが発生すると落ちる可能性がある不具合の修正




Ver.14.3.4.0
●不具合修正
・前回のタブ情報内の空行を処理してパス指定なしでタブを開いていた不具合の修正
※定義ファイルの読み込み改善の影響で表面化

●その他
・仮想フォルダの情報を管理するクラスの追加（適用は一部のみ）
・独自状態であったUsersディレクトリ直下のソート関連情報を統合
・スクリプトや定義ファイルを読み込み上限を50MBに変更




Ver.14.3.3.0
●コマンドライン連携の改善
・コマンドプロンプトやPowerShellを呼び出すパスがネットワークの場合、事前にPINGを打って疎通確認するように変更
※存在しない/切断されたネットワークパスだと、かなり待たされるため
・CMDやPSは存在しないローカルパスの場合でも即座に応答を返すが、隠し機能のカスタマイズがされた場合を想定してパスの存在チェックを行うように変更

●変更機能を持たない軽量文字列クラスの改修
・自前のヒープ管理をやめて、最近の常識的な実装に変更
・微妙に省メモリ化(1文字列あたり4バイト)
・Attachメソッドはメモリリークの危険性の方が高そうだったので廃止
・MBCSサポートが残っていたので全廃
・小さなメモリの遅延解放は効率が良くないケースが多くなってきたため廃止

●クリティカルセクションの管理クラスの改修
・微妙に省メモリ化(1タブ当たり8～40バイト)
・ロックカウンタを廃止して効率化

●定義ファイルの読み込み速度の向上(不要な初期化をしていたのを削除)
・ローカルサムネイルキャッシュの辞書
・前回のタブ情報

●その他
・自動更新の設定の「環境依存の不具合対策」リストに合致して更新を止める場合の判定の冗長性を改善
・ローカルの自動更新の検出に関わる文言の修正
・自身の起動中を示すフラグが不要になったので削除
・タブバーからドラッグする情報を構造体からクラスに変更
・不要なイメージリストの初期化処理を除去
・ウィンドウ管理バーのアイテムの列挙の際、先頭アイテムの取得APIを推奨のものに変更

●不具合修正
・オプションの自動更新を無効にするアイテム数を超えても、初期状態でステータスエリアのアイコンが変わらない、また切替できない場合がある不具合の修正




Ver.14.2.8.0
●タブの管理方法のモダン化と速度改善
※元が数ミリ秒の処理なので、改善速度が何十倍速であっても個々の改善の体感速度は誤差です。
　タブ数が多いケースなどを想定したチリツモ効果の性能向上を期待するものです。
・タブバーで管理していた情報および操作をウィンドウ管理クラスへ移管
・タブ情報の管理の中で、UIスレッド依存の情報/処理を全廃して同期を取る必要性をなくした
・タブの削除時のグループ解除判定を整理、また高速化(約2～40倍速)
・新しいタブグループNoの採番処理を高速化(約5～30倍速)
・グループに含まれる件数の管理テーブルを新設して都度計算しないようにした(約8～200倍速)
・グループ番号の操作をカプセル化して外部から変更できないように変更（件数管理の厳密化）
・グループ最大数を定数化した
・グループ色アイコンを静的配列から動的配列に変更
・ウィンドウを並べる系のコマンド（MDIモード）をウィンドウ管理クラスに合わせたパラメータ構成に変更
・タブバーでD&Dで並び替えの際のグループ管理情報の効率化
・バッファオーバーランの防止のためのタブグループ番号の剰余計算の冗長性を改善して計算量の削減
・ウィンドウ管理バーによる選択状態の管理を見直し、MFC汎用ポインタからvectorに変更等

●その他
・冗長な構成であった仮想フォルダか否かの内部フラグを廃止、また判定式をある程度まとめた

●不具合修正
・起動時に2画面分割タブを含む場合、初期化スレッドの完了が早すぎると落ちる不具合の修正
※同期処理が無くなった影響で表面化した問題だが、本来考慮に入れておくべき内容




Ver.14.1.6.0
●コマンドライン/PowerShellの起動系のコマンドのカスタマイズ強化
・各コマンドパスをレジストリ参照にしてカスタマイズ可能に変更（隠し機能扱い、ヘルプで仕様を公開）
・cmd.exeのパスを「[システムディレクトリ]＋cmd.exe」から環境変数「%ComSpec%」に変更（デフォルト値）

●ドラッグアンドドロップで実体のあるファイルをドロップした時の動作の変更
・ファイルコピー/移動（バックグラウンド）の内部処理を同期処理でも動くように拡張（未使用）
・ドロップファイルの1個目が環境変数%TMP%配下に存在する場合、バックグラウンド→同期モードに自動的に切り替える処理を追加
※7Zip File Manager用の(最近のOutlookも?)互換対策
　MArcのように一時解凍のクリーニングを統合的に行っているソフトが相手の場合は、エクスプローラー並みの性能に低下する

●高DPI環境への対応強化
・ウィンドウ管理バーの各種アイコン画像をDPI係数で拡縮する機能の追加と、当たり判定式を拡張
・タブバーの各種アイコン画像で、自前描画部はDPI係数で拡縮する機能を追加

●その他
・コード分析による指摘対応(3個)





Ver.14.1.3.0
●ウィンドウ管理バー
・コマンドメニューとコンテキストメニューのグループへ移動系のコマンド色を塗りアイコンを追加
※タブバーのメニューは制御してないので保留、ツールバーを追加すると自動表示されるのだがリソースが増えるのを懸念

●タブバー
・スキン適用の有無にかかわらずアプリ描画をするように変更
※スキンが使用された場合、どうせ画像で全面上塗りするんだと速度重視で下塗りをしてなかったため透過色の使用で描画が破綻していた

●不具合修正
・ウィンドウ管理バーのツールバー上でダブルクリックすると空欄クリックと誤認して新しいウィンドウを開いてしまう不具合の修正

●その他
・コード分析による指摘対応(22個)
・volatileでスレッド間のフラグとして使用している変数を管理するクラスを追加して、コード分析で警告が出る部分のみ置き換えた
・規定のフォルダの取得処理を見直して簡略化




Ver.14.1.0.0
●オプションのタブ共通ページ
・現在のタブの表示関連の設定をグループボックスでまとめた
・現在タブで、枠線を付けて強調するを追加
・現在のタブと同じパスのタブが存在していたら強調表示（薄緑色）を追加
・ファイル操作エラー時にロック疑惑のあるタブの強調表示（赤色）を追加
・現在のタブよりも下位の階層のタブの強調表示（紺色）を追加

●追加コマンド
・タブグループ1～12へ移動コマンドを追加
※ドッキングバーのメニューと、キー割り当て用の「全コマンド」のみに追加

●ウィンドウ管理バー
・ウィンドウ管理バーの下位階層（階層表現）/同じパスのタブ（背景色）の描画を追加
・ウィンドウ管理バー用タブグループ1～12へ移動コマンドを追加
・コマンドメニューの変更
　メニュー項目の並び順を見直した
　開く/閉じる/ウィンドウ管理/タブグループの階層化と見直し
　「同じパスのタブを閉じる」を追加
　「下位階層のパスのタブを閉じる」を追加
　「新しく開く」を追加
　「ここから開く」を追加
　「ここからバックグラウンドで開く」を追加
　「クリップボードのテキストで開く」を追加
　「閉じたタブを再度開く」を追加
　選択タブをタブグループ1～12へ移動を追加
・コンテキストメニューの変更（右/中ボタンクリックでアクティブタブが切り替わらない）
　メニュー項目の並び順を見直した
　開く/閉じる/ウィンドウ管理/タブグループの階層化と見直し
　「同じパスのタブを閉じる」を追加
　「下位階層のパスのタブを閉じる」を追加
　「新しく開く」を追加
　「クリップボードのテキストで開く」を追加
　「閉じたタブを再度開く」を追加
　選択タブをタブグループ1～12へ移動を追加
※ここから開く/ここからバックグラウンドで開くは、初期値の挿入位置の設定の対象がアクティブタブなので保留

●タブバー
・タブバーの下位階層（段組み）/同じパスのタブ（段組み）の描画を追加
・コンテキストメニューの変更
　メニュー項目の並び順を見直した
　開く/閉じる/ウィンドウ管理/タブグループの階層化と見直し
　「新しく開く」を追加
　「同じパスのタブを閉じる」を追加
　「下位階層のパスのタブを閉じる」を追加
　タブグループ1～12へ移動を追加
・設定メニューの変更
　「新しく開く」を追加

●その他
・ナビゲートロックされているタブで、フォルダーのショートカットをフォルダーとして扱う設定の場合、新しく開くタブをグループに含めるように変更

●不具合修正
・同じパスのタブを閉じると下位階層のパスのタブを閉じるで、仮想フォルダがサポート対象外であったのを修正




Ver.14.0.0.0
●デバッグバーとログバーを追加
※機能詳細や設定項目はかなり多いので詳細はヘルプ参照
・デバッグバーとログバーのオプション画面を追加
・標準ツールバーへボタンへアイコンを追加
・デバッグバーへフォーカス移動コマンドを追加
・ログバーが新設になったことで、ステータスバーに表示していたメッセージの多くを整理
　インクリメンタルサーチ/マウスジェスチャ/警告表示は読み上げ等の対象から外したなど
・音声認識関連のキャプションバーへのメッセージ出力/表示制御を、全てログバーに変更

●ダークモード関連
・OSのダークモード適用オプションがONの場合、タイトルバーへの反映を追加
・起動時読み込みDLLにDwmapi.dllを追加(ダークモードのタイトルバー反映用)
・起動時読み込みDLLからD2d1.dll、Dwrite.dllを削除(Direct2D/DirectWriteモードの全廃)

●外部ツールのメモリ破壊などの検出を強化
・ログバーの取り扱いも含めて後処理を共通化(32ヶ所)
・発生個所を示す番号を付与して発生個所を特定できるようにした
・新規のトラップを追加（アンドゥなど）
・メッセージ文言を見直した

●圧縮ファイルビューア
・たくさんのアイテムを開こうとしたときのメッセージIDが不適切な不具合の修正
・Office文書（xlsx,pptx,docx）を書庫として扱わないように変更
・初期値のViewer.txtのMArcの対象からxlsx,pptx,docxを削除

●バージョン情報
・レイアウトを調整した
・表示テキストを調整した

●Ver.14.1用のタブの見た目改修関連
・現在のウィンドウよりも下位階層のパスのウィンドウを閉じるコマンドの追加
・現在のウィンドウと同じパスのウィンドウを閉じるコマンドの追加
・ロックされていて削除できないパスを削除しようとしたときの赤塗りを新方式に変更

●その他
・スクリプト呼び出し処理の無駄なスタック階層を整理
・ネタで作って消し忘れてた「変形合体して人型に変形する」機能を削除
・ウィンドウ管理バーに無駄なタイマー処理のオーバライドがあったので削除
・ユーザー定義バーの背景色管理方法を見直した
・リストで表示位置が不適切な場合があるためInfoTipを非表示に変更
※表示が欠けている場合に表示されるもので、自前で制御しているツールチップとは別物
・自動更新の「旧式差分更新」モードで不要なメッセージを削除して速度を改善
・アプリアイコンがWindows11のエクスプローラーに酷似していて見分けづらいため変更
・メインメニューでショートカットキーが割り当てられていない機能があったので修正
・ウィンドウ管理バーのチェックボックスの描画エリアを自前で計算するように変更し、ツリービューからチェックボックスの属性を削除した

●不具合修正
・アンドゥの際にメモリリークが発生するルートが存在したのを修正
※OSの不具合対策のため意図的に残していたもの
・オプションで「適用」を押下した時にメモリ破壊が起きる可能性がある不具合の修正
・オプションの静的テキストで不適切なコントロールIDを使用していたのを修正
・最新バージョンの確認機能でβ版が検出できなくなっていた不具合の修正
・ウィンドウ管理バーのコンテキストメニューとアクションメニューで、同じ機能なのに文言の相違がある不具合の修正
・ロックされていて削除できないパスを削除しようとしたときに落ちる可能性がある不具合の修正
・タブのスキン画像が適用されている場合、ロックされていて操作できない場合のタブ描画が行われない不具合の修正
・タブ情報管理クラスの不具合で開/閉を繰り返していると落ちることがある不具合の修正




Ver.13.5.7.0
●不具合修正
・一括新規作成の「OSの持つテンプレートを使用する」による活性化制御の不具合を修正
・深いパスで新規作成を行うと異常動作をするため、新規作成ファイル名の決定ロジックおよびファイル生成処理を自前で実装
　対象：Asr.exe,FileNewEx.exe
※IFileOperation::NewItem()で122文字以上のパスをセットし、処理を行うとパラメータエラーの例外になる
・リソースが確保できない等の理由でドッキングバーの生成に失敗した場合に落ちる不具合の修正
・非常にメモリが困窮している場合に現在のタブ構造を変化させようとすると落ちる不具合の修正

●その他
・スキン適用の画像の情報をクラス化して不用意なバグを発生しにくくした

●今後の布石
・新しいバー用のツールバーリソース追加とIDの予約
・スクリプトから実行するコマンドの情報をクラスでまとめた
・スクリプトの呼び出しインターフェイスを拡張
・スクリプトのスレッドに対して本体からブレイクポイント/再開/中断の制御を行うプロトタイプを実装




Ver.13.5.5.0
●詳細表示の設定画面
・カラム名の検索機能を追加して追加するカラムの探しやすさを向上

●不具合修正
・パスをなるべく環境変数に置換する処理において、環境変数の構成によって無限ループになる可能性がある不具合の修正（Option.exe,VersionInfo.exe）
・Finのコピー/移動先指定のコンボボックスの入力可能桁数が減っていた問題へ対処




Ver.13.5.3.0
●タグ情報
・抽出条件のオプションを「現在の階層以下」ではなく、「現在の階層よりも下」に変更
・リンクの切れたタグの抽出は「現在の階層より下」もAND条件になるように変更
・チェックボックスの組合せによる各コントロールの非活性化を分かりやすくなるように改善

●その他
・シェル削除の際に何かしらの理由で中断し、他のタブで下位階層を開いてると、そのタブを赤枠で目立たせるようにした
※As/Rがロックしていると疑わしきタブを通知する目的です
・Ctrl+Shift+Tabの初期値を「前のタブ」→「前のウィンドウ（Zオーダー）」に変更
・ウィンドウハンドル指定のタブ切り替え系の処理を共通関数にまとめた
・子ウィンドウのハンドル管理で現在のタブと同じパスを探すロジックを追加
・スクリプトのIF文の状態管理をオブジェクト化した
・バージョン情報ダイアログでAsr.exeのパスは、極力環境変数に置き換えるように変更

●不具合修正
・「同じグループ内に同じパスのタブがあった場合に閉じる」設定がONでグループに属さないタブの場合の初回表示フラグが、不適切な値になる場合がある不具合の修正
・動作には問題ないが、前/次のウィンドウ（Zオーダー）のID名が逆になっていたのを修正
・スクリプトのdebugが、本体以外から呼びだしたスクリプトの場合も半端に動作する不具合の修正

●OSかMFC関連の不具合の暫定対処
・WaitForInputIdle()で指定したプロセスがアイドルになっていないのに応答を返してしまう問題への暫定対処を追加
※対象はAsrload.exeのみ




Ver.13.5.0.0
●音声認識系のオプション追加
・起動時に自動的に認識を開始設定追加
・開始/終了の読み上げテキストの設定追加
・サンプルの生成、文法ファイルを登録エディタでの編集するための呼び出し機能の追加

●メインメニューに以下のコマンドを追加
・音声認識の切替(ID:35575)
・管理者でコマンドライン(ID:35560)
・管理者でPowerShell(ID:35561)
・管理者でエクスプローラー(ID:35562)

●描画の改善
※今回の改修の影響で、従来と若干の描画レイアウトに差異が生じます
・高DPI環境かつ「一覧」「詳細一覧」小・中・大アイコンの場合のリストアイコンの描画計算式を修正（横方向）
・高DPI環境かつ「詳細」「コンテンツ」かつ小・中・大アイコンの場合のリストアイコンの描画計算式を修正（縦方向）
・高DPI環境かつ「並べて表示」「アイコン」「アイコンのみ」かつ小・中・大アイコンの場合のリストアイコンの描画計算式を修正
・「アイコン」にてカーソル行およびフォント種類によりテキスト欠けが発生する現象の低減
・「並べて表示」「アイコン」のタイル系描画のテキスト幅を調整してごみ描画が減るようにした
・「アイコン（隠し機能版）」のごみ描画が減るように調整
・リスト上のチェックボックスの描画/クリック反応サイズにDPI比を適用した

●その他
・サイズから単位付きの文字列を生成する関数を高速化（気持ちだけ）
　Info.exe,Fin.exe,Marc.exe,FileExport.exe,FileNameCp.exeに影響
・アイコン画像メッセージの後の再描画をイベント駆動に変更して非同期性を向上
・エクスプローラ風のチェックボックス動作のアイコンをWindows11風に変更

●不具合修正
・スクリーンセーバーの設定値を0にしても、対象画像が存在すると動作する不具合の修正
・リソースDLLが一部巻き戻っていたのを修正




Ver.13.4.4.0
●管理者で実行コマンドの機能追加
以下のコマンドをキー割り当て、ツールバー割り当て可能にした
・管理者でコマンドライン(ID:35560)
・管理者でPowerShell(ID:35561)
・管理者でエクスプローラー(ID:35562)

●ファイルサイズ取得の改善
・ファイルアクセスを監視されている特定環境で、ファイルサイズを求める処理の高速化

●フォルダサイズ計算コマンドの改善
・稼働中のスレッドを数える際、フォルダサイズ計算の中断リクエストの処理中のステータスを考慮していなかった不具合の修正
・フォルダサイズ計算コマンドで探索中に権限無しで中断した場合はフォルダに「(探索不可)」と表示するように変更
・画面のアニメーション速度を落として、探索速度を向上
・リパースポイント属性のあるフォルダも集計対象に追加



Ver.13.4.2.0
・最新版情報の取得コマンド(VersionCheck.exe)の表記を改善
・コンパイラの不具合対応に伴い外部コマンドも全ビルドを行った
・不要IDの整理

●その他
・ステータスバーにAs/Rを実行したユーザー権限の表示を追加
　管理者として実行時は「管理者権限」、それ以外は「ユーザー権限」
・ついでにステータスバーの描画を最適化
・音声認識周りの定義を定数からレジストリ設定に変更
・音声認識周りのエラーメッセージを詳しくした
・配布書庫に不要なテンプレートが含まれていたので削除

●シェル実行関数に管理者で実行モードの分岐を追加
　以下は先行実装でPostMessageマクロコマンド等で実行できます。
・管理者でコマンドライン(ID:35560)
・管理者でPowerShell(ID:35561)
・管理者でエクスプローラー(ID:35562)




Ver.13.4.0.0
●不具合修正
・悪意あるテキストの読み込みに失敗した場合、バッファオーバーランが発生する可能性がある不具合の修正
・メモリ枯渇状態での安定性を向上
・コンパイラの不具合対応（一部の最適化オプションが効いてなかったらしい）
・乱数の初期化でtime()だと1秒以内に再度呼ばれたら同値になるのでGetTickCount64()に変更

●DetectCodepageスクリプト追加
　指定したファイルのコードページを求める。
　候補が複数ある場合、コードページの判別に迷ったら日本語であると仮定した上で判別ポイントの多数決を行う。
　文字コードの判別ができない場合「ERROR」と返す。

【書式】
var $codepage$ = DetectCodepage, 文字コード種を調べるフルパスファイル名

●SetCodepageスクリプト追加
　FileRead/FileAllReadで外部のファイルを読み込む場合、コードページを指定することで任意の文字コードのファイルを読み込めるようになります。
※Windowsがサポートするすべてのコードページが使用できますが、残念ながらWindowsの変換機能をそのまま使用しているので厳密なものではありません。

【書式】
SetCodepage=932




Ver.13.3.8.0
●Windows11の不具合か仕様変更への対応
・新規作成の項目をレジストリから走査する際、.txt/.bmpのShellNewが見当たらなければ自前で値を補完するように変更

●スクリプト
・BackgroundImageのターゲット指定に「One」を追加
※画面分割状態の場合にアクティブなリストを対象とする（画面分割していない場合はNowと同じ）

●その他
・ユーザーさんに調査を依頼するようなケースでの原因調査用ログ出力機能を追加
※当面は無効




Ver.13.3.6.0
●不具合修正
・ファイル一括作成コマンドのボタン活性化制御の実装漏れを修正、ついでにビルド警告を2個潰した
・コード分析対応
・乱数の初期化でGetTickCount()ではなくtime()を使うように変更




Ver.13.3.5.0
・Windows 11関連する表記を修正
・オプションの誤字修正と表現を改善
・Windows 7が動作確認対象から外れてる旨の説明を追加




Ver.13.3.4.0
●サポートOSにWindows 11を追加
※当面は既知の問題点は解説ページをサイト上に掲示します
・バージョン情報はBuild 22000以上であれば「Windows 10」を「Windows 11」に置換するように変更（暫定対処）

●リスト上のフォーカス制御を厳密に行うように修正
・↑ボタンはリストへ
・↑ボタンの長押しメニューはリストへ
・インサイドツリー切り替えはリストへ
・ディレクトリ内検索のボタン（選択/色塗り/次候補/前候補）はディレクトリ内検索のテキストボックスへ

●その他不具合修正
・内蔵検索機能の呼び出しにて、フォルダを選択していた場合に未選択警告が出る不具合の修正




Ver.13.3.2.0
●Windows 11の暫定対応(ISO版)
・バージョン情報で「リリースID」(ReleaseId)を表示していた箇所に「表示バージョン」(DisplayVersion)を表示するように変更
※21H2のような版表示

●スクリプト
・Randomコマンドのパス指定で終端の\が無い場合は付与するように修正
※ただしワイルドカード指定ではない場合に限る
※GetSelectItemsも同じ修正

●その他
・文言修正




Ver.13.3.1.0
●オプション→全体→外観→色・フォント画面の見直し
・レイアウト構成を大幅に修正
・「黒テーマ」/「FDテーマ」/「FILMTNテーマ」の、グループ2～6の配色を見直した
・「OSのダークモードを適用する」設定の追加
※スクロールバーなどが黒く、ツリーのWindows 10 20H1以降などの制限事項あり

●Windows 11の暫定対応(Inside preview版)
・拡張子icoはSHGetFileInfo()で画像が取得できない問題への対処
※エクスプローラも同じように白いアイコンで表示されます




Ver.13.2.9.0
・フォルダーバー(インサイドツリー)において、Windows10だと常にクラッシック表示のみであったが制限を解除
※サポート切れになった1809/1903/1909だとレイアウトが崩れる/見苦しいので非推奨
　動作確認は21H1のみ
・存在チェックをする際にFindFirstFileEx()を使用し、ドライブルートの場合にINVALID_HANDLE_VALUEが返ってくることがある現象への対処
※再現条件は不明、1ドライブをパーティション分けして片方だけＮＧもありうる
　共通関数のため全exeをリビルドした





Ver.13.2.7.0
●「埋め込み型の名前の変更」でリネームに失敗した場合に、As/Rでロックしている可能性のあるタブを3秒間、赤枠で目立たせる機能の追加
※リネームに失敗した場合の当該パスの下位階層のタブを赤枠で色塗りします
※As/Rではタブで開いていても、極力手放す仕組みを持っているのでロックしていないことが多々あります
　また、よそ様のソフトでロックしていた場合には判別不能なので、あくまでロックしている可能性がある候補と考えてください




Ver.13.2.4.0
●タグ情報画面
・「～フルパスを使用する」はファイル名絞り込みチェックに依存して非活性になるように変更
・色のピッカーは色で絞り込むに依存して非活性になるように変更
・分かりやすくするために依存関係にある項目の順に項目を並び替えた

●音声認識
・メニュー定義の「全コマンド」に機能コマンドと説明リソースを追加
　音声認識開始/音声認識停止/音声認識切り替え　
※MFCのカスタマイズ画面にある項目で、ここからツールバーなどにＤ＆Ｄで配置できます

●その他
・非推奨になっていたGetSimpleItemIdList()/SHSimpleIDListFromPath()を補助的に使用していたが、戻り値のITEMIDLISTが不正になってきたので利用しないように変更
※存在しないネットワークパス、取り出し済みリムーバブル機器など、応答が極端に遅いパスの変換に使用していたため、こういったパスの応答性能は大きく劣化します
・上記の処理が2種類あったので内部統合した
・アプリ側で下位階層はチェック済みフラグを追加（一覧生成速度の向上）
・ファイル属性取得から、取得にタイムリスクのある「時間のかかるオブジェクト」「ReadOnly（ファイルやディレクトリの属性ではなく、フォルダーの属性）」のフラグを見ないようにして各種応答速度の向上




Ver.13.2.0.0
●音声認識
・ルール「As/R Script」を暫定廃止（Ver.13.5.0.0で正式機能になるまで機能は残します）
・ルール「As/R Command」で数値変換ができない場合、スクリプトと見なして実行するように変更
・ルール「Task」のActionのコマンドを追加して外部アプリケーションの制御機能を拡充
 UP・・・ウィンドウを100pix上へ移動
 DOWN・・・ウィンドウを100pix上へ移動
 LEFT・・・ウィンドウを100pix上へ移動
 RIGHT・・・ウィンドウを100pix上へ移動
 ICONIC・・・ウィンドウを100pix上へ移動
 ZOOM・・・ウィンドウを100pix上へ移動
 NORMAL・・・最大化/アイコン化を戻す

●不具合修正
・Seekerで拡張子MP4はメディアプレーヤコンポーネントを使用するように初期値を変更

●その他
・Visual studio 2019の更新
※1個前はランタイムのインストーラや排他制御に致命的な問題があったため2個前で止めていた
・並列STLのソートが遅くなってきたので自前実装に戻した




Ver.13.1.6.0
●音声認識の制御を実装
1.ルール「As/R Command」の実装
　コマンドをコマンドIDとしてメインフレームに発行する（As/Rの内部機能の利用）
2.ルール「As/R Script」の実装
　コマンドをAs/R用のスクリプトファイル名として認識する
3.ルール「Execute Command」の実装
　コマンドをフルパス文字列としてコマンドを実行する
4.ルール「Task」の実装
　コマンドをプロセス名として認識する
　タスク切り替え/タスク終了のアクションを定義できる
5.ルール「Special moves」の実装
　必殺技を発声する
6.ルール「その他」の実装
　数値変換して0にならなければAs/R Command、0になったらExecute Commandとみなす。
※3～6はよそ様のソフトを制御するためのものです。

●音声認識関連のコマンド追加
・音声認識モードの開始/終了のトグルコマンドの追加(ID:35575)
※メニューやツールバーなどに配置するとUI制御あり
・音声認識モードの開始コマンドの追加(ID:35576)
※状態を表示するためのキャプションバーが強制表示されます
・音声認識モードの終了コマンドの追加(ID:35577)

●その他
・ILCreateFromPath系のAPI群でITEMIDLISTが取得できないパスの場合、上から順に走査してITEMIDLISTを自前構築する機能を追加
※Windows10の不具合対策で、Androidデバイス等で各種ジャンプや、ツリークリックでの表示できるようになります




Ver.13.1.0.0
●通知メッセージの読み上げ精度の向上
　インクリメンタルサーチの文言が顔文字と読み上げられるのを修正
　英単語認識できてないローカルサムネイルキャッシュの読み上げ情報を日本語化
　「NaviLock!」は意味不明なのでリソース化して日本語化

●タブバーの不具合修正
・OS依存するエッジ幅を定数に変更
・Xボタンの位置をマウス押下であたるようになど全体を調整
・スキン画像の適用の際の座標計算が修正漏れだったのを修正

●その他不具合修正
・音声合成エンジンの取得に失敗かつデフォルトエンジンも見つからない場合、更なる代替エンジンの検索に失敗する不具合の修正

●その他
・システムの乗っ取りが可能な欠陥のあるアプリがインストールされている環境にて、アイコン取得の際に落ちないようにした
※ステータスバーに「外部のプロセスによるメモリ破壊が検出されました\nシステムを不安定にするソフトがインストールされている可能性があります」という従来から実装しているメッセージを表示します。
　なお抜本対策をする予定はありません。予告して心の準備をさせるだけのものです。
・音声認識のエンジンを追加




Ver.13.0.7.0
●通知の強化
・ナビゲートロック時にナビゲート要求があった時の通知メッセージが不統一であったのを修正
・オプション→全体→動作に通知メッセージの表示場所(?)の設定を追加
　1.ステータスバーのみ
　2.アクティブフレームの中央
　3.メインウィンドウの中央
　4.しゃべる

●スクリプト
・スクリプトのSpeach系のコマンドのタイプミス修正（→Speech）
※Ver.13系の間は両方使えます

●音声合成
・関連処理をクラスにまとめた
・声をOSの「音声認識」の設定画面の「音声」の設定を参照するように変更
・「音声認識」の設定が見つからない場合、TTSエンジンの設定値を参照する仕組みを追加
・読み上げ速度
　スクリプトはSpeechRateSpeedの指定
　通知はOSの「音声認識」の設定の「速さ」

●その他
・Win32Apiの最低使用レベルをXP以降からVista以降に変更
※結構な数のWindowsAPIの内部動作が変わっています
・コード分析対応

●不具合修正
・特殊な操作を行った場合、リストの全選択解除の際にドロップハイライトと切り取り属性が解除されない不具合の修正（通常操作では発生しません）
・監視イベントの名称がバッティングする可能性(1/16億くらいの確率)がある不具合の修正
・一部のコンテキストメニューのVerb指定で不適切なキャストを行っていたのを修正
・クリティカルセクションの生成に失敗した場合のエラー処理が間違っていたので修正




Ver.13.0.4.0
・タブバー上の閉じるボタンの当たり判定が3ピクセルずれていたのを修正
・プレビューで発生する例外を調整
・エラーメッセージの文言修正




Ver.13.0.3.0
・プレビューバーの安定性の向上
　（外部コンポーネントがメモリリークしても落ちにくくした）
・プレビューバーに反映させるトリガーの設定を追加
　1.リスト上のファイルを選択（従来動作）
　2.リスト上のファイルの上にマウスを近づける
　　(ツールチップを出すタイミングで表示切り替え)
　3.リストとは連動しない
　　下記のスクリプトコマンドで、プレビューバーを組み込みビューアとして使う場合に使用する。
・スクリプトのExRunにプレビューバーで表示させる組み込みコマンドの追加
　　Filter句で対象拡張子を指定し、起動コマンドの記述を以下のようにすることで内蔵ビューアにすることが可能になる
【書式】
Filter=txt,xlsx,xls,docx,pdf
ExRun=Previewbar

●その他
・インサイドツリーでツリーのクリックイベントがジャンプの場合、ターゲットリストは現在のペインのリストに限定するように変更

●不具合修正
・「反対側のペインで開く」コマンドでアクティブフレームを見失っている場合に誤動作する不具合の修正




Ver.13.0.1.0
●Setting.exeに/Fスイッチを追加
　初回インストールボタンが非活性にしないオプションです。
　インストール先などを変更して再インストール可能になります。
　お気に入り等のサンプルスクリプトを作るようにすると上書きするので注意してください。
【書式】
Setting.exe /F

●不具合修正
・アイコン表示の場合、プレフィックスを隠すモードになっていなかった不具合の修正
・サイズグラフの描画の条件式が不正であったのと、初期化値の扱いを勘違いしていた不具合の修正
・コマンドが増えていたのでAllCommand.txtを出力しなおした




Ver.13.0.0.0

●コンパイラオプションの変更
・std:17をすべてのバイナリに適用
※全体的に実行時の性能が向上しているが、サイズが大きくなった分だけロード時の性能が低下

●ウィンドウ管理バー
・貼り付けなど、複数のフォルダーを対象にできることがイメージできるようなメニュー文言に修正
・閉じる系のコマンドの並び順のほかに合わせて統一した
・メニューに「全て閉じる」を追加

●タブバー
・メニューのセパレータを他に合わせて統一した

●メインメニュー
・メニューに「ロックされているタブも全て閉じる」を追加
・「ホームページを開く」を追加
・「As/Rのページを開く」を追加
・並び順を他のメニューに合わせて修正

●リストのメニューを修正/是正
・リストが選択状態の場合「全選択/解除」は結果が不定なので「解除」と「全選択」に分離した
・リストが未選択状態で「全選択/解除」はあり得ないので「全選択」のみに変更
・リストが未選択状態で「選択状態の反転」はあり得ないので削除
・選択系のコマンドの説明文言を修正
・「更新日付が10分以内のファイルを選択」コマンドを追加
・「更新日付が1時間以内のファイルを選択」コマンドを追加
・「更新日付が本日のアイテムを選択」コマンドを追加

●新規追加コマンド
・「ホームページを開く」コマンドを追加
・「As/Rのページを開く」コマンドを追加
・「全て選択」コマンドを追加
・「更新日付が10分以内のファイルを選択」コマンドを追加
・「更新日付が1時間以内のファイルを選択」コマンドを追加
・「更新日付が本日のアイテムを選択」コマンドを追加

●その他
・COMがビジーの場合のインターフェイス再取得処理を廃止
　(ビジーならすぐに諦める。Ivy Bridgeより過去のCPUがビジー状態を誤認するため)




Ver.12.9.5.0

●その他
・BOX等のシェル拡張ソフトが動作しなくなるので、スレッドでのCOMの初期化でメモリを多く割り当てて速度が向上するように変更したものをロールバックした
・プレビューバーの安定性の向上（メモリ/リソースリークする外部コンポーネント用の対策）
・リスト上のツールチップテキストの設定反映の仕組みを整理して無駄な処理を減らした
・コード分析の警告対応（122個）
・定義ファイルの読み込み処理のアルゴリズムを改善
・旧式差分更新のアルゴリズムを改善




Ver.12.9.4.0

●自動更新（シェル通知モード）が使い物にならないシーンが増えてきたので機能追加
・更新検出方法に「旧式差分更新」の選択肢を追加
※特に正確性を要求されるシーン用
　常に全走査を行うため性能は低
　リネームの際にフォーカスを失うので操作性も低
・自動更新用のステータスバーのアイコン画像を追加
・「旧式差分更新」モードのステータス表示/切り替え機能を追加
・更新検出方法の設定画面の文言を見直した
・ローカルフォルダーの更新検出方法の設定を追加
※設定可能項目はネットワークと同じだが、文言は異なる

●コンパイラの不具合対応
・並列処理における最適化不具合の対応のため開発環境を更新
・サニタイズ処理不具合の対応のため開発環境を更新

●メディアプレイヤープラグイン（プレビューバー）
・デフォルト拡張子にmp3,mp4を追加

●その他
・スレッドでのCOMの初期化でメモリを多く割り当てて速度が向上するように変更
※消費増がByte単位、速度差がナノ秒単位なのでほぼ誤差
　アイコン取得
　ディレクトリ走査
　フォルダサイズ計算
　貼り付け
　削除
　バックグラウンド実行のスクリプト
・リストの幅設定で「詳細一覧」以外の動作を改善
・リストの自動幅計算で幅のDPI許容値を調整

●その他不具合対応
・シェル通知の自動更新の場合、対象が現在フォルダーか否かのチェック処理を暫定で追加
※解放したはずの他のパスの更新通知を拾っている
　最近のWindows10ではSHChangeNotifyDeregister()が期待通り動いてない
・リスト項目の削除後の再描画で落ちる可能性がある不具合の修正
・フォルダ情報としてカラムも取得しているが、COMがビジーだと取得し損ねて落ちる可能性がある不具合の修正
・リストの自動幅計算でDPI係数で割るべきところを掛けていた不具合の修正




Ver.12.8.5.0
●スマートペーストのカスタマイズ画面をオプションに追加
・設定項目を「全体→共通操作」から「リスト→貼り付け」に移動
・テキスト/画像を個別指定できるように変更
・デフォルトのテキスト/画像のファイル名を設定できるようにした
・置換マクロをたくさん正式追加
・制御マクロを正式追加

●その他
・並列STLの実行ポリシーを変更(execution::par_unseq→execution::par)
　30万ファイルで10ms程度速くなったため

●リストの幅の自動伸長が効かなくなる環境への暫定対処
・計算用のリストの個数を厳密に求めるように修正
　CPU依存でmax_element()が未使用領域の値を返すため



Ver.12.8.4.0
●不具合修正
・自動更新を監視できないフォルダーか空でイベントが呼ばれた場合の状態セットが、スレッド優先度によって検出し損ねる可能性がある不具合を修正
・監視スレッドのハンドルの命名にて、桁落ちが原因で重複する可能性があった不具合の修正

●その他
・SeekerでFlash Playerのサポートを終了
・SeekerでRealPlayerのサポートを終了

●メンテナンス
・コード分析対応2件
・リストフォルダの制御フラグをenumで定義視しなおした



Ver.12.8.3.0
●不具合対応
・悪意ある環境変数を設定した環境で制御不能になる可能性がある問題への対処
※よそ様のソフトでも悪用可能なので詳細は伏せます

●その他
・子ウィンドウ(タブ単位)管理処理の安定性の向上
・オプションの文言修正



Ver.12.8.2.0
●高解像度向けの改善
・メインウィンドウのサイズにDPI係数をかけるようにした
・ウィンドウ管理バーの派生元クラスが低機能版になっていたのを変更

●その他
・タブバー上のホイールの回転検出をタブコントロールではなく、ドッキングウィンドウ側へ移動した
・上記と動きをそろえるためウィンドウ管理バーのホイール検出を、ツリーコントロールだけでなくドッキングウィンドウにも処理を追加
・隠し機能（作りかけで挫折して投げ出しているもの）のレジストリ情報をまとめた
・ドライブの増減/関連付けアイコンの変更通知の受信イベントを限定的なものして複数ディレクトリ監視の衝突を緩和した
・更新検出イベントを無名にしていたがユニーク名称を付与するように変更
・監視APIがFALSEを返してきたときに監視スレッドを停止するように変更（失敗してもTRUEを返してくる仕様なので気休め）



Ver.12.8.0.0
●不具合修正
・ネットワーク上のディレクトリをローカルと誤認させた上で、相手サーバーのOSの種類依存で更新通知を誤認してしまう問題の対処
・オプション画面内の「Webで探す」ボタンが機能していない不具合の修正

●その他
・詳細表示で折り返して2行以上になり、表示の遅いカラムを追加している場合の「名前」カラムのちらつきを低減
・監視スレッドの省メモリ化とメモリ転送速度を若干向上
・リリースパッケージの生成コマンドの修正(Windows10 20H2対応)
・文字列の配列を結合して1つの文字列を生成するクラス(なんちゃってStringBuilder)で状態を管理して再生成頻度を減らした



Ver.12.7.9.0
●高DPI環境向けの対応
※通常環境を基準にしているので高DPI環境では今までの版からバージョンアップするとレイアウトが崩れます。
　高DPI環境はマウスでドラッグ/設定等でサイズの再調整をお願いします。

・オプションでのフォント設定のずれを修正
　1.外観
　2.テキストのサムネイル表示
　3.プレビューの内蔵テキストビューア
・テキスト表示サイズ調整
　1.テキストファイルのサムネイル
　2.プレビューのテキスト表示
・詳細を除く各項目の表示幅の管理を構造体からクラスに変更し、取得の際にDPI係数を掛けるようにした
　1.詳細一覧
　2.並べて表示
　3.一覧
・詳細のカラム幅取得/カラム幅保存にDPI係数を掛けるようにした
　1.ヘッダ境界のドラッグ
　2.ヘッダ境界のダブルクリック
　3.自動調整
　4.詳細表示の設定
・タグテキストのフォントサイズ調整
・タブバーのタブ幅にDPI係数を掛けるようにした
・インサイドツリーににDPI係数をを掛けるようにした
　1.初期値（新しく開いたタブ）
　2.保存値（スプリッタをドラッグしたときの保存値）
　3.保存用ステータス文字列
　4.スプリッタの幅（DPI係数をを掛けて摘まみやすいように）
・8ビットカラー環境向けのアプリアイコン画像をモダン化
・128×128、256×256のアプリアイコン画像を追加

●その他
・フルパスからインデックスを求める際の安定性の向上



Ver.12.7.4.0
・ユーザー定義バーで一覧を使わない場合のフォーカス描画を修正
・ユーザー定義バーの破棄処理の安定性を向上
※極めてまれにキャッシュの保存処理が行われずに終了するケースがあった

●タブを閉じる際のアイコン取得スレッドの自壊処理の見直し
・OSが応答を返さない場合にメモリリーク覚悟でスレッドを放棄していたが完全破棄の成功率が大幅に向上
・オーバーレイアイコンの取り合いをしているシステム全体が不安定な環境での安定性を向上

●その他
・コンパイラバグで落ちるのを回避する処理の削除



Ver.12.7.3.0
●不具合修正
・新規作成時、テキストや画像が張り付けられた時のファイル名の生成に重複がある場合、連番は1から始めていたのをOSに準じて2に変更
・ドッキングバーのフォーカスの抜け方によって（自分自身に抜ける場合）、設定によって背景色指定が乱れる不具合の修正
・ユーザー定義バーで一覧を使わない場合の描画が見苦しかったのを修正

●その他
・ユーザー定義バーで一覧を使わない場合の幅にDPI係数を掛けて横幅を広げるよう変更
・ユーザー定義バーのコンテキストメニュー系の定義ファイルに「カラム幅調整」の追加、またこのルートのメッセージ処理も追加
※設定項目なので設定メニュー内に存在していたが気づかない人向け
・テキストや画像が張り付けられた時のファイル名をレジストリから取得し、置換マクロ展開処理を追加
※設定画面は未実装
初期値およびレジストリの位置
[HKEY_CURRENT_USER\Software\AMA_Soft\ASR\Main001\Settings]
"ClipboardText"="ClipboardText"
"ClipboardImage"="ClipboardImage"

※使用可能な置換マクロは以下の通り
?Name?:ファイル名の名前（デフォルトファイル名）
?Ext?:ファイルの拡張子（デフォルトファイル名）
?FileName?:ファイル名（デフォルトファイル名）
?ParentDir?:親フォルダー名
?Date?:現在年-月-日
?Time?:現在時-分-秒
?Year?:現在年
?Month?:現在月
?Day?:現在日
?Hour?:現在時
?Minute?:現在分
?Second?:現在秒
?Week?:現在曜日(短)
?WEEK?:現在曜日(長)
?ShellTime?:現在コントロールパネル表記

※使用可能な制御マクロは以下の通り
?FixedNumber?:テキスト中のどこに記述していても良い、この記述があると必ず1から始まる連番を付与する



Ver.12.7.1.0
・ユーザー定義バーの描画をOS標準からカスタムドローに置き換えた
※高DPI環境でのレイアウト崩れ対応、高DPI環境でのアイコン画像の拡縮表示、フォーカス色の設定反映の目的です
　見た目が若干変わります



Ver.12.7.0.0
●ファイル一括作成コマンドを作り直した
・従来のOSの自動命名に加えて、任意の名称、行政文書における名称付与の標準例に沿った命名機能を追加
・カスタムテンプレート機能を追加

●その他
・リストで未選択状態のメニュー定義ファイルにファイル一括作成コマンドを追加
・安定性の向上
・不要な変数の削除



Ver.12.6.0.0
●高解像度向けの改善
・大きめのフォントを指定した場合のウィンドウ管理バーの描画の崩れを修正
・リスト部の座標計算で、アイコンサイズよりもフォントが大きい場合の配慮を追加
・タブバー、ウィンドウ管理バー上の閉じるボタンの横幅を2Pix大きくした
・タブバー、ウィンドウ管理バー上の閉じるボタンの高さと当たり判定を、タブの高さ÷2に変更(最小値は16pix)

●保留
・リスト上のチェックボックスの描画を拡縮対応の描画に変更
（コントロールの持っている座標計算がおかしくなるので継続調査）



Ver.12.5.9.0
・「ロックされているタブも全て閉じる」を追加
　タブバーのコンテキストメニュー
　ウィンドウ管理バーの機能メニュー
　コンテキストメニュー

●不具合修正
・アドレスバーの設定を保存しても、要再起動である不具合を修正
・いつの間にやら全ビルドで、外部コマンドがコンパイルエラーになっていたのを修正

●その他
・ユーティリティ系の関数を複数追加
・オプションの画面分割の説明を修正



Ver.12.5.8.0
●不具合修正
・コード分析による警告の解消が合計で62ヶ所
　値をセットしている変数の未初期化対応
　スレッド関数への未記入のコメントを追記
　オブジェクト生成の確認済みだがCOMインスタンス生成関数そのものの戻り値の不使用等

●ファイル数の多い(数万)フォルダでの安定性の向上
・素早く連続して更新を発行し続けると落ちることがある不具合の修正
・素早く大量に連続して削除やリネームを検出し続けると落ちることがある不具合の修正
　※自動更新の遅延を極端に短く設定した場合に起こりやすい



Ver.12.5.6.0
・タブごとにウィンドウハンドルを管理する仕組みを実装
・タブの列挙の処理の速度改善
・ウィンドウハンドルから走査してタブ情報を取得していた処理をハッシュに変更

●その他
・起動に失敗する場合のメッセージを大量に追加
・ソースコードのメンテナンスバッチコマンドを修正
・タブバー縦置きなら右クリックメニューの「右を閉じる」を「下を閉じるに」、「左を閉じる」を「上を閉じるに」に置換するように変更



Ver.12.5.1.0（リリース告知前に不具合が発覚したので非公式）
●不具合修正
・コード分析による警告の解消
　(今回は設定系と、アプリケーション固有情報系で163ヶ所修正)
・スクリプト実行時にCOMのメモリリークが発生するルートがあった不具合の修正
・アイコン取得スレッドでCOMの初期化に失敗した場合に落ちる事がある不具合の修正
・ftp://、http://などのパス名はネットワークとみなすように修正
・コンパイラによる最適化によって、フォルダサイズ計算のスレッドの終了フラグが立たない対策を実施

●アドレスバーの動作改善
・アドレスバーが空欄の場合に移動しようとすると表示が乱れる不具合の修正
　また、空欄の場合は初期値フォルダを開くように変更
・アドレスバーの終端\補完は実体のあるフォルダに限定するように修正

●試作
・ハードウェアレンダリングの初期化処理を高速化したが、まだ足らない
・プロトタイプのIME監視スレッドが動いてたので停止
　IMEの状態を大きく表示して「(IMEがONになってて)あれ？動かない」を減らす目的の機能の試作品



Ver.12.4.8.0
●不具合修正
・シェル比較系のソートモードの場合、並列処理を行うと比較結果が不定になる環境が存在するようなので非並列のソートに切り替えるように修正
・コード分析による警告の解消
　(今回は影響が少なく、簡単に手が付けられるもののみ120ヶ所くらい修正)

●その他
・更新検出後の動作を整理して分岐の発生数を減らした



Ver.12.4.7.0
・フィルタ設定の表示名の展開したテキストで「&」がプレフィックスになっていた不具合の修正
・Speachスクリプトの再生音量が0になっていた不具合の修正
・新規フォルダ作成(MkDir.exe)の文字列処理を改善
・フィルタエリア/ディレクトリ内検索で、有効なショートカットキーを押下してもアラート音が鳴る不具合の修正
・詳細一覧の属性の表示にMを追加（存在しない）
・詳細一覧の属性の表示にUを追加（ピン無し）
・詳細一覧の属性の表示にPを追加（ピンあり）
・詳細一覧の属性の表示でスパースファイルは小文字のpに変更



Ver.12.4.5.0
●ファイル一覧出力の強化(FileExport.exe)
・未入力などのエラーチェックを厳しくした
・単位無しでファイルサイズを出力した場合、出力時にintの範囲までとなっていたのを修正
・不正な出力ファイル名にならないように前後のスペースを除去するように修正

●その他
・配布書庫のディレクトリにバージョン番号を付与するように変更
・スキンなどのなどのキャッシュが破損している場合の読み込み時に落ちる場合がある不具合の修正
・OLEオブジェクトの生成時、メモリ割り当てインターフェイスが取得できない場合に落ちる不具合を修正
・ドラッグ時のドロップソースを開放しないルートがあった不具合の修正
・バックグラウンドタスクが発生した場合、アプリケーションのタスクバーアイコンを赤塗にした
※ファイルコピー/削除などのダイアログが表示されていると、どれが本体か見分けがつかないため



Ver.12.4.3.0
●名前の変更コマンドで異常な名称のリネームを許可がOFFの場合の動作の変更
・前後のスペースを除去しているが、動作が分かりやすいように画面を更新するように変更

●アイコン描画のスレッドの安定性の向上
・スレッド制御でアクセス違反が起こりうるルートがあったので修正
・何らかのアクセス違反が発生した場合に例外を捕まえて落ちないように変更(暫定対処)

●その他
・各種のサムネイルキャッシュを読み込む際にGDIリソースリークが発生する場合がある不具合の修正



Ver.12.4.1.0

●ウィルススキャンソフトの誤検出対策として実行ファイル/DLLの個数の削減
・設定のない書庫系コマンド(ArcDllInfo.exe、MakeArchive.exe、MakeSelfExtract.exe)を統合した(-4個)
・設定のない情報系コマンド(DriveInfo.exe、FileInfo.exe、MemInfo.exe)を統合した(-4個)
・ShellCmd.exeにコマンドラインオプション(/RmHardware)を追加してRmHardware.exeを削除(-2個)
・ShellCmd.exeにコマンドラインオプション(/ScreenSaver)を追加してScreenSaver.exeを削除(-2個)
・SettingInitialization.exeは配布書庫から削除(-2個)
・現在休止中なのでCreateErrorReport.exe、report.batの同梱を削除(-4個)
・プレビュープラグインのRealPlayer.dllは配布書庫から削除(-1個)

●ExternalDefCommand.txtの更新
・統合したArc.exeのコマンドを記述
・統合したInfo.exeのコマンドを記述
・ハードウェアの取り外し(42083)の追加
・スクリーンセーバーの起動コマンドの修正

●その他
・誤字修正
・AllCommand.txtの更新
・_ListNoSelContextMenu.txtがENDで閉じてない不具合の修正(補完するので実害ありませんが、サンプルとして文法に問題があるのがNG)



Ver.12.3.7.0

●その他
・リストで選択している状態のコンテキストメニューを表示し、項目を選択するとコマンド名とIDをクリップボードにコピーする機能(コマンドID:35907、隠し機能）が消えていたので再実装
・自動更新の遅延時間が0の場合、カウンターの描画頻度を下げてレスポンスを向上
・アクティブビューがnullの場合に落ちる可能性がある不具合の修正
　(バグを組み込まない限り問題は発生しない)
・画面分割時にインサイドツリーをマウスクリックした場合にフォーカスを制御する仕組みを組み込んだ
・コンパイラの不具合により異なるループ条件のバイナリが生成される不具合対策（コンパイラの更新）

●脆弱性がある環境でも動く版のコンパイラオプションを変更
・原因特定の検証用としてベースアドレスの固定化ON、メモリ内ランダム配置のOFF等
※最近のWindows updateで強制的にメモリ内にランダム配置されるので効果は限定的



Ver.12.3.5.0

●リスト描画の修正
・アイコンのみモード（隠し機能版）は格子色を反映しないように変更
・テキストの設定色、状態色の管理方法をまとめた
・詳細一覧で選択状態かつ、フォーカスがあり、ウィンドウがアクティブでない場合、背景色が黒系だと情報表示部が見づらくなるのを改善

●初回設定ツール
・使用許諾条件のページを開くボタンが機能していない不具合を修正
・コンパイルオプションの最適化をサイズ優先に変更

●その他
・Intel JCC erratumIntel マイクロコード更新のパフォーマンスへの影響の軽減対策を適用



Ver.12.3.3.0

●性能の改善とライブラリ使用の変更
・表示情報の取得の並列処理をOpenMPからPPLに変更
・何らかのフィルタを設定した場合の速度を平均的に6～7%程度向上、ただし全てのフィルタがない場合は1～2%程度の性能低下
・OpenMPの直接利用を廃止
・OpenMP依存のソートや並列処理を並列STLに変更(ピーク性能の低下と全体性能の向上)
・AVX2版の場合、並列処理でベクタライズするように変更して性能を向上
・コンパイラの更新によってAVX2版が落ちることがある不具合が解消
・最適化オプションの調整

●オプション
・260文字を超えるパス長の対応の設定を追加
・CPU依存のチューニングおよび、アルゴリズム切り替えの設定を削除
・OpenMPの直接利用を廃止

●ランタイムテストコマンド
・GetCurrentProcess()というAPIを無駄に呼び出して、VCRUNTIME140_1.DLLを検出できるようにした

●シェル系のコマンドをShellCmd.exeに統合
・ExternalDefCommand.txtを更新、説明文の改定
・ShellCascadeWindows.exeの廃止
・ShellMinimizeALL.exeの廃止
・ShellSetTime.exeの廃止
・ShellStartMenu.exeの廃止
・ShellTileHorizontally.exeの廃止
・ShellTileVertically.exeの廃止
・ShellUndoMinimizeALL.exeの廃止
・ShellWinHELP.exeの廃止
・OSをシャットダウン(ID:42078)を追加
・OSをサスペンド(ID:42079)を追加
・ドッキングベイからPCを切り離す(ID:42080)を追加
・ファイル名を指定して実行(ID:42081)を追加
・コンピュータを探す(ID:42082)を追加



Ver.12.2.6.0

●配布パッケージの変更
・インストール/更新の手順に追加して「AVX2使用版」と「DLLプリロード等の脆弱性がある環境でも動作する版」を選択できるように変更
※「AVX2使用版」「DLLプリロード等の脆弱性がある環境でも動作する版」の差分の配布は終了します。
※7Zipのインストーラーに対するウィルススキャンソフトの誤検出が一向に減らないことから「インストーラー同梱版」の配布は当面見合わせます。

●その他
・AVX2版の速度を全体的に向上(並列最適化の向上/ロード・ストア系の命令を使用許可)
・通常版/AVX2版/DLLプリロード等の脆弱性がある環境でも動作する版をステータスバーに表示するようにした
・配布書庫を精査
・文言修正多数



Ver.12.2.4.0

●ウィンドウ管理バー
・ウィンドウ管理バー上にてホイール回転でタブを切り替える際、ウィンドウ管理バーでチェックを付けているアイテムが存在する場合は、チェックを付けているタブだけを対象に切り替えるように変更
・前/次のタブに切り替えコマンドでタブを切り替える際、タブバーが非表示かつウィンドウ管理バーでチェックを付けているアイテムが存在する場合は、チェックを付けているタブだけを対象に切り替えるように変更
・上を閉じるコマンド追加(35107)
・下を閉じるコマンド追加(35106)

●メニュー定義ファイルの更新
リストの選択状態のコンテキストメニュー(_ListContextMenu.txt)
・タグ関連のサブメニュー項目を追加
ウィンドウ管理バーのコマンドメニュー(_TabMngBarAction.txt)
・閉じる系のコマンドを追加
ウィンドウ管理バーのコンテキストメニュー(_TabMngContextMenu.txt)
・閉じる系のコマンドを追加

●オプション
・スキン/ステータスアニメーション/スクリーンセーバーの画面に「Webで探す」ボタンを追加
・背景の透明度の設定を子ダイアログ内へ移動

●その他
・アクティブになるまで走査しない設定の動作を改善して起動速度を向上した
・kiriさん作成のスキン画像を追加同梱した
・ソースコードをツールを使って自動整形した



Ver.12.2.0.0

●ウィンドウ管理バー
・自動整列を解除したときにタブバーと同じ順になるように変更
・自動整列OFFの場合のタブの挿入位置はタブバーの設定を使うように変更
・自動整列OFFの場合の親子関係がある場合のタブの挿入位置はタブバーの設定を使うように変更
・マウスの左クリックでアクティブタブを切り替えた場合に、リストにフォーカス移動するように変更
・空欄ダブルクリックで新しく開くコマンドを発行するように変更
・アクティブタブを太字にする設定の影響を受けるように変更
・ドライブアイコンの設定の影響を受けるように変更
・アクティブタブに閉じるボタンの設定の影響を受けるように変更

●オプション（タブ周りの仕様変更対応）
・「タブバー」のページを削除して、「タブ個別」ページを追加
・「タブ共通」ページのレイアウト変更と項目の再編
・「フラットデザインを使用する」の設定と、タブのグラデーション描画モードを削除
・「タブ切換時に点滅させて目立たせる」設定と点滅機能を削除
・その他文言修正多数
・その他レイアウト修正多数

●ユーザー定義バーのキャッシュ制御
・制御を独立したクラスにまとめた
・削除の際にインデックスから除去する処理を追加
・リネームの際にインデックスを更新する処理を追加

●その他
・Windows SDKの更新
・バックグラウンドのシェル削除が完了したタイミングでメインウィンドウをアクティブにするように変更
※ごみ箱のプロパティが「削除の確認メッセージを表示する」がONの場合、シェルのバックグラウンド削除を行うとフォーカスを見失うWindows10の不具合対策
・Office2007(黒)テーマ時、タブバーのアクティブタブを太文字にする場合の見た目を改善
・最近閉じたフォルダーバーのフォーカスの色塗りで考慮不足があったのを修正



Ver.12.1.4.0

●不具合修正
・最近閉じたフォルダーバーで背景黒テーマでフォーカスがない場合は、背景黒で黒文字なので選択テキストが読みにくい不具合の修正
・環境変数を含んだパス対応の修正もれで、全てのディレクトリ名が1文字で構成され260文字を超えるパスをツリーで選択したときの動作を修正

●スクリプト不具合修正
・小数部があるか否かの判定でint32のキャストを使っていたが、無条件で文字列に変換して、右から「0」トリムした上で「.」トリムするように変更
・Ver.12から変数の代入式で左右の「スペース」トリムしていたのを削除

●スクリプトの仕様変更
・String、TrimLeft、TrimRight、Paddingを追加
・以下のコマンドの戻り値は数値変換をしないように、また結果が空文字であった場合に空文字を返すように変更
 ReadRegString
 left
 right
 csv
 replace
 SubString
 RemoveLastSeparator
 GetExt
 GetName
 GetPath
 random
・input,inputdir,inputfileの戻り値の制御を上記の処理ど同じ仕組みを使うように修正



Ver.12.1.0.0

●環境変数を含んだパス対応の修正もれ
・Ctrl+左クリックの動作を修正



Ver.12.0.9.0

●プレビューバーのメディアプレーヤープラグイン
・UIモードを非表示にした(メッセージループを持たない画面には表示できない仕様らしいため)

●自動更新の環境依存の不具合対策
・オプションにあった「ごみ箱」と「マイコンピュータ」の自動更新抑制を削除
・任意フォルダーをワイルドカードで複数指定できる機能を追加(上限20個)

●スクリーンセーバー機能の追加
・隠し機能のステータスバー上のアニメーションの動作を作り直した
・アニメーションの描画個数の変更を追加
・描画場所の設定を追加
・開始時間の設定を追加
・選択UIを追加

●その他
・シングルスレッド版をプロジェクトから削除
・スキンやステータスアニメーションの説明のテキストを文字コード判別して表示するように変更
・ディスクの増減/関連付けの変更監視の通知受信で再帰取得しないようにして通知の受信量を削減した
・自動更新の通知の最適化処理を改善(速度の向上と省メモリ化)
・同梱用の画像にドキュメントを追加

●不具合対応
・ツリーの各種の動作に内部データ転送の目印を追加して、環境変数を含んだパスにリスト以外で遷移できない問題への対策を多数盛り込んだ
・特定条件でディスクの増減/関連付けの変更監視と、ネットワーク上のフォルダの監視の通知が混ざる現象への対処を盛り込んだ(Windows10の不具合)



Ver.12.0.0.0

●開発環境を変更(Visual studio 2015→2019)
・移行に関する問題を大量に修正
・コンパイラオプションの調整
・全てのWindowsSDKを8.1→10の最新に変更
・リストの破棄処理をPPLで並列化した
・リストのテキスト幅の最大値を求める処理をPPLで作り直した
・使用可能コア数の動的管理の仕組みを追加(シングルコア版は無くなりました)
・C++17に対応していないWindowsAPIはDLL化

●スレッド管理方法の改善
・サムネイル/アイコン取得のスレッドプールのインスタンス管理を調整して速度と安定性の向上
・リストの破棄処理を調整して、一度にタブを大量に閉じる際の安定性を向上させた
・フォルダサイズ計算時に背景の画面の描画を止めて安定性を向上させた

●名前の変更コマンド(FileRename.exe)
・長いファイル名が増えてきたことからファイル名のエリアが狭く感じるようになったため、レイアウトを大幅に変更した
・画面サイズを変更した上で、並び順の反転/拡張子分割のモードを切り替えるとレイアウトが崩れる不具合の修正
・スペース以下を除去ボタンを追加
・異常な名称のリネームを許可がOFFの場合、前後のスペースを除去するように変更

●FirstSetting.exeとUpdateAsr.exeの統合
・更新の手順を1個減らした
・動きとメッセージを見直した
・Setting.exeで更新時、ファイルコピーに失敗した場合に再試行の選択肢を追加

●設定の仕様変更
・ユーザー情報の管理ディレクトリの初期値をプロファイルで管理された～ではなく、アプリケーションフォルダーに初期値を変更

●バージョン情報(VersionInfo.exe)
・OS情報を平たい表記に変更
・最近使わなくなった情報を削除(ShellVersion,サービスパックの有無)

●スクリプト
・16進数変換は1行に複数の値を記載できるようにした
・代入文で四則演算を記載できるようにした
・ExRun句で複数のアプリケーションを指定した場合、ポップアップメニューで表示していたものをTaskDialogで表示するように変更した
※ショートカットキーは使えなくなりましたが、複数のファイルを開こうとした場合等に有用な情報表示が増えてます

●不具合修正
・外部コマンドのファイル一覧が、属性Mを持つファイルの場合にアイコン取得に失敗してチラつく不具合を修正
・リンクを開く際にフォルダ移動が発生し、それが何らかの理由でキャンセルされ場合、現在パスを見失う設定の組み合わせがある不具合の修正(フォーカスナビゲーション)
・リンクを開く際にフォルダ移動が発生し、それが何らかの理由でキャンセルされ場合、現在パスを見失う設定の組み合わせがある不具合の修正(選択ナビゲーション)




///////////////////////////////////////////////////////////////////////////////////
// Ver.11.x系
///////////////////////////////////////////////////////////////////////////////////

Ver.11.8.6.0

・自動更新の検出スレッドのループが特定の環境の場合に、ノーウェイトでループすることがある不具合の修正
・パスの存在確認関数が、ドライブルートを検出できない不具合の修正



Ver.11.8.5.0

・詳細一覧の日付の描画で縦にはみ出して描画する組み合わせがあったのを修正
・チェックボックスのモード管理が無駄に階層化されていたので1階層に修正
・CLSIDから文字列に変換する際、レジストリ情報が破損して不整合があると落ちる可能性がある不具合の修正
・ファイル読み込み系のプレビューで開けても読めない場合に落ちる可能性がある不具合の修正



Ver.11.8.4.0

・コード分析により検出した警告のうち、クラッシュおよび脆弱性の原因となりうる項目を修正(23件)
・長パス対応により低下していた走査性能を3割くらい回復



Ver.11.8.3.0

●不具合修正
・外部コマンドの入力補完コンボボックスの候補の選択時に、マウスで選択した場合に省略文字列を取得してしまう不具合を修正
・ネットワーク上のファイルの長パス解析で不適切なパス変換を行う不具合の修正
・テキストファイルビューアでコマンドラインで指定されたファイルを2回読んでいた不具合の修正(速度が遅い以外に実害はない)

●動作改善
・?SelFile?、?selfile?の置換マクロで渡す場合、MAX_PATHを超えるがショートファイル名の置換が可能であればショートファイル名で渡すように変更
 (長パス対応していないアプリケーションに対する救済措置)
・無駄な試行を減らす目的でショートファイル名か否かの判定を厳しくした
 (7文字以内に~があり、次の文字が数字か否かで判定)



Ver.11.8.2.0

●深いパス対応
・ネットワーク対応したデバイス名の取得関数を追加
・長パス対応のパス分割関数の関数を作成
・長パス対応のGetFileAttributes()のラッパ関数を追加
・長パス対応のファイル存在チェック関数を作成
・検索系の一連の処理を作り直した
・従来のロングファイル名の取得関数(今まで未使用)をチューニングして0.85～30,000倍速に向上
・ShellExecute()対応
・更新検出処理の見直し
・更新通知の受け取り処理の見直し
・更新インデックスの管理を見直した
・_tsplitpath_s/_wsplitpath_sのパスの分割関数を使わないように変更
・GetFileAttributes()を使わないように変更
・FileExistance()を使わないように変更
・ファイルオープン系の処理の長パス対応
・DragQueryFile()の長パス対応関数を追加
・レジストリの文字列読み込みの最大長を32K文字に変更
・StrRetToBuf()の長パス対応関数を追加
・入力補完コンボボックスの長パス対応(MArcを除く)
・PathAppend()を使用しないように変更
・GetIconLocation()を使用しないように変更
・ショートカットから実体名を取り出す処理の長パス対応(上限があるので可能な範囲のみ)
・外部プロセスの起動モードで、終了を待つタイプの動作のパス長の制限を解除
・ITEMIDLISTからフルパスを取得する関数のパス長の制限を解除
・shell32.dllから文字列を取得する関数の文字列長を32KBに拡張
・指定したexeからウィンドウハンドルを求める関数の長パス対応
・古いOSを対象としたロングファイル名取得関数の長パス対応
・Shell_GetCachedImageIndexを使うアイコン画像の取得処理の長パス対応
・ツリーのコンテキストメニューのOS部分の長パス対応（※悪意あるシェル拡張ソフトの検出用）
・ユーザー操作以外では_wrename()を使用しないように変更
・CStdioFileクラスを使用しないように変更
・CFileクラスを使用しないように変更
・TxvのみMFCのコマンドライン解析を使用しないようにして長パス対応アプリにした
・Finのファイルの探索を長パス対応とした（制限付きなので完全対応とはしない）

●高速動作する関数を用意しているに未適用であった項目
・GetWindowsDirectory()の置き換え(多数)
・GetSystemDirectory()を置き換え(多数)

●テキスト文字コード変換コマンド
・UNICODEの場合BOMを付与するオプションでUTF8を対象に追加した

●その他
・ファイルサイズを求める関数を抜本的に作り直して大幅に高速化した
・lnkファイル解析処理で、無駄なメモリ転送と確保があったので省略して速度向上させた
・拡張子分割文字列の生成で文字列長のカウントしないようにして高速化
・複数あったフルパスを分解してファイル名を返す処理を速い方に統一して使うように変更
・文字コード判定の日本語対応を強化、ただし非日本語圏は劣化
・ファイル情報コマンドのテンプレート(FileInfo.tmp)の読み込み文字コードがSJISになっていたのでUNICODEに変更

●不具合修正
・オプションから本体のexeを探すパスの扱いで未処理の相対パス指定があった不具合の修正
・テキストをサムネイル画像にする際にメモリリークする可能性がある不具合の修正
・リストの「選択状態」のコンテキストメニューの「シェル項目を上に表示する」が、「未選択状態」の設定値を使用していた不具合の修正
・タブバーでの左クリック動作を丸ごと作り直した
・スクリプトのFileOpenMode、BomOutで0がセットできない不具合の修正
・本体起動時に必要な画像が存在しない場合に起動できない不具合の修正



Ver.11.3.7.0

●細かい改善
・リスト未選択のコンテキストメニューで、サイズグラフ、日付の色分けの状態をチェックで表示するようにした
・クリップボードのテキストから開くコマンドで、フォルダを判別して終端の\を補完して開くように変更した
・パスの終端の\を取り除く処理で/も対象にした（パス表記に/が混じっていると/を対象とする）
・終端に\を付ける処理で/も対象にした
・フルパスで520文字を超えるパスをドロップで受け取れるように修正
・タブのD&D構造体サイズを可変長にして省メモリ化
・かなり深いパスの場合に更新通知を拾えない現象を解消

●一時的にカレントディレクトリを切り替える処理を作り直した
・カレントパスの保持を可変長で管理するようにして省メモリ化
・パスが深過ぎるとカレントフォルダが取得できなかったが最大32KB文字に変更
・リスト関連付け実行（フォーカスナビゲーション）に適用
・リスト関連付け実行（選択ナビゲーション）に適用
・リストのコンテキストメニューに適用
・リスト空欄のコンテキストメニューに適用

●ファイル属性変更
・圧縮属性の変更に失敗した場合にシステムメッセージを出すように変更
・暗号化属性の変更に失敗した場合にシステムメッセージを出すように変更

●不具合修正
・選択中のディレクトリをツリーに追加コマンドで、インサイドツリーが更新されない不具合の修正
・フォルダーバーを一度も表示させていない状態だと、オプションで設定変更をしてもインサイドツリーが更新されない不具合の修正
・1040文字を超えるローカルディレクトリの場合、更新通知の受信に失敗する場合がある不具合の修正
・1040文字を超えるディレクトリの場合、タブをD&Dで並び替えたときに不定なパスになる可能性がある不具合の修正



Ver.11.3.3.0

・リスト未選択時のコンテキストメニューのメニュー定義を修正（ショートカットキーの付与、構成の修正等）
・option.exeと本体のオプション画面のIDがずれて設定変更したオプションページの終端イベントが発行されず、画面が更新されなくなっていた不具合の修正



Ver.11.3.2.0

●外部コマンドの改善
・対象ファイルの一覧を持つ画面のアイコン画像の取得の仕組みを作り直して大幅にレスポンス性能を改善した（ファイル一覧を持つ機能全てが対象）

●その他
・アドレスバーの「ダブルクリックした位置の示すパスへジャンプ」は対象を開くではなく、対象をディレクトリとしてジャンプに戻した



Ver.11.3.0.0

●アドレスバーの入力補完の強化
・先頭が\:;でなく、2文字目が:でなく、:/や:\を含まない場合、現在のパスの下位階層とみなした補完を追加
・「.」「..」の相対パス指定の展開を追加
・相対パス指定や環境変数などを展開済みの状態で履歴に保存するように変更（相対パス指定の代償）
・終端に\がつかない場合、対象がディレクトリか否かを判断して\を補完する機能の追加
※フォルダーにフォーカスを当てる動作はできなくなりました
・フォルダーをドロップしたときに終端に\を付与する機能の追加
・http等のパス区切り文字が/の場合の階層パスの検出処理を追加
・候補の補完と候補の列挙を1文字以下なら従来どおり先頭一致、2文字以上は部分一致に変更

●アドレスバー右クリックメニューを追加
・メニュー定義ファイルの_AddressBar.txtを追加
・貼り付けて移動を追加
・元に戻すを追加
・切り取りを追加
・コピーを追加
・貼り付けを追加
・削除を追加
・全て選択を追加
・全て削除を追加
・フルパスをコピーを追加
・終端パスを削除を追加
・選択候補の表示を追加
・履歴候補の表示を追加
・履歴の削除を追加

●アドレスバーのオプション追加
・ダブルクリックで履歴を表示モードを追加
・ダブルクリックで候補を表示モードを追加
・ダブルクリックでクリック位置のパスへ移動するモードを追加
・ダブルクリックでクリック位置のパスの階層メニューを表示するモードを追加
・選択候補にファイル含める設定の追加

●アドレスバーその他
・アドレスバーからタブキーを押下した次のフォーカス遷移先をリスト固定になるように制御を追加

●入力補完コンボボックス(入力補完コンボボックスのある機能全てが対象)
・候補の補完と候補の列挙を1文字以下なら従来どおり先頭一致、2文字以上は部分一致に変更
・アドレスバーと同様に選択候補を5000件に制限した

●クリップボードのテキストから開く
・テキストを前後の空白をトリミングするように変更
・複数行のテキストで、まとめて複数ウィンドウを開く際に数が多いと警告メッセージを表示するように修正

●ダイアログのサイズを変えたときにレイアウトが崩れる不具合の修正
・FileCpMv.exe
・FileExecute.exe
・FileRename.exe
・VersionInfo.exe

●exe,lnk,ico,cur,sln,ani,scr以外のアイコン画像は１回しか読み込まない設定
・圧縮属性がついている場合は、キャッシュを探さないように修正（Windows10の圧縮オーバーレイ対策）



Ver.11.2.1.0

●オプションのフォルダーバーの設定画面の調整
※フォルダーバーの歯車アイコンで設定可能な項目ですが、インサイドツリーと共用なのでこちらにも設けました
・レイアウト変更して表示/操作/連動項目をカテゴリ分けした
・隠しアイテムの表示を追加
・リストのフォルダー移動に連動するを追加
・タブ切り替えに連動するを追加
・リストが仮想フォルダーの場合に連動するを追加
・リストがネットワークの場合に連動するを追加

●その他オプション
・型変換のワーニングが出てたのでキャストした×4
・日付の書式の初期値をyyyy/MM/dd HH:mmに変更
・ユーザー定義バーの並び順で、フォルダー優先しないモードを2種類増やした

●不具合修正
・キー割り当てをファイルに出力で、出力不能なフォルダを指定した場合にエラーにならない不具合の修正
・アドレスバーの選択候補を5000件に制限した



Ver.11.1.7.0

・日付の書式化処理を作り直した
※1600～1900年の表示やミリ秒表示などの機能が追加されたが、置換文字の抜本的な仕様変更のため日付の書式設定は引き継ぎません

●Zip書庫と見なす拡張子の追加（圧縮/展開/圧縮ファイルビューア）
・apk、crx、docx、xlsx、pptx、ipa、ipg、odt、ods、odp、odb、odg、odf、wsz、wmzをzip書庫と認識するように変更
・インストーラーのViewer.txtを更新

●exe,lnk,ico,cur,sln,ani,scr以外のアイコン画像は１回しか読み込まない設定
・丸ごと再構築しなおして、スレッドセーフで速度も十分確保できるように改修
・タイムアウトしたものをキャッシュに積まないように修正
・2次遅延処理をしないように変更
・不正確な状態を検出したらキャッシュを開放して取得しなおす処理を追加
・OSから拡張子との関連付け情報の変更が大量（1000個くらい）に発行された場合に落ちる場合がある不具合の修正
・簡易アイコンの取得モードよりもキャッシュを優先するように変更
・アイコン取得のオプションページで設定を保存した場合にキャッシュを開放するように修正
・長い拡張子は拡張子と見なさないように修正

●その他
・OpenMPのスレッド分割スケジュールを動的に最適化するように変更

●不具合修正
・詳細表示の設定で「取得に時間がかかる項目」の設定が反映に要再起動である不具合の修正
・VersionCheck.exeのダイアログ表示中に負荷が下がらない不具合への回避処理を追加



Ver.11.1.0.0

●フォルダーバー/インサイドツリー
・更新処理等の非同期処理を有効に変更

●ドッキングバーの初期値の変更
・タブレット支援バーの初期位置を下段に変更
・ウィンドウ管理バーの初期位置を右側に変更
・キャプションバーの初期状態を非表示に変更
・タブバーのタイトルバーを非表示に変更

●セキュリティ対策
・ベースアドレスの難読化

●不具合修正
・タブ幅が自動で横置きの場合、フォルダ移動で高さ調整をするように修正
・ペイン切り替えでアクティブになる場合に、フォーカスを見失っていたら強制的にリストにフォーカスを当てるようにした(OS依存で発生)



Ver.11.0.7.0

●タブのデザイン変更と設定の追加
・タブの幅で0を指定可に変更し、0にした場合はテキストの幅に合わせた自動計算モードになる機能の追加
※複数段表示がONで縦置きにした場合は、自動で横幅の調整を行わなくなります
・アクティブタブの輝度を下げる設定の場合、60%→40%に変更
・アクティブタブの輝度を下げる設定を、ウィンドウ管理バーにも反映するように変更
・タブをWindows10を意識したフラットデザインに変更(スキン未適用の場合に適用)

●サムネイル
・フォルダー遷移後に開放できるメモリがあったので、積極的に開放するように変更

●オプションの変更(Option.exe)
・タブの旧デザインが使えるようにオプションを追加（将来は削除予定）
・アクティブタブの輝度を下げる設定を共通へ移動
・アイコン画像取得で、exe,lnk,ico,cur,sln,ani,scr以外のアイコン画像を1回しか読み込まない設定を追加
※例外として、OSが管理しているアイコン画像の更新通知には反応して再度読み込みます

●一括リネームコマンド(FileRenameEx.exe)
・各種の置換系のロジックを、ほぼ丸ごと作り直した
・レイアウト微調整

●不具合修正
・ステータスエリアやタブバーのアイコンのサイズ計算で、大きいアイコンサイズの倍率が適用されない不具合の修正
・オプションで色・フォントを切り替えても、インサイドツリーに即時適用されない不具合の修正
・オプションでリスト再構築が必要な場合に表示が消える場合がある不具合の修正

●その他
・MD2～MD5,SHA1～SHA512、CRC32を計算する関数を追加



Ver.11.0.2.0

●一括で名前の変更コマンド(FileRenameEx.exe)
・検索/置換テキストを、それぞれ3つに増やした
・ファイル名生成処理の順番を入れ替え、検索/置換を先頭で行うように変更

●サムネイル
・画像を1個ずつ生成していたのを、まとめて100個ずつ生成するようにして高速化
・サムネイル⇔アイコン表示の切替でメモリを開放していなかった不具合の修正(タブを閉じると解放される)

●その他
・小分けになっていたフィルタの判定処理をまとめた



Ver.11.0.0.0

●アンドゥ/リドゥ改善
・確認メッセージを表示している場合、メッセージ内にどのような操作を行うか補助テキストを追加

●スマートペースト機能の追加
・テキストや画像のデータを貼り付けた場合、そのテキストのファイルやPNGファイルを生成する機能を追加
・オプションにスマートペースト機能を無効にする設定を追加
・設定可能な確認メッセージを追加

●「ユーザー」ディレクトリの扱いの変更
・ユーザーディレクトリの場合、リダイレクトして一般のディレクトリとして扱うように変更
※デスクトップからユーザーフォルダーに潜った場合も、上位階層への移動先はデスクトップではなくC:\Usersになります
※パス表記が「ユーザー名」から「ユーザーID」の実体表記になります

●インサイドツリーを追加（リストと1対1で紐づくフォルダーバー）
・メインメニューに表示切替コマンドを追加
・メニュー定義にたくさん追加
・リスト上に表示切替ボタンを配置した
・オプションのリストの初期表示にインサイドツリーの表示設定を追加
・表示モード設定でインサイドツリーの表示の指定を追加

●サムネイル表示用の画像の一本化
・Ctrl＋ホイール、アイコンサイズを大きく/小さくコマンドで、サムネイルの画像サイズを16～400ピクセルの任意のサイズに変更できるようにした
・各タブごとにサムネイル画像サイズを保持できるようにした
・オプションにサムネイル画像の原版サイズの設定を追加
・「縮小版」が「縮小画像」混在していたので「サムネイル」に統一した（リソース、メニュー定義ファイル等）
・表示モードのメニュー定義ファイルを抜本的に見直した
・アイコンを小さく/大きくコマンドをメインフレームから子ウィンドウに変更してメニュー定義からアクセスできるように変更
・アイコンを小さく/大きくコマンドのホイールの回転方向をエクスプローラーに合わせて逆にした
・サムネイルのテキストは原画サイズを256に固定して表示サイズの部分のみを切り取って表示するようにした(表示サイズの方が大き場合は拡大)

●ローカルサムネイルキャッシュ作成コマンド(CreateLocalTumb.exe)
・大/中/小サイズの指定を削除
・サブフォルダを対象にする動作モードの追加
・不要になったローカルサムネイルキャッシュの自動削除モードの追加

●バージョン情報(VersionInfo.exe)
・CPUのファミリーネームを表示を追加
・SIMD拡張命令のサポート状況を追加

●epubファイル対応(ArcUnPack.exe,MArc.exe)
※拡張子の関連付けは相応しくないので書庫閲覧と解凍機能のみの対応
・展開コマンドでZipファイルとして認識させるように追加
・圧縮ファイルビューアでの閲覧対象に追加
・配布用のViewer.txtの圧縮ファイルビューアの対象拡張子にepub,nar,xpi(7z系)、ar,xz(tar系)を追加

●セキュリティ対策
・ファイルにドロップでフォルダ作成モードの場合に生成するフォルダ名を決定するロジックを修正
・外部からスクリプトの実行を指示された時に表示する確認メッセージを追加

●追加コマンド
・テキストの中身をコピーするコマンドを追加（複数選択している場合は先頭のファイルのみ対象）
・画面の分割方向を変えるコマンドをメインメニューに追加
・ドッキングウィンドウを全て閉じる/復元コマンドを追加
・.で始まるアイテムの表示を切り替えるコマンドを追加
・ローカルサムネイルキャッシュファイルの表示を切り替えるコマンドを追加
　(SAMBA採用のNAS等の隠し属性が付与できない環境用で、名称の先頭4文字が「~asr」であるかで判断する)
・ユーザー定義バーに「開く」コマンドを追加（標準動作という扱いの「開く」でマウスクリックと等価）
・メインメニューの編集に「やり直し」を追加

●その他
・カスタマイズ/機能一覧の「初期メニューに無いコマンド」を解体して、再構成しなおした
・機能一覧画面のレイアウトを微調整
・ツールバーに置けるスクリプトコマンドを20→50個に増やした
・共有コマンドを編集→ツールへ移動
・フォルダーのカスタマイズコマンドをファイル→ツールへ移動
・誤字修正多数
・AVX2使用版の追加

●不具合修正
・並べて表示で、アイコン小のときにレイアウトが崩れる不具合を修正
・ユーザー用のコマンドディレクトリに、いつの間にかコマンドラインのテストコマンドが混じっていたので削除
（検証のためにコマンドライン引数をポップアップ表示するコマンドです）
・Asrload.exeに/searchスイッチを追加



///////////////////////////////////////////////////////////////////////////////////
// Ver.10.x系
///////////////////////////////////////////////////////////////////////////////////

Ver.10.6.9.0

・誤字の修正
・回りくどい説明表記を修正



Ver.10.6.8.0

・悪意を込めたファイル名をスクリプトに渡した場合に想定外の動作をする可能性がある不具合の修正



Ver.10.6.7.0

・各種のヘルプ等のURLをすべてHTTPSに変更



Ver.10.6.6.0

●不具合修正
・チェックボックスが非表示の状態で、チェックを付与できる場合がある不具合を修正した
・スコープが間違っていて外部コマンドがビルドできない状態になっていたのを修正

●インサイドツリー（仮名）
・スプリッタを動かして初期幅を覚えるようにした
・新しく開いた時に表示できる仕組みを追加



Ver.10.6.5.0

●フォルダーバーの部品化
・サブクラス用プロシージャを整理
・スタティックのデフォルトプロシージャの管理方法を修正

●タブ内のコントロール制御を拡張
・リストのサイズ制御で冗長な箇所があったのでまとめた
・スプリッタ制御を追加
・インサイドツリーの表示切替コマンドを追加(ID:33359、プロトタイプ実装につき低機能)

●スクリプト
・SetClipboardTextコマンド追加
指定されたテキストをクリップボードにコピーする
【書式】
SetClipboardText=文字列
【例】
クリップボードのテキストをSQLと見なして整形してくれるツール「SQLFix」の前処理として、\t,\r,\nを半角スペースに置換してクリップボードにセットしなおすサンプル
※「SQLFix」はnagavさんが公開されているソフトです。(http://hp.vector.co.jp/authors/VA033418/)
var $text$ = GetClipboardText
var $a$
$text$ = Replace,\t, ,$text$
$text$ = Replace,\r, ,$text$
$text$ = Replace,\n, ,$text$
SetClipboardText=$text$
CommandlineOption=
OpenMode=0
MultiCommandMode=0
ShiftSilentMode=0
BootDir=1
BootMode=0
Run=（インストール先のフルパス）\SQLFix.exe



Ver.10.6.4.0

●タブバー
・ドライブアイコンを使用する場合に、ドライブレターの描画に影をつけて見やすくした
・アクティブタブのテキストに影をつけて視認性を向上

●サムネイル時のオーバーレイアイコン
・サイズを見て余裕があれば大きい画像を使用するように変更
・描画の分岐ロジックを見直した

●ハードウェアの安全な取り外しコマンドを配布書庫に追加(RmHardware.exe)
※マイナーアップデート時にはメニューやキー割り当ての一覧には追加しないのでexeを直接起動してください

●オプション(Option.exe)
・機能一覧画面に説明テキストの表示を追加

●フォルダーバーの部品化
・リネーム、アンドゥ、更新、次のウィンドウコマンドをフォルダーバーからツリーコンポーネントへ移動
・WM_TIMER、WM_SYSKEYDOWN、WM_KEYDOWNのメッセージイベントをフォルダーバーからツリーコンポーネントへ移動
・更新の描画速度を改善
・あちこち処理効率が悪い状態になっていたので全体的に見直した
※タブ内に置いてみたが、全部のツリーの動作が遅くなって使い物にならない

●その他
・Office2007(黒)のテーマ適用時の配色を調整した
・ナビゲートロックされている場合「画面分割」「パスを入れ替え」「アクティブパスに揃える」は動作しないように変更
・画面分割されていない場合「パスを入れ替え」「アクティブパスに揃える」は動作しないように変更
・画面分割コマンドは同期処理を行うようにして、ビジーの場合にはコンポーネントに自殺を命じてリトライしないように変更
・画面分割方向を一時的に変えるコマンドを追加(ID:48103)
※ナビゲートロックされている場合は動作しませんし、非分割状態では画面の変化はありません

●不具合修正
・「タブ切り替えと連動」がOFFでも切り替えていた不具合の修正
・大量にファイルを選択してスクリプト実行を行った場合の警告表示で「今後このメッセージを表示しない」が押せない不具合の修正



Ver.10.6.0.0

●フォルダーバーの部品化
・コンポーネント内のメッセージクラッカーを追加
・コピー、切り取り、張り付け、プロパティ表示機能をフォルダーバーからツリーコンポーネントへ移動
・フォルダーバー内で使用している関数を統合して数を減らした

●不具合修正
・サムネイル表示時に画像を持っていないアイテムをリネームすると異なる画像が表示される不具合の修正
・アイコンなしモードの場合にも描画を試みていた不具合の修正
・オーバーレイアイコンのインデックスをchar→shortに戻した
・すでに分割されたタブが存在する場合に画面分割方向の設定を変えると、ビューを参照したタイミングで落ちる不具合の修正
　（次回の分割から適用→新しく開いたタブから適用に変更）
・複製の作成コマンドで連番の数字が不適切な値になることがある不具合を修正



Ver.10.5.8.0

●縮小版の描画
・拡縮描画の速度を改善
・縮小画像を持たないアイテムや画像取得しないアイテムの画像生成をやめ、アイコン番号を取得してシェルイメージリストを用いて描画するように変更
※省メモリ化と高速化のメリットがあるが、デメリットとして画像以外の表示サイズが最大で48×48になる
・アイコン（画像なし）、テキスト（拡縮小なし、ピープホール）、画像（拡縮小あり）の分岐の仕組みを実装
・ローカルサムネイルでサムネイル画像フラグをセットするように変更
・ローカルサムネイルび新しい書式の辞書ファイルの読み込みを追加（性能検証用）

●ローカルサムネイルキャッシュ作成コマンド
※アイコン交じりのフォルダなら差異は出ますが、表示の変化が気にならないなら再生成する必要はありません
・縮小画像を持たないファイルは出力しないようにした
・メモリリークしていたのを修正
・画像生成の無駄を省いて生成速度を向上
・ファイルがロックされていてサムネイル生成に失敗した場合、インデックスの番号がずれる不具合の修正
・内蔵のテキスト展開エンジンによって画像を生成する仕組みを追加(性能検証用)

●その他
・アイコンの上にチェックボックスを重ね描画する場合のフラグセット処理を改善
・MDIモードでウィンドウを最大化すると、最小化していたタブのチラつきが発生していた現象を抑制した
※タイトルバーの最大化ボタンを押した場合はシステムに制御が渡っているので未対処です



Ver.10.5.4.0

●ローカルサムネイルキャッシュがあるディレクトリの場合の不具合修正
・画像フラグがセットされていなくて表示できない不具合を修正
・ダミーのイメージリストではなく、実体のイメージリストを紐づけていた不具合の修正



Ver.10.5.3.0

●CImageListを拡張して拡大縮小できるようにした
・サイズ/時刻比較のオーバーレイアイコン表示に適用
・サムネイル画像の表示に適用
・縮小画像表示時のドラッグヘルパーも拡大縮小に適用

●不具合修正
・選択アイテムと同じ拡張子を選択コマンドが正しく動作していなかった不具合の修正
・フォルダサイズ計算のプログレス表示が不正になるパターンがあった不具合の修正

●内部データ構造の変更
・選択アイテムを走査する処理の一部をMFCからSTLのコンテナに置き換えた
・走査の際の縮小画像の初期化が冗長になっていたのを整理
・オーバーレイアイコンのインデックスをshort→charに変更してファイル1個当たり1バイト節約
・自前で生成した縮小画像か否か、テキストの縮小画像か否かのフラグを追加（既存フラグの空きビットを使用）
・縮小画像のイメージリストと、リストに紐付けるイメージリストを分離した



Ver.10.4.7.0

●AsrLoad.exe
・終端の\記号がメタ文字のエスケープとして扱われるので「"」は全て除去するように変更

●その他
・aniのアイコンの取得速度を向上
・個別のアイコン画像の取得順を、存在確率に合わせた順番に変更して速度を向上
・拡張子/アイコンのインデックスにANIを追加
・x86版のコンパイラオプションをサイズ優先から速度優先に変更



Ver.10.4.6.0

●詳細一覧の改修
・表示速度の改善
・仮想オブジェクトは日付欄に[System]と表示するように変更
・マイコンピュータの場合、サイズ欄に空き容量とサイズグラフを表示するように変更

●その他
・ダークモードにあわせて、Offce2007(黒)の補完色の輝度を下げた
・Windows10に合わないのでタブバーの背景のグラデーションをやめた
・今時256色環境なんてないので、アプリケーションアイコンに24bit色のアイコン画像を追加
・外部コマンドの実行後の後処理の動作を改善
・CUR,SCR,LNKのアイコンの取得速度を向上

●不具合修正
・Windows10でOSがダークモードになっていると、フォルダーバーのスクロールバーなどが黒くなるので、強制的にクラッシクスタイルを適用するように変更
・共通のフォルダ指定ダイアログのメッセージが文字化けしている不具合の修正

●ICO,EXE,CUR,SCR,LNK以外の拡張子/アイコンのインデックスを作成して、アイコンインデックスをオンメモリで求める仕組みを実装
※ディスクアクセスが減少して表示性能が大幅に向上しますが、仕様満足度の確認のため当面は隠し機能
[HKEY_CURRENT_USER\Software\AMA_Soft\ASR\Main001\ListDraw]
"UseCache_IconIdx"=dword:00000001（デフォルトは0でOFF）



Ver.10.4.3.0

●ソート順を管理する処理の作り直し
・仮想フォルダーのソート種別を覚えるようになった
・仮想フォルダーの昇降順を覚えるようになった
※仮想フォルダーは、ごみ箱、マイコンピュータ、ユーザーディレクトリ、その他の4種類に分類します

●リスト描画
・マイコンピュータで詳細モードで空き容量に使用割合のサイズグラフ(使用率の百分率)を表示するようにした
・マイコンピュータでコンテンツモードで2行以上の場合に使用割合のサイズグラフを表示するようにした
・コンテンツモードで2行以上の場合のレイアウトを調整
・サイズグラフのグラデーションの色を背景色から、格子色に固定した

●仕様変更
・本体の機能を使ってディレクトリを作成する際に、フルパスで255文字以上のパスは作れないように変更した
※外部のソフトやウィルススキャンソフトが問題を起こすことが多いため

●その他
・スクリプトの大小比較のif文の数字か否かの判定処理を厳密なものに修正
※先頭のみ＋/-の符号を許可、半角数字のみ数値と見なすようにした

●不具合修正
・同一グループ内に同じパスのタブが存在していたら閉じるがONで、ナビゲートロックかかった状態で更新して閉じようとする不具合を修正
・表示モード設定で全てのタブを対象にした場合、仮想フォルダのタブも変更してしまいソート順が不定(名前順の扱い)になる不具合の修正



Ver.10.3.9.0

●テキスト文字コード変換コマンド(ChgTxtFmt.exe)
・レイアウトを調整
・文字コード判別は日本語を最優先で判定するように変更
※日本語SJIS/EUC/UTF8の検出精度は向上したが、かなり遅いので他への適用は保留

●表示のON/OFFが切り替えられるメッセージ
・メッセージボックスからTaskDialogに変更
・全てのメッセージを対象に画面内から非表示に設定できるようにした
・オプションの場所を示すメッセージ定義を「今後このメッセージを表示しない」に変更した(流用)

●高DPI環境対応
・本体のダイアログのレイアウトを大量に調整
・オプションのレイアウトを大量に調整

●その他
・タブバーで「同一グループに同じパスのタブが存在していたら閉じる」がONの場合に「ここから開く」が全く機能しないので初回ナビゲーションは無視するように変更した
・オプションのバージョンチェックの画面にプライバシーポリシーに関する文言を追記

●スクリプト
・if文の大小比較で、両辺とも半角数字のみであれば数値として比較をするように変更した
※数字とみなす判定方法は暫定仕様です

●不具合修正
・MDIモードの場合、画面分割直後の幅調整が効かない不具合の修正
・分割モードで「更新コマンド実行時は両方を対象にする」がONの場合にアドレスバーの更新ボタンには適用されないのを修正
・スクリプトのGetTabIndexで分割しているタブのパスの両方をカウントしていた不具合の修正



Ver.10.3.0.0

●プレビューバー
・IStreamのインターフェイスがあって初期化でエラーになるファイルの場合に落ちる不具合の修正
・内部テキストエンジンでUTF16(BE)を表示できるようにした
・UTF16(LE)の場合の描画改善
・文字コード判別/変換で検出精度の向上が効いていなかったのを修正（気休め程度）

●縮小版
・内部テキストエンジンでUTF16(BE)を表示できるようにした
・UTF16(LE)の場合の描画改善
・文字コード判別/変換で検出精度の向上が効いていなかったのを修正（気休め程度）

●画面分割モードのサイズ/日付比較の描画
・サイズの大小、日付の新旧のオーバーレイアイコンをアイコンサイズとスケーリングに合わせて拡大描画するようにした



Ver.10.2.8.0

●オプション
・フィルタ/ディレクトリ内検索/タグ検索の絞り込みテキストで、AND/OR/NOTが使用できる拡張構文を使用する設定を追加

●高DPI環境向けの対応
・高DPI対応アプリケーションとしての宣言を追加
・アイコンサイズ小～大の描画サイズをスケーリング補正するように修正
・シェルのオーバーレイアイコンの座標をスケーリング補正するように修正
・アイコン、アイコンのみ、並べて表示の描画をスケーリング補正するように修正
・テキスト幅の自動調整の計算式をスケーリング補正するように修正

●バージョン情報(VersionInfo.exe)
・高DPI対応アプリケーションとしての宣言を追加
・サポート連絡用の必須情報にDPI、スクリーンサイズを追加
・今まで使ったことがないので全情報のコピーボタンを削除
・メインメニューにあるので最新バージョンの確認機能を削除

●終了時スクリプト
・前回のタブ情報を展開する処理の省メモリ化と、若干の高速化
・終了時アクティブの情報の保存処理を追加
・アクティブタブの指定の復元動作を追加
※アクティブになるまで走査しないオプションがONでもフレームワークが作る1タブ目は走査してしまうので改善の余地有り

●タグ入力ダイアログ
・タグ入力ダイアログのタブオーダーを修正
・タグ入力ダイアログのレイアウトを微調整
・新規作成時の色は、前回保存時の値を使用するように変更
・選択数と処理番号を表示するように変更
・「以降の全てに適用する」はキャンセルボタンも対象にするように変更（メインフレーム）
・「以降の全てに適用する」はキャンセルボタンも対象にするように変更（タブ情報）

●アップデートツール
・各種定義ファイルの上書き確認のファイル参照を、エディットボックス2個からリストビューで並べて表示するように変更
・差分のある行を色塗りするようにした

●スクリプト
・FileAllRead/FileReadで読み込んだテキストデータを変数を展開しないで格納するように変更
※変数の利用時に展開するので動作は変わらない認識です
・クリップボードのテキストを取得するGetClipboardTextコマンドを追加

●その他
・FindFirstChangeNotification系の自動更新通知(現在は未使用)の停止レスポンスを向上

●不具合修正
・自動更新を監視しているフォルダーを外部から消された場合にCPU使用率が上がる不具合を修正



Ver.10.2.0.0

●スクリプト仕様の追加と変更
・if文の論理式の評価を関数化した
・do/while/continue/breakによる繰り返し構文を追加
・varコマンドで配列の宣言の仕様を追加
・varコマンドで連想配列の宣言の仕様を追加
・変数の置換を再帰展開するように変更（最大10回）
・for/next、do/whileのループ外で、continue,breakが出現したらエラーになるように変更

●タグ入力ダイアログ
・タグ入力ダイアログをサイズ可変に変更
・対象ファイルの表示をディスエブルからReadOnlyに変更
・対象ファイルの表示を複数行表示に変更（ダイアログサイズを変更すると自動調整する）

●テキスト文字コード変換コマンド
・複数選択可能にし、一括でコード訂正できるようにした
・全て選択ボタンを追加
・改行コードの変更は文字種によって信頼性が低下するので封印した
・文字コード検出の優先コードページをSJISからシステムのデフォルトコードページに変更
・テキスト文字コード変換の検証として、As/R本体のソースコードを全てUNICODEに変換した

●文字コード判別エンジン
・OSのエンジンが頻繁に間違えるので、前処理でUTF8/16/32のBOM判定をするようにした
※本体プレビュー/サムネイル、テキスト文字コード変換コマンド、テキストビューアに影響

●不具合修正
・設定でツールバーアイコンのサイズを大きくした場合、リスト下部のボタン幅とエリア高さの計算が不正になる不具合の修正



Ver.10.1.3.0

●不具合修正
・ウィンドウ管理バーのツールバーから表示させたメニューのチェック項目が、タブバーの状態をになっていた不具合の修正
・次のウィンドウ(Zオーダー順)と、前のウィンドウ(Zオーダー順)が逆になっているのを修正
※IDはそのままで、機能名と説明を入れ替えた
・最大化状態で起動した場合、ボタンサイズの計算前にタブバーが描画されていたのを修正
・一部のリストの画面遷移で無条件で監視スレッドを止めていた不具合の修正

●外的要因の不具合への対処
・特定の拡張子のみ簡易アイコンモードにする設定を追加
・マイコンピュータの自動更新を動作させない設定を追加
・ごみ箱の自動更新を動作させない設定を追加

●仮想フォルダーの自動更新の仕様変更
・マイコンピュータ
　ネットワークドライブが存在し、ドメインのネームサーバーが不安定な場合に断続的に全更新の通知が発生することがあるので無視するようにした
・ごみ箱
　OSに対して不適切な通知を行い続けるソフトがインストールされている環境対策として、全更新の通知を無視するようにした

●その他
・タブバーのツールバー制御だけ他のバーと異なっていたのを修正、また非表示設定の場合にサイズ0にしていたので非表示に変更した



Ver.10.1.0.0

●高解像度ディスプレイ対応の強化と描画の最適化
※従来のタブ数は160～170個で1プロセスあたりのGDIリソースの上限に達するため、GDI上限の95%に達すると安全装置としてエラーを出していた
　今回の実装で1タブあたりの使用GDIハンドルの数を減らした(43→11)
　また高解像度ディスプレイ対応の一環として、フォントサイズが12ポイント以上の場合にサイズ拡大も実装したので2D描画が弱い環境だと若干描画がもたつく
・タブバーとリストにある、全てのボタンをオーナードローに変更
・ホバー状態をコールバックで通知する仕組みを追加
・「ボタン押下」を自前で描画して、全てのボタンの「ボタン押下画像」を使わないように変更した
・ボタンサイズから計算して、ボタンがに対して画像が小さすぎる場合は拡大するようにした
　（デフォルトの画像サイズが16×16、12ポイントのフォント指定でボタンサイズが28×28となり差が12pixを超えると拡大する）
・どうやっても1プロセスあたりのGDIリソースの上限値に達しなくなったのでエラー判定を削除した
・MDIの限界数を超えた場合にフレームワーク内でリソースリークや、各種スレッドの起動失敗が多発するようになるので、余裕をもってタブ数が200個を超えたらエラーになるようにした
・GDIの上限に達したエラーメッセージを、タブ数の上限に達した旨へと変更した
・「進む」/「戻る」/「上へ」の長押しできるボタンの描画を調整
・デザイン的に浮いていた並び順のボタンを自前で描画に変更

●その他
・監視スレッドの内部エラーで終了する際に、監視モード切替ボタンの画像を変更する処理を追加
・ボタン画像の切替が速くなったので、監視モードのボタンをリアルタイムで切り替えるように変更
・アドレスバーの手入力で/を\に置き換える処理を追加(ftp://、http://、https://、:、;で始まるフォルダは除外)
・フォントのDPI計算で生成フォントは使い捨てにして丸め誤差が出ないようにした
・タブに画像を貼れることを周知するため、配布書庫にスキンサンプルを同梱するようにした

●オプション（キー割り当て）
・IDの手入力欄を追加
・手入力欄から検索する機能を追加
・逆引き用に全機能一覧のヘルプページを開くボタンを追加

●タグ
・フォルダーにタグを付けた場合、タブバーとウィンドウ管理バーにタグ色のラベルを描画するようにした

●MDIモード
・ウィンドウを極端に小さくした時にフォームビューのスクロールバーが表示されないようにした
・新規で開いた時のウィンドウサイズをメインウィンドウのサイズ依存となるように変更した

●文言修正
・各表示モードの説明テキストを修正した

●プレビューバー
・選択が外れた場合に表示を消すように変更

●不具合修正
・設定とマウス座標の組み合わせによって、埋め込みリネームが発動する可能性がある不具合の修正
・プレビューハンドラの成否判定の結果の値が不正で、組み込みのテキストプレビューができなくなっていた不具合の修正
・上位階層へ移動がナビゲートロックで阻害された場合も走査スレッドの停止を試みていたのをやめた

●プレビューバーの試験実装
　環境によってOfficeドキュメントも閲覧できる内蔵ビューアとしての活用法の検証です。

・プレビューバーの表示のトリガーの設定
[HKEY_CURRENT_USER\Software\AMA_Soft\ASR\Main001\PreView]
"EventType"=dword:00000000
0：リスト上での選択で表示
1：マウスオーバーで表示（予約）
2：スクリプト(ExRun=PreviewBar)やコマンド(ID:33321)で表示

※トリガー2かつ、プレビューバーが表示されていないと動作しません
・プレビューバーで閲覧コマンドを追加(ID:33321)、キー割り当て可にした
・スクリプトのExRunコマンドで「PreviewBar」が指定してあると、拡張子判別でプレビューバーで表示する機能を追加
例)
Filter=html,cshtml,mp4,vbs,sql,pdf,xlsx,docx
ExRun=PreviewBar



Ver.10.0.0.0

●メインメニューに追加
・タグを付けるコマンドを追加
・タグを削除コマンドを追加
・タグ情報コマンドを追加
・リンク切れタグの削除コマンドを追加
・最新バージョンの確認を追加

●オプションの再配置と新しい設定項目の追加
○リスト→動作
・散らばっていたナビゲートロックの動作をまとめた
　バー→タブ共通→「ロック時にナビゲート依頼が来ると、新しく開く」をこちらに移動
※「ナビゲートロック状態で新たにナビゲート依頼があると「新しいタブで開く」」に文言と初期値を変更
・「起動時にタグを読み込む」を削除

○リスト→マウスを、選択クリック/空欄クリック/ホイールに3分割
・リスト→マウス、「空き領域を左クリックして実行するスクリプト」を移動
・リスト→マウス、「空き領域を左ダブルクリックして実行するスクリプト」を移動
・空き領域を中クリックして実行するスクリプトを追加
・空き領域を中ダブルクリックして実行するスクリプトを追加
・隠し機能だったホイール関連の設定を画面から設定できるようにした

○リスト→分割（新規追加）
